VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CPicture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Error Codes
Private Const errInvalidPropertyValue = 380

'System Color Constants
Private Const COLOR_BTNFACE = 15
Private Const COLOR_BTNHIGHLIGHT = 20
Private Const COLOR_BTNSHADOW = 16

'BitBlt OpCodes
Private Const SRCAND = &H8800C6
Private Const SRCCOPY = &HCC0020
Private Const SRCINVERT = &H660046

Private Type BITMAP
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

' APIs
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetObj Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long

'Internal Storage Variables
'Private hdcSource As Long
'*&*Private m_bmpSource As StdPicture
Private m_hbmpSource As Long
Private m_hdcMask As Long
Private m_hbmpOldMask As Long
Private m_hbmpMask As Long
Private m_hdcGrey As Long
Private m_hbmpOldGrey As Long
Private m_hbmpGrey As Long
Private m_hdcDestination As Long

Private m_lMaskColor As Long
Private m_fWidth As Single
Private m_fHeight As Single

Public Property Get DestinationDC() As Long
    DestinationDC = m_hdcDestination
End Property

Public Property Let DestinationDC(ByVal NewValue As Long)
    m_hdcDestination = NewValue
    InitPicture
End Property

Public Property Let MaskColor(lMaskColor As OLE_COLOR)
    m_lMaskColor = lMaskColor
End Property

Public Property Get MaskColor() As OLE_COLOR
    MaskColor = m_lMaskColor
    InitPicture
End Property

Public Property Get hdcSource() As Long
    hdcSource = hdcSource
End Property

Public Property Let hdcSource(ByVal NewValue As Long)
    m_hbmpSource = NewValue
    InitPicture
End Property


Friend Sub InitPicture()
'   ******************************************************************
'   * Params : None
'   * Purpose: This routine is called when picture is intialized
'   *          to create the picture's Mask and Grey state pictures
'   ******************************************************************

    Dim cPixel As Long
    Dim x As Long
    Dim y As Long
    Dim lRet As Long
    Dim lColor_BtnFace As OLE_COLOR
    Dim lColor_BtnHighLight As OLE_COLOR
    Dim lColor_BtnShadow As OLE_COLOR
    Dim tbmp As BITMAP
    Dim hdcSource As Long
    Dim hbmpOldSource  As Long
    
    If m_hbmpSource = 0 Or m_hdcDestination = 0 Then
        Exit Sub
    End If
    
    'Get System Colors
    lColor_BtnFace = GetSysColor(COLOR_BTNFACE)
    lColor_BtnHighLight = GetSysColor(COLOR_BTNHIGHLIGHT)
    lColor_BtnShadow = GetSysColor(COLOR_BTNSHADOW)
    
    hdcSource = CreateCompatibleDC(m_hdcDestination)
    hbmpOldSource = SelectObject(hdcSource, m_hbmpSource)
    GetObj m_hbmpSource, Len(tbmp), tbmp
    
    m_fWidth = tbmp.bmWidth
    m_fHeight = tbmp.bmHeight
    
    'Initialize Mask bitmap
    If m_hdcMask <> 0 Then
        SelectObject m_hdcMask, m_hbmpOldMask
        DeleteObject m_hbmpOldMask
        DeleteDC m_hdcMask
    End If
    m_hdcMask = CreateCompatibleDC(m_hdcDestination)     'Create DC to hold stage
    ' create a mono bitmap
    m_hbmpMask = CreateBitmap(m_fWidth, m_fHeight, 1, 1, Null)
    ' select the new mono bitmap
    m_hbmpOldMask = SelectObject(m_hdcMask, m_hbmpMask)
    
    'Initialize Grey bitmap
    If m_hdcGrey <> 0 Then
        SelectObject m_hdcGrey, m_hbmpOldGrey
        DeleteObject m_hbmpOldGrey
        DeleteDC m_hdcGrey
    End If
    m_hdcGrey = CreateCompatibleDC(hdcSource)
    m_hbmpGrey = CreateCompatibleBitmap(m_hdcDestination, m_fWidth, m_fHeight)
    m_hbmpOldGrey = SelectObject(m_hdcGrey, m_hbmpGrey)
    
    BitBlt m_hdcGrey, 0, 0, m_fWidth, m_fHeight, hdcSource, 0, 0, SRCCOPY
    
    'Create Mask and Grey bitmaps
    For x = 0 To m_fWidth - 1
        For y = 0 To m_fHeight - 1
            cPixel = GetPixel(hdcSource, x, y) ' get the rgb color value
            Select Case cPixel
                Case m_lMaskColor:
                    lRet = SetPixel(m_hdcMask, x, y, vbWhite)
                Case vbWhite:
                    lRet = SetPixel(m_hdcMask, x, y, vbBlack)
                    lRet = SetPixel(m_hdcGrey, x, y, lColor_BtnFace)
                Case &HC0C0C0: ' gray
                    lRet = SetPixel(m_hdcMask, x, y, vbBlack)
                    lRet = SetPixel(m_hdcGrey, x, y, lColor_BtnHighLight)
                Case Else
                    lRet = SetPixel(m_hdcMask, x, y, vbBlack)
                    lRet = SetPixel(m_hdcGrey, x, y, lColor_BtnShadow)
            End Select
        Next y
    Next x
    SelectObject hdcSource, hbmpOldSource
    DeleteObject hbmpOldSource
    DeleteDC hdcSource
End Sub

Public Sub MaskBlt(ByVal DestX As Integer, ByVal DestY As Integer, Optional Transparent As Variant, Optional GrayOut As Variant)
'   ******************************************************************
'   * Params : DestX        The X coordinate on the destination where the blit will go
'   *          DestY        The Y coordinate on the destination where the blit will go
'   *          Transparent  A flag which deterimnes whether the portion of the bitmap where
'   *                       the MaskColor exists will be transparent when drawn
'   *          GrayOut      A flag which deterimnes whether the bitmap will be drawn greyed
'   * Purpose: This routine draws the bitmap onto the destination device
'   ******************************************************************
    
    Dim cOldBk As Long, cOldFore As Long, cOldBkSrc As Long
    Dim hdcSource As Long
    Dim hbmpOldSource As Long
    
    'Check optional parameters
    If IsMissing(Transparent) Then
        Transparent = False
    Else
        If TypeName(Transparent) <> "Boolean" Then
            Error errInvalidPropertyValue
        End If
    End If
    
    hdcSource = CreateCompatibleDC(m_hdcDestination)
    hbmpOldSource = SelectObject(hdcSource, m_hbmpSource)
    
    If IsMissing(GrayOut) Then
        GrayOut = False
    Else
        If TypeName(GrayOut) <> "Boolean" Then
            Error errInvalidPropertyValue
        End If
    End If
    
    ' now do it!
    If Transparent Then
        cOldBk = SetBkColor(m_hdcDestination, RGB(255, 255, 255))
        cOldFore = SetTextColor(m_hdcDestination, RGB(0, 0, 0))
        If GrayOut Then
            BitBlt m_hdcDestination, DestX, DestY, m_fWidth, m_fHeight, m_hdcGrey, 0, 0, SRCINVERT
            BitBlt m_hdcDestination, DestX, DestY, m_fWidth, m_fHeight, m_hdcMask, 0, 0, SRCAND
            BitBlt m_hdcDestination, DestX, DestY, m_fWidth, m_fHeight, m_hdcGrey, 0, 0, SRCINVERT
        Else
            BitBlt m_hdcDestination, DestX, DestY, m_fWidth, m_fHeight, hdcSource, 0, 0, SRCINVERT
            BitBlt m_hdcDestination, DestX, DestY, m_fWidth, m_fHeight, m_hdcMask, 0, 0, SRCAND
            BitBlt m_hdcDestination, DestX, DestY, m_fWidth, m_fHeight, hdcSource, 0, 0, SRCINVERT
        End If
        SetBkColor m_hdcDestination, cOldBk
        SetTextColor m_hdcDestination, cOldFore
    Else
        If GrayOut Then
            BitBlt m_hdcDestination, DestX, DestY, m_fWidth, m_fHeight, m_hdcGrey, 0, 0, SRCCOPY
        Else
            BitBlt m_hdcDestination, DestX, DestY, m_fWidth, m_fHeight, hdcSource, 0, 0, SRCCOPY
        End If
    End If
    SelectObject hdcSource, hbmpOldSource
    DeleteObject hbmpOldSource
    DeleteDC hdcSource
End Sub

Private Sub Class_Terminate()
    'Select orig objects
    SelectObject m_hdcMask, m_hbmpOldMask
    SelectObject m_hdcGrey, m_hbmpOldGrey
    
    'Deallocate system resources.
    DeleteObject m_hbmpOldMask
    DeleteObject m_hbmpOldGrey
    
    'Remove hDCs
    DeleteDC hdcSource
    DeleteDC m_hdcMask
    DeleteDC m_hdcGrey
End Sub

