VERSION 5.00
Begin VB.UserControl GTCheckFrame 
   ClientHeight    =   1365
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2025
   ControlContainer=   -1  'True
   PropertyPages   =   "GTCheckFrame.ctx":0000
   ScaleHeight     =   91
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   135
   ToolboxBitmap   =   "GTCheckFrame.ctx":0030
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   30
      Left            =   870
      Top             =   90
   End
End
Attribute VB_Name = "GTCheckFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

'   ***** OLEDrop constants
Public Enum GTOLEDropConstants
    gtOLEDropNone
    gtOLEDropManual
End Enum
'   *****

'CheckFrame Constants
Private Const CheckBoxLeftMargin = 9
Private Const CaptionLeftMargin = 9
Private Const CheckBoxCaptionSpacer = 5
Private Const CaptionExcludeSpacer = 2

'DrawEdge Constants
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_RAISEDINNER = &H4
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)

Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8
Private Const BF_RECT = BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM

Private Const BF_MONO = &H8000 'DrawEdge Const for flat Appearance

'DrawText Constants
Private Const DT_NOCLIP = &H100
Private Const DT_SINGLELINE = &H20
Private Const DT_LEFT = &H0

'Internal Constants for Draw routine
Private Const gtDrawFrame = 1
Private Const gtDrawFocusRect = 2
Private Const gtDrawCheckBox = 4
Private Const gtDrawCaption = 8
Private Const gtDrawAll = gtDrawCheckBox Or gtDrawCaption Or gtDrawFocusRect Or gtDrawFrame
Private Const gtDrawMouseDown = 16

'The enumerations used in the Property window on VB
Public Enum GTCheckFrameAlignmentConstants
    gtLeftJustify = 0
    gtRightJustify = 1
    gtRightCaptionJustify = 2
End Enum

Public Enum GTAppearanceConstants
    gtFlat = 0
    gt3D = 1
End Enum

Public Enum GTBorderStyleConstants
    gtNone = 0
    gtFixedSingle = 1
End Enum

Public Enum GTCheckboxConstants
    gtUnchecked = 0
    gtChecked = 1
    gtGreyed = 2
End Enum

'Control property definitions.
Private m_eAlignment As GTCheckFrameAlignmentConstants
Private m_eAppearance As GTAppearanceConstants
Private m_lBackColor As OLE_COLOR
Private m_cBorderStyle As GTBorderStyleConstants
Private m_sCaption As String
Private m_oFont As StdFont
Private m_lForeColor As OLE_COLOR
Private m_lHelpContextID As Long
Private m_lMaskColor As OLE_COLOR
Private m_cOLEDropMode As Byte
Private m_oPicture As StdPicture
Private m_bRightToLeft As Boolean
Private m_bUseMaskColor As Boolean
Private m_eValue As GTCheckboxConstants
Private m_lWhatsThisHelpID As Long

'   ***** used for doing all drawing and painting
Private m_CPaint As CPaint

'Property strings
Private Const sAlignment = "Alignment"
Private Const sAppearance = "Appearance"
Private Const sBackColor = "BackColor"
Private Const sBorderStyle = "BorderStyle"
Private Const sCaption = "Caption"
Private Const sEnabled = "Enabled"
Private Const sFont = "Font"
Private Const sFontBold = "FontBold"
Private Const sFontCharset = "FontCharset"
Private Const sFontItalic = "FontItalic"
Private Const sFontName = "FontName"
Private Const sFontSize = "FontSize"
Private Const sFontStrikethrough = "FontStrikethrough"
Private Const sFontUnderline = "FontUnderline"
Private Const sFontWeight = "FontWeight"
Private Const sForeColor = "ForeColor"
Private Const sHelpContextID = "HelpContextID"
Private Const sMaskColor = "MaskColor"
Private Const sMouseIcon = "MouseIcon"
Private Const sMousePointer = "MousePointer"
Private Const sOLEDropMode = "OLEDropMode"
Private Const sPicture = "Picture"
Private Const sRightToLeft = "RightToLeft"
Private Const sUseMaskColor = "UseMaskColor"
Private Const sValue = "Value"
Private Const sWhatsThisHelpID = "WhatsThisHelpID"

Private Const sCheckBoxLeft = "CheckBoxLeft"
Private Const sCheckBoxTop = "CheckBoxTop"
Private Const sCheckBoxWidth = "CheckBoxWidth"
Private Const sCheckBoxHeight = "CheckBoxHeight"

'Hold checkbox and caption boundaries for hit testing
Private m_lCheckBoxLeft As Long
Private m_lCheckBoxTop As Long
Private m_lCheckBoxWidth As Long
Private m_lCheckBoxHeight As Long
Private m_lCaptionLeft As Long
Private m_lCaptionTop As Long
Private m_lCaptionWidth As Long
Private m_lCaptionHeight As Long
Private m_lMaxCaptionWidth As Long

Private m_bDontPaint As Boolean ' used for refreshing graphical controls
Private m_bParentIsActive As Boolean ' ver 1.0a Used with timer

'Store Focus info
Private m_bHaveFocus As Boolean

'Class with handles bitmap transparency and gray drawing
Private m_oTransBlt As New CMaskBlt

'System color constants
Private Const COLOR_BTNFACE = 15
Private Const COLOR_BTNHIGHLIGHT = 20
Private Const COLOR_BTNSHADOW = 16

Private rectCaption As RECT


'The control's events. These are defined in the
'individual areas of the control (i.e.
'UserControl_Click, UserControl_MouseDown, etc.)
Public Event CheckboxClick()
Attribute CheckboxClick.VB_Description = "Occurs when user clicks the Checkbox or caption."
Attribute CheckboxClick.VB_HelpID = 108
Public Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_HelpID = 129
Attribute Click.VB_UserMemId = -600
Public Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Attribute DblClick.VB_HelpID = 106
Attribute DblClick.VB_UserMemId = -601
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Attribute KeyDown.VB_HelpID = 32
Attribute KeyDown.VB_UserMemId = -602
Public Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Attribute KeyPress.VB_HelpID = 36
Attribute KeyPress.VB_UserMemId = -603
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Attribute KeyUp.VB_HelpID = 32
Attribute KeyUp.VB_UserMemId = -604
Public Event MouseDown(Button As Integer, Shift As Integer, _
        x As Single, y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Attribute MouseDown.VB_HelpID = 124
Attribute MouseDown.VB_UserMemId = -605
Public Event MouseMove(Button As Integer, Shift As Integer, _
        x As Single, y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Attribute MouseMove.VB_HelpID = 121
Attribute MouseMove.VB_UserMemId = -606
Public Event MouseUp(Button As Integer, Shift As Integer, _
        x As Single, y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Attribute MouseUp.VB_HelpID = 124
Attribute MouseUp.VB_UserMemId = -607
Public Event OLECompleteDrag(Effect As Long)
Attribute OLECompleteDrag.VB_Description = "Occurs at the OLE drag/drop source control after a manual or automatic drag/drop has been completed or canceled."
Attribute OLECompleteDrag.VB_HelpID = 120
Public Event OLEDragDrop(Data As DataObject, Effect As Long, _
        Button As Integer, Shift As Integer, x As Single, _
        y As Single)
Attribute OLEDragDrop.VB_Description = "Occurs when data is dropped onto the control via an OLE drag/drop operation, and OLEDropMode is set to manual."
Attribute OLEDragDrop.VB_HelpID = 119
Public Event OLEDragOver(Data As DataObject, Effect As Long, _
        Button As Integer, Shift As Integer, x As Single, _
        y As Single, State As Integer)
Attribute OLEDragOver.VB_Description = "Occurs when the mouse is moved over the control during an OLE drag/drop operation, if its OLEDropMode property is set to manual."
Attribute OLEDragOver.VB_HelpID = 118
Public Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Attribute OLEGiveFeedback.VB_Description = "Occurs at the source control of an OLE drag/drop operation when the mouse cursor needs to be changed."
Attribute OLEGiveFeedback.VB_HelpID = 116
Public Event OLESetData(Data As DataObject, DataFormat As Integer)
Attribute OLESetData.VB_Description = "Occurs at the OLE drag/drop source control when the drop target requests data that was not provided to the DataObject during the OLEDragStart event."
Attribute OLESetData.VB_HelpID = 117
Public Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
Attribute OLEStartDrag.VB_Description = "Occurs when an OLE drag/drop operation is initiated either manually or automatically."
Attribute OLEStartDrag.VB_HelpID = 115

'Propety Definitions
Public Property Get Alignment() As GTCheckFrameAlignmentConstants
Attribute Alignment.VB_Description = "Returns/sets the alignment of a CheckBox or OptionButton, or a control's text."
Attribute Alignment.VB_HelpID = 9
Attribute Alignment.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Alignment = m_eAlignment
End Property

Public Property Let Alignment(ByVal NewValue As GTCheckFrameAlignmentConstants)
    Select Case NewValue
        Case gtLeftJustify, gtRightJustify, gtRightCaptionJustify
            m_eAlignment = NewValue
            'signal that the property has changed
            PropertyChanged sAlignment
            Draw gtDrawAll
        Case Else
            Error errInvalidPropertyValue
    End Select
End Property

Public Property Get Appearance() As GTAppearanceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
Attribute Appearance.VB_HelpID = 22
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
    Appearance = m_eAppearance
End Property

Public Property Let Appearance(ByVal NewValue As GTAppearanceConstants)
    Select Case NewValue
        Case gtFlat
            BackColor = vbWindowBackground
        Case gt3D
            BackColor = vbButtonFace
        Case Else
            Error errInvalidPropertyValue
            Exit Property
    End Select
    m_eAppearance = NewValue
    'signal that the property has changed
    PropertyChanged sAppearance
    Draw gtDrawAll
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_HelpID = 5000
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal NewValue As OLE_COLOR)
    m_lBackColor = Val(NewValue)
    UserControl.BackColor = m_lBackColor
    'signal that the property has changed
    PropertyChanged sBackColor
    Draw gtDrawAll
End Property

Public Property Get BorderStyle() As GTBorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_HelpID = 2
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_cBorderStyle
End Property

Public Property Let BorderStyle(ByVal NewValue As _
        GTBorderStyleConstants)
    Select Case NewValue
        Case gtNone, gtFixedSingle
            m_cBorderStyle = NewValue
            'signal that the property has changed
            PropertyChanged sBorderStyle
            Draw gtDrawAll
        Case Else
            Error errInvalidPropertyValue
    End Select
End Property

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
Attribute Caption.VB_HelpID = 21
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute Caption.VB_UserMemId = -518
    Caption = m_sCaption
End Property

Public Property Let Caption(ByVal NewValue As String)
    m_sCaption = NewValue
    'signal that the property has changed
    PropertyChanged sCaption
    m_lMaxCaptionWidth = m_lCaptionWidth
    m_lCaptionWidth = TextWidth(m_sCaption)
    m_lMaxCaptionWidth = IIf(m_lMaxCaptionWidth > m_lCaptionWidth, m_lMaxCaptionWidth, m_lCaptionWidth)
    m_lCaptionHeight = TextHeight("O")
    Draw gtDrawAll
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_HelpID = 18
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
    Dim lRet As Long
    
    If Ambient.UserMode Then
        If m_bHaveFocus Then
            Draw gtDrawCaption
        End If
        EnableControls
    Else
        Draw gtDrawCaption
    End If
    
    Draw gtDrawCheckBox Or gtDrawCaption
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_HelpID = 31
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512
    Set Font = m_oFont
End Property

Public Property Set Font(NewValue As StdFont)
    Set m_oFont = NewValue
    Set UserControl.Font = NewValue
    
    m_lCaptionHeight = TextHeight("O")
    m_lCaptionWidth = TextWidth(m_sCaption)
    
    'signal that the property has changed
    PropertyChanged sFontBold
    PropertyChanged sFontCharset
    PropertyChanged sFontItalic
    PropertyChanged sFontName
    PropertyChanged sFontSize
    PropertyChanged sFontStrikethrough
    PropertyChanged sFontUnderline
    PropertyChanged sFontWeight
    Draw gtDrawAll
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_HelpID = 5000
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal NewValue As OLE_COLOR)
    m_lForeColor = Val(NewValue)
    UserControl.ForeColor = m_lForeColor
    'signal that the property has changed
    PropertyChanged sForeColor
    Draw gtDrawAll
End Property

Public Property Get HelpContextID() As Long
Attribute HelpContextID.VB_Description = "Specifies the default Help file context ID for an object."
Attribute HelpContextID.VB_HelpID = 41
Attribute HelpContextID.VB_ProcData.VB_Invoke_Property = ";Misc"
    HelpContextID = m_lHelpContextID
End Property

Public Property Let HelpContextID(ByVal NewValue As Long)
    m_lHelpContextID = NewValue
End Property

Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
Attribute hWnd.VB_HelpID = 43
Attribute hWnd.VB_UserMemId = -515
    hWnd = UserControl.hWnd
End Property

Public Property Get MaskColor() As OLE_COLOR
Attribute MaskColor.VB_Description = "Returns/sets a value which determines the color to be transparent in ImageList graphical operations."
Attribute MaskColor.VB_HelpID = 54
Attribute MaskColor.VB_ProcData.VB_Invoke_Property = ";Behavior"
    MaskColor = m_lMaskColor
End Property

Public Property Let MaskColor(ByVal NewValue As OLE_COLOR)
    m_lMaskColor = NewValue
    If m_oTransBlt.Pictures(1).hdcSource <> 0 Then
        m_oTransBlt.Pictures(1).MaskColor = m_lMaskColor
    End If
    'signal that the property has changed
    PropertyChanged sMaskColor
    Draw gtDrawCheckBox
End Property

Public Property Get MouseIcon() As StdPicture
Attribute MouseIcon.VB_Description = " Sets a custom mouse icon."
Attribute MouseIcon.VB_HelpID = 58
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = ";Misc"
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(NewValue As StdPicture)
    If Not NewValue Is Nothing Then
        If Not (NewValue.Type = vbPicTypeIcon) Then
            Err.Raise vbObjectError + 1051, App.Title, "MouseIcon only accepts a picture of type icon or cursor.", App.HelpFile
            Exit Property
        End If
    End If
    Set UserControl.MouseIcon = NewValue
    'signal that the property has changed
    PropertyChanged sMouseIcon
End Property

Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
Attribute MousePointer.VB_HelpID = 59
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Misc"
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal NewValue As MousePointerConstants)
    UserControl.MousePointer = NewValue
    'signal that the property has changed
    PropertyChanged sMousePointer
End Property

Public Property Get OLEDropMode() As GTOLEDropConstants
Attribute OLEDropMode.VB_Description = "Returns/Sets whether this object can act as an OLE drop target."
Attribute OLEDropMode.VB_HelpID = 62
Attribute OLEDropMode.VB_ProcData.VB_Invoke_Property = ";Misc"
    OLEDropMode = m_cOLEDropMode
End Property

Public Property Let OLEDropMode(ByVal NewValue As GTOLEDropConstants)
    m_cOLEDropMode = NewValue
    UserControl.OLEDropMode = NewValue
    'signal that the property has changed
    PropertyChanged sOLEDropMode
End Property

Public Property Get Picture() As StdPicture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in the checkbox."
Attribute Picture.VB_HelpID = 13
Attribute Picture.VB_ProcData.VB_Invoke_Property = ";Misc"
    Set Picture = m_oPicture
End Property

Public Property Set Picture(ByVal NewValue As StdPicture)
    If Not NewValue Is m_oPicture Then
        If (Not NewValue Is Nothing) Then
            'Property Pages return 0 for cleared pictures
            If NewValue <> 0 Then
                If NewValue.Type = vbPicTypeBitmap Then
                    Set m_oPicture = NewValue
                    
                    m_lCheckBoxWidth = ScaleX(m_oPicture.Width, _
                            vbHimetric, vbPixels) + 4
                    m_lCheckBoxHeight = ScaleY(m_oPicture.Height, _
                            vbHimetric, vbPixels) + 4
                   
                    m_oTransBlt.Pictures(1).hdcSource = m_oPicture.Handle
                    Draw gtDrawAll
                    'signal that the property has changed
                    PropertyChanged sPicture
                Else
                    Error errInvalidPropertyValue
                End If
            Else
                Set m_oPicture = Nothing
                m_lCheckBoxWidth = 12
                m_lCheckBoxHeight = 12
                m_oTransBlt.Pictures(1).hdcSource = 0
                Draw gtDrawAll
                'signal that the property has changed
                PropertyChanged sPicture
            End If
        Else
            Set m_oPicture = Nothing
            m_lCheckBoxWidth = 12
            m_lCheckBoxHeight = 12
            m_oTransBlt.Pictures(1).hdcSource = 0
            Draw gtDrawAll
            'signal that the property has changed
            PropertyChanged sPicture
        End If
    End If
End Property

Public Property Get RightToLeft() As Boolean
Attribute RightToLeft.VB_Description = "Determines text display direction and control visual appearance on a bidirectional system."
Attribute RightToLeft.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute RightToLeft.VB_UserMemId = -611
    RightToLeft = UserControl.RightToLeft
End Property

Public Property Let RightToLeft(ByVal NewValue As Boolean)
    UserControl.RightToLeft = NewValue
End Property

'UseMaskColor  allows a use to turn on and off transparency
'for user defined pictures
Public Property Get UseMaskColor() As Boolean
Attribute UseMaskColor.VB_Description = "Returns or sets a value that determines whether the color assigned in the MaskColor property is used as a 'mask'. (That is, used to create transparent regions.)"
Attribute UseMaskColor.VB_HelpID = 93
Attribute UseMaskColor.VB_ProcData.VB_Invoke_Property = ";Behavior"
    UseMaskColor = m_bUseMaskColor
End Property

Public Property Let UseMaskColor(ByVal NewValue As Boolean)
    m_bUseMaskColor = NewValue
    'signal that the property has changed
    PropertyChanged sUseMaskColor
    Draw gtDrawAll
End Property

Public Property Get Value() As GTCheckboxConstants
Attribute Value.VB_Description = "Returns/sets the value of an object."
Attribute Value.VB_HelpID = 94
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Misc"
Attribute Value.VB_MemberFlags = "200"
    Value = m_eValue
End Property

Public Property Let Value(ByVal NewValue As GTCheckboxConstants)
    Select Case NewValue
        Case gtUnchecked, gtChecked, gtGreyed
            m_eValue = NewValue
            'signal that the property has changed
            PropertyChanged sValue
            Draw gtDrawAll
            EnableControls
        Case Else
            Err.Raise errInvalidPropertyValue
    End Select
End Property

'Methods
Public Sub OLEDrag()
Attribute OLEDrag.VB_Description = "Starts an OLE drag/drop event with the given control as the source."
Attribute OLEDrag.VB_HelpID = 135
    UserControl.OLEDrag
End Sub
'   ***** Ver 1.0a No longer used
''gtMsgHook is the controls subclass routine to relay
''Windows messages
'Private Sub gtMsgHook1_Message(ByVal hWnd As Long, ByVal MsgID As Long, ByVal wParam As Long, ByVal lParam As Long)
'
'    Select Case MsgID
'        Case WM_SYSCOLORCHANGE
'            Draw gtDrawAll
'        Case WM_ACTIVATE
''   ***** Ver 1.0a Passes when the form is active or not
'            Draw gtDrawCaption, (wParam = 2)
''            m_bHaveFocus = (wParam = 2)
''            Draw gtDrawCaption
''   *****
'    End Select
'
'End Sub
'   *****
Public Property Get WhatsThisHelpID() As Long
Attribute WhatsThisHelpID.VB_Description = "Returns/sets an associated context number for an object."
Attribute WhatsThisHelpID.VB_HelpID = 97
Attribute WhatsThisHelpID.VB_ProcData.VB_Invoke_Property = ";Misc"
    WhatsThisHelpID = m_lWhatsThisHelpID
End Property

Public Property Let WhatsThisHelpID(ByVal NewValue As Long)
    m_lWhatsThisHelpID = NewValue
End Property

Private Sub Timer1_Timer()
'   ***** Ver 1.0a Now using a timer instead of subclassing the parent
    Dim bParentIsActive As Boolean
    
    bParentIsActive = IsParentActiveWindow() ' check to see if the parent is the actve window
    
    If m_bParentIsActive = bParentIsActive Then
        ' do nothing
    Else
        SetActiveFlag
        Draw gtDrawCaption, bParentIsActive
    End If
'   *****
End Sub

Private Sub UserControl_Initialize()
    
    Set m_CPaint = New CPaint ' initialize the drawing class
    
    'Add the default check picture. An additional picture will be added
    'in the set Picture routine if the user adds his own picture.
    m_oTransBlt.AddPicture UserControl.hdc
    
'   ***** Ver 1.0a No longer used
'    'Pass our Window to gtMsgHook to trapp the messages
'    GTMsgHook1.Windows.Add , , , UserControl.hWnd
'    GTMsgHook1.Windows(1).Messages.Add , , WM_SYSCOLORCHANGE, "WM_SYSCOLORCHANGE"
'   *****
End Sub

Private Sub UserControl_InitProperties()
    'Start gtMsgHook

'   ***** Ver 1.0a No longer used
'#If DEBUG_SWITCH = 2 Then
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = 1 Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
'   *****
    'Initialize the Properties to their defaults
    'when the control is placed on the form.
    m_eAlignment = gtLeftJustify
    m_eAppearance = gt3D
    m_lBackColor = vbButtonFace
    UserControl.BackColor = m_lBackColor
    m_cBorderStyle = gtFixedSingle
    m_sCaption = UserControl.Ambient.DisplayName
    m_lCaptionWidth = TextWidth(m_sCaption)
    m_lCaptionHeight = TextHeight(m_sCaption)
    UserControl.Enabled = True
    Set m_oFont = UserControl.Font
    m_lForeColor = vbButtonText
    '**m_lHelpContextID As Long
    m_lMaskColor = vbWhite
    m_cOLEDropMode = UserControl.OLEDropMode
    Set m_oPicture = Nothing
    m_bRightToLeft = False
    m_eValue = gtUnchecked
    m_lWhatsThisHelpID = 0
    
    m_lCheckBoxWidth = 12
    m_lCheckBoxHeight = 12

    SetActiveFlag ' ver 1.0a
End Sub

Private Sub Draw(ByVal DrawWhat As Byte, Optional bDrawFocusRect As Boolean = True)
'   *******************************************************************
'   * Params : DrawWhat     A bitflag which tells the routine which parts
'   *                       of the control need to be drawn, bDrawFocusRect:
'   *                       the parent has focus or not
'   * Purpose: Draws parts or the complete control.
'   * Modified: Ver 1.0a    Added bDrawFocusRect param as to
'   *                               whether to draw focus rect if control has
'   *                               focus.
'   *******************************************************************
    
    Dim iFrameLineTop As Integer
    Dim lRet As Long
    Dim fClipLeft As Long
    Dim fClipRight As Long
    Dim lOldCaptionLeft As Long
    Dim rectFrame As RECT
    Dim CPaint As CPaint
    Dim hDCMem As Long
    Dim lOldBackColor As Long
    Dim lWidth As Long
    
    If DrawWhat = gtDrawAll Then
        hDCMem = m_CPaint.GetMemDC(UserControl.hdc, ScaleWidth, ScaleHeight, GetBkColor(UserControl.hdc))
    Else
        hDCMem = m_CPaint.hDCMem
    End If
    
    'get properties for Caption to position lines
    If m_lCheckBoxHeight > m_lCaptionHeight Then
        m_lCaptionTop = (m_lCheckBoxHeight - m_lCaptionHeight) * 0.5 + 1.5
        m_lCheckBoxTop = 1
    Else
        m_lCheckBoxTop = (m_lCaptionHeight - m_lCheckBoxHeight) * 0.5
        m_lCaptionTop = 1
    End If
    iFrameLineTop = m_lCaptionTop + CInt(m_lCaptionHeight * 0.5)

    'Get postions of Caption, CheckBox and Top Line
    Select Case m_eAlignment
        Case gtLeftJustify
            m_lCheckBoxLeft = CheckBoxLeftMargin
            m_lCaptionLeft = m_lCheckBoxLeft + m_lCheckBoxWidth + CheckBoxCaptionSpacer
            If m_sCaption <> "" Then
                fClipLeft = m_lCheckBoxLeft + m_lCheckBoxWidth
                fClipRight = m_lCaptionLeft + m_lCaptionWidth + CaptionExcludeSpacer
            End If

        Case gtRightJustify
            m_lCheckBoxLeft = ScaleWidth _
                    - (m_lCheckBoxWidth + 9)
            m_lCaptionLeft = CaptionLeftMargin
            If m_sCaption <> "" Then
                fClipLeft = m_lCaptionLeft - 2
                fClipRight = m_lCaptionLeft + m_lCaptionWidth + 2
            End If

        Case gtRightCaptionJustify
            m_lCheckBoxLeft = ScaleWidth - (m_lCheckBoxWidth + 9)
            m_lCaptionLeft = m_lCheckBoxLeft - _
                    (UserControl.TextWidth(m_sCaption) + CheckBoxCaptionSpacer)
            If m_sCaption <> "" Then
                fClipLeft = m_lCaptionLeft - 2
                fClipRight = m_lCheckBoxLeft
            End If

    End Select

'    'clearing done here
    If DrawWhat And gtDrawFrame Then
        'Clear frame for redrawing
        rectFrame.Left = 0
        rectFrame.Top = 0
        rectFrame.Right = UserControl.ScaleWidth
        rectFrame.Bottom = UserControl.ScaleHeight

        m_CPaint.DrawBackground hDCMem, rectFrame.Left, rectFrame.Top, rectFrame.Right, rectFrame.Bottom, UserControl.BackColor

    ElseIf DrawWhat And gtDrawCaption Then
        'Clear only the caption
        Select Case Alignment
            Case gtLeftJustify
                rectFrame.Left = m_lCaptionLeft - 4 'use minus 4 to remove line section to left of caption to checkbox
                rectFrame.Right = m_lCaptionLeft + m_lMaxCaptionWidth + 2 'use plus to remove line section to right of caption
                lWidth = m_lMaxCaptionWidth + 2
            Case gtRightJustify
                rectFrame.Left = m_lCaptionLeft - 2  'use minus 2 to remove line section to left of caption
                rectFrame.Right = m_lCaptionLeft + m_lMaxCaptionWidth + 2 'use plus to remove line section to right of caption
                lWidth = m_lMaxCaptionWidth + 2

            Case gtRightCaptionJustify
                rectFrame.Left = IIf(lOldCaptionLeft < m_lCaptionLeft, lOldCaptionLeft, m_lCaptionLeft) - 2 'use minus 2 to remove line section to left of caption
                rectFrame.Right = m_lCheckBoxLeft
                lWidth = m_lCheckBoxLeft
        End Select

        rectFrame.Top = m_lCaptionTop
        rectFrame.Bottom = m_lCaptionTop + m_lCaptionHeight

        m_CPaint.DrawBackground hDCMem, rectFrame.Left, rectFrame.Top, lWidth, m_lCaptionHeight, UserControl.BackColor

        DrawWhat = DrawWhat Or gtDrawFrame 'Draw the frame to draw the exposed line
    End If

    If DrawWhat And gtDrawFrame Then

        If m_cBorderStyle = gtFixedSingle Then
            'Define the area of frame box to exclude from drawing (namely where the caption is.)

            If m_sCaption <> "" Then
                ExcludeClipRect hDCMem, fClipLeft, iFrameLineTop - 2, fClipRight, iFrameLineTop + 4
            End If
            ExcludeClipRect hDCMem, m_lCheckBoxLeft, iFrameLineTop - 2, m_lCheckBoxLeft + m_lCheckBoxWidth, iFrameLineTop + 4

            rectFrame.Left = 0
            rectFrame.Top = iFrameLineTop
            rectFrame.Right = ScaleWidth - 1
            rectFrame.Bottom = ScaleHeight - 1
            If m_eAppearance = gtFlat Then
                DrawEdge hDCMem, rectFrame, EDGE_ETCHED, BF_RECT Or BF_MONO
            Else
                DrawEdge hDCMem, rectFrame, EDGE_ETCHED, BF_RECT
            End If
            lRet = SelectClipRgn(hDCMem, 0&)
        End If
    End If

    If DrawWhat And gtDrawCaption Then
        DrawCaption hDCMem, bDrawFocusRect ' Ver 1.0a Added bDrawFocusRect
    End If

    If DrawWhat And gtDrawCheckBox Then
        DrawCheckBox hDCMem, DrawWhat
    End If

    m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight
    
    If Not m_bDontPaint Then ' has to be otherwise doesn't redraw correctly.
        RefreshGraphicalControls ' need to refresh the graphical controls or they disappear
    End If
End Sub

Private Sub DrawCaption(hdc As Long, Optional bDrawFocusRect As Boolean = True)
'   ***************************************************************************
'   * Params:   hdc: the dc draw the caption on, bDrawFocusRect: whether
'   *               or not the parent is active.
'   * Purpose:  Draws the caption and the focus if the control has focus and the parent
'   *               is active.
'   * Modified: Ver 1.0a    Added bDrawFocusRect param as to
'   *                               whether to draw focus rect if control has
'   *                               focus.
'   ***************************************************************************
    'define coordinates for focus rect
    rectCaption.Left = m_lCaptionLeft - 1
    rectCaption.Top = m_lCaptionTop - 1
    rectCaption.Right = m_lCaptionLeft + m_lCaptionWidth + 1
    rectCaption.Bottom = m_lCaptionTop + m_lCaptionHeight + 1
    
'   ***** Draws behind the caption
    m_CPaint.DrawBackground hdc, m_lCaptionLeft - 1, m_lCaptionTop - 1, m_lCaptionWidth + 2, m_lCaptionHeight + 2, UserControl.BackColor
'   *****
    
    'Position and print Caption
    If UserControl.Enabled Then
        
        If Not m_oFont Is Nothing Then
            m_CPaint.PaintText m_sCaption, m_oFont.Name, rectCaption.Left, rectCaption.Top, rectCaption.Right, rectCaption.Bottom, _
                        TextHeight("O"), DT_NOCLIP Or DT_SINGLELINE Or DT_LEFT, , m_oFont.Bold, m_oFont.Italic, m_oFont.Strikethrough, _
                        m_oFont.Underline, GetBkColor(UserControl.hdc), GetTextColor(UserControl.hdc)
        End If
        
'   ***** Draws the focus rect
        If m_bHaveFocus And bDrawFocusRect Then
                DrawFocusRect hdc, rectCaption
        End If
'   *****

    Else
        'Draw the disabled picture with etched look:
        'Start by drawing a Highlighted copy 1 pixel right and down
'        DrawText hdc, m_sCaption, Len(m_sCaption), rectCaption, DT_NOCLIP Or DT_SINGLELINE Or DT_LEFT
        If Not m_oFont Is Nothing Then
            UserControl.ForeColor = vb3DHighlight
            rectCaption.Left = m_lCaptionLeft
            rectCaption.Top = m_lCaptionTop
            rectCaption.Right = m_lCaptionLeft + m_lCaptionWidth + 2
            rectCaption.Bottom = m_lCaptionTop + m_lCaptionHeight + 2
            
            m_CPaint.PaintText m_sCaption, m_oFont.Name, rectCaption.Left, rectCaption.Top, rectCaption.Right, rectCaption.Bottom, _
                    TextHeight("O"), DT_NOCLIP Or DT_SINGLELINE Or DT_LEFT, , m_oFont.Bold, m_oFont.Italic, m_oFont.Strikethrough, _
                    m_oFont.Underline, GetBkColor(UserControl.hdc), GetTextColor(UserControl.hdc)
        End If
        'Then draw the Shadow copy in the proper place
        If Not m_oFont Is Nothing Then
            UserControl.ForeColor = vb3DShadow
            rectCaption.Left = m_lCaptionLeft - 1
            rectCaption.Top = m_lCaptionTop - 1
            rectCaption.Right = m_lCaptionLeft + m_lCaptionWidth + 1
            rectCaption.Bottom = m_lCaptionTop + m_lCaptionHeight + 1
'        DrawText hdc, m_sCaption, Len(m_sCaption), rectCaption, DT_NOCLIP Or DT_SINGLELINE Or DT_LEFT
            
            m_CPaint.PaintText m_sCaption, m_oFont.Name, rectCaption.Left, rectCaption.Top, rectCaption.Right, rectCaption.Bottom, _
                    TextHeight("O"), DT_NOCLIP Or DT_SINGLELINE Or DT_LEFT, , m_oFont.Bold, m_oFont.Italic, m_oFont.Strikethrough, _
                    m_oFont.Underline, GetBkColor(UserControl.hdc), GetTextColor(UserControl.hdc)
        
        End If
        
        UserControl.ForeColor = m_lForeColor
    End If
End Sub

Private Sub DrawCheckBox(hdc As Long, ByVal DrawWhat As Byte)
    Dim rectCheckbox As RECT
    Dim lCheckStyle As Long
    Dim CDrawRect As CDrawRect
    Dim lOldBackColor As Long
    
    If m_oPicture Is Nothing Then
        'If user did not define a picture, use default picture
        
        rectCheckbox.Left = m_lCheckBoxLeft
        rectCheckbox.Top = m_lCheckBoxTop
        rectCheckbox.Right = m_lCheckBoxLeft + m_lCheckBoxWidth + 1
        rectCheckbox.Bottom = m_lCheckBoxTop + m_lCheckBoxHeight + 1
        
        'define properies
        lCheckStyle = DFCS_BUTTONCHECK
        If m_eAppearance = gtFlat Then
            lCheckStyle = lCheckStyle Or DFCS_FLAT
        End If
        If DrawWhat And gtDrawMouseDown Then
            lCheckStyle = lCheckStyle Or DFCS_PUSHED
        End If
        If m_eValue Then
            lCheckStyle = lCheckStyle Or DFCS_CHECKED
        End If
        If m_eValue = gtGreyed Then
            lCheckStyle = lCheckStyle Or DFCS_INACTIVE
        End If
        
        DrawFrameControl hdc, rectCheckbox, DFC_BUTTON, lCheckStyle
    Else
        'otherwise use user defined picture (Pictures(2))
            
        Set CDrawRect = New CDrawRect
        
        If DrawWhat And gtDrawMouseDown Then
            m_CPaint.DrawBackground hdc, m_lCheckBoxLeft, m_lCheckBoxTop, m_lCheckBoxWidth, m_lCheckBoxHeight, _
                                                    UserControl.BackColor ' need to use the backcolor
        Else
            m_CPaint.DrawBackground hdc, m_lCheckBoxLeft, m_lCheckBoxTop, m_lCheckBoxWidth, m_lCheckBoxHeight, _
                                                    vbWindowBackground ' make sure to use the windowbackcolor
        End If
        
        'Draw checkbox frame manually since the DrawFrameControl API
        'only draws it square
        If m_eAppearance = gt3D Then
            CDrawRect.Draw3DRect hdc, m_lCheckBoxLeft, m_lCheckBoxTop, m_lCheckBoxWidth, m_lCheckBoxHeight, Inset
        Else
            CDrawRect.Draw3DRect hdc, m_lCheckBoxLeft, m_lCheckBoxTop, m_lCheckBoxWidth, m_lCheckBoxHeight, FixedSingle
        End If
        
        If m_eValue <> gtUnchecked Then
        
            m_oTransBlt.Pictures(1).DestinationDC = hdc
            m_oTransBlt.Pictures(1).MaskBlt m_lCheckBoxLeft + 2, m_lCheckBoxTop + 2, m_bUseMaskColor, _
                    (Not UserControl.Enabled) Or (m_eValue = gtGreyed)
        End If
    
        Set CDrawRect = Nothing
    
    End If
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_GotFocus()
    Dim lRet As Long
    m_bHaveFocus = True
    Draw gtDrawCaption
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeyLeft, vbKeyUp 'Left and Up arrows cause a Tab to previous control
            If Shift = 0 Then
                SendKeys "+{Tab}"
            End If
        Case vbKeyDown, vbKeyRight 'Down and Right arrows cause a Tab to next control
            If Shift = 0 Then
                SendKeys "{Tab}"
            End If
        Case 32 'The Space key fires a MouseDown event
            If UserControl.Enabled Then
                Draw gtDrawCheckBox Or gtDrawMouseDown
            End If
    End Select
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeySpace 'the Space key will trigger a MouseUp event
            If UserControl.Enabled Then
                If m_eValue = gtChecked Then
                    m_eValue = gtUnchecked
                Else
                    m_eValue = gtChecked
                End If
                Draw gtDrawCheckBox
'   ***** Ver 1.0a Now fires the CheckboxClick and enables/disables child controls
                EnableControls
                RaiseEvent CheckboxClick
'   *****
            End If
    End Select
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_LostFocus()
    m_bHaveFocus = False
    Draw gtDrawCaption
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As _
        Integer, x As Single, y As Single)
    Dim bClicked As Boolean
    
    If UserControl.Enabled Then
        'Only do check box events if the hit zones hit by the left button
        If Button = vbLeftButton And TestHitZones(x, y) Then
            Draw gtDrawCheckBox Or gtDrawMouseDown
        End If
        'tell VB to call event procedure
        RaiseEvent MouseDown(Button, Shift, x, y)
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As _
        Integer, x As Single, y As Single)
   RaiseEvent MouseMove(Button, Shift, x, y)
   If Button Then
        If TestHitZones(x, y) Then
            Draw gtDrawCheckBox Or gtDrawMouseDown
        Else
            Draw gtDrawCheckBox
        End If
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As _
        Integer, x As Single, y As Single)
    Dim bClicked As Boolean
    
    If UserControl.Enabled Then
        'Only do check box events if the hit zones hit by the left button
        If Button = vbLeftButton And TestHitZones(x, y) Then
            If m_eValue <> gtUnchecked Then
                m_eValue = gtUnchecked
            Else
                m_eValue = gtChecked
            End If
            EnableControls
            Draw gtDrawCheckBox
            RaiseEvent CheckboxClick
        Else
            RaiseEvent Click
        End If
        'tell VB to call event procedure
        RaiseEvent MouseUp(Button, Shift, x, y)
    End If
End Sub

Private Sub UserControl_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub

Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As _
        Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, x, y)
End Sub

Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As _
        Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, x, y, State)
End Sub

Private Sub UserControl_OLEGiveFeedback(Effect As Long, _
        DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub

Private Sub UserControl_OLESetData(Data As DataObject, DataFormat As _
        Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub

Private Sub UserControl_OLEStartDrag(Data As DataObject, _
        AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

Private Sub UserControl_Paint()
    Draw gtDrawAll
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    'This procedure is called to retrieve the stored
    'property values (i.e. Viewing the form at
    'design-time, loading the form at runtime.)
    
    On Error GoTo UserControl_ReadProperties_err
    
'   ***** Ver 1.0a No longer used
'#If DEBUG_SWITCH = 2 Then
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = 1 Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
'   *****
    m_eAlignment = PropBag.ReadProperty(sAlignment)
    m_eAppearance = PropBag.ReadProperty(sAppearance)
    m_lBackColor = PropBag.ReadProperty(sBackColor)
    UserControl.BackColor = m_lBackColor
    m_cBorderStyle = PropBag.ReadProperty(sBorderStyle)
    m_sCaption = PropBag.ReadProperty(sCaption)
    UserControl.Enabled = PropBag.ReadProperty(sEnabled)
    
    Set m_oFont = PropBag.ReadProperty(sFont, UserControl.Font)
    Set UserControl.Font = m_oFont
    m_lForeColor = PropBag.ReadProperty(sForeColor)
    UserControl.ForeColor = m_lForeColor
    m_lHelpContextID = PropBag.ReadProperty(sHelpContextID)
    m_lMaskColor = PropBag.ReadProperty(sMaskColor)
    Set UserControl.MouseIcon = PropBag.ReadProperty(sMouseIcon, Nothing)
    UserControl.MousePointer = PropBag.ReadProperty(sMousePointer, vbDefault)
    Set m_oPicture = PropBag.ReadProperty(sPicture, Nothing)
    If m_oPicture Is Nothing Then
        m_lCheckBoxHeight = 12
        m_lCheckBoxWidth = 12
    Else
        m_lCheckBoxWidth = ScaleX(m_oPicture.Width, vbHimetric, _
                vbPixels) + 3
        m_lCheckBoxHeight = ScaleY(m_oPicture.Height, vbHimetric, _
                vbPixels) + 3
        m_oTransBlt.Pictures(1).DestinationDC = UserControl.hdc
        m_oTransBlt.Pictures(1).hdcSource = m_oPicture.Handle
        m_oTransBlt.Pictures(1).MaskColor = m_lMaskColor
    End If
    m_cOLEDropMode = PropBag.ReadProperty(sOLEDropMode)
    UserControl.RightToLeft = PropBag.ReadProperty(sRightToLeft)
    m_bUseMaskColor = PropBag.ReadProperty(sUseMaskColor)
    m_eValue = PropBag.ReadProperty(sValue)
    
    'Set contained controls' Enabled properties
    EnableControls
    
    m_lWhatsThisHelpID = PropBag.ReadProperty(sWhatsThisHelpID)
    
    m_lCaptionWidth = TextWidth(m_sCaption)
    m_lCaptionHeight = TextHeight(m_sCaption)
    
    m_lCheckBoxLeft = PropBag.ReadProperty(sCheckBoxLeft)
    m_lCheckBoxTop = PropBag.ReadProperty(sCheckBoxTop)
    
    SetActiveFlag ' ver 1.0a
    
    Timer1.Enabled = Ambient.UserMode ' ver 1.0a
    
    Exit Sub
    
UserControl_ReadProperties_err:
    '***
End Sub

Private Sub UserControl_Show()
    EnableControls
'    Draw gtDrawAll
End Sub

Private Sub UserControl_Terminate()
'   ***** Ver 1.0a No longer used
'    'turn off gtMsgHook
'    GTMsgHook1.Subclass = False
'   *****

    Set m_CPaint = Nothing ' release CPaint
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    'This procedure is called to store the current
    'property values (i.e. Closing the form in design-time.)
    PropBag.WriteProperty sAlignment, m_eAlignment
    PropBag.WriteProperty sAppearance, m_eAppearance
    PropBag.WriteProperty sBackColor, m_lBackColor
    PropBag.WriteProperty sBorderStyle, m_cBorderStyle
    PropBag.WriteProperty sCaption, m_sCaption
    PropBag.WriteProperty sEnabled, UserControl.Enabled
    PropBag.WriteProperty sFont, m_oFont
    PropBag.WriteProperty sForeColor, m_lForeColor
    PropBag.WriteProperty sHelpContextID, m_lHelpContextID
    PropBag.WriteProperty sMaskColor, m_lMaskColor
    PropBag.WriteProperty sMouseIcon, UserControl.MouseIcon, Nothing
    PropBag.WriteProperty sMousePointer, UserControl.MousePointer, vbDefault
    PropBag.WriteProperty sPicture, m_oPicture, Nothing
    PropBag.WriteProperty sOLEDropMode, m_cOLEDropMode
    PropBag.WriteProperty sRightToLeft, UserControl.RightToLeft
    PropBag.WriteProperty sUseMaskColor, m_bUseMaskColor
    PropBag.WriteProperty sValue, m_eValue
    PropBag.WriteProperty sWhatsThisHelpID, m_lWhatsThisHelpID
    
    PropBag.WriteProperty sCheckBoxLeft, m_lCheckBoxLeft
    PropBag.WriteProperty sCheckBoxTop, m_lCheckBoxTop
End Sub

Private Sub UserControl_Resize()
    Draw gtDrawAll
End Sub

Private Sub EnableControls()
'   *******************************************************************
'   *Params : None
'   *Purpose: This routine cycles through all children controls and
'   *         sets their Enabled parameter
'   *******************************************************************
    Dim ctl As Control
    
    On Error Resume Next
    
    'Cycle through all child controls and change their
    'Enabled property
    For Each ctl In ContainedControls
        ctl.Enabled = m_eValue = gtChecked And UserControl.Enabled
    Next ctl
End Sub


Private Function TestHitZones(ByVal x As Single, ByVal y As Single) As Boolean
'   *****************************************************************************************
'   * Params : None
'   * Return : Reutrns a boolean which indicates whether one of the hit zones were clicked
'   * Purpose: The internal routine tests if either the checkbox or caption hit zones were clicked
'   *****************************************************************************************

    'Check checkbox
    'Since the caption is either left or right of the checkbox,
    'we can check the X coordindates first. If the mouse is not between the checkbox's
    'left and right sides, it will go to the Else portion and check the caption.
    'Otherwise, we go on to check the Y coordinates. This saves time since you only
    'need to check the X coordinates of the Checkbox if the mouse is on the caption.
    If x + 2 >= m_lCheckBoxLeft And x <= m_lCheckBoxLeft _
            + m_lCheckBoxWidth + 2 Then
        If y + 2 >= m_lCheckBoxTop And y <= m_lCheckBoxTop _
                + m_lCheckBoxHeight + 2 Then
            TestHitZones = True
            Exit Function
        End If
    Else
        'Check caption
        If x + 2 >= m_lCaptionLeft And x <= m_lCaptionLeft _
                + m_lCaptionWidth + 2 Then
            If y + 2 >= m_lCaptionTop And y <= m_lCaptionTop _
                    + m_lCaptionHeight + 2 Then
                TestHitZones = True
                Exit Function
            End If
        End If
    End If
    
    TestHitZones = False
End Function


Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_HelpID = 8
Attribute ShowAboutBox.VB_UserMemId = -552
Attribute ShowAboutBox.VB_MemberFlags = "40"
    
End Sub

Private Sub RefreshGraphicalControls()
'   ***********************************************************************
'   * Purpose:  Loops thru the contained controls collection and
'   *               finds the controls without hwnd properties. These
'   *               controls are then refreshed. This is done because
'   *               graphical controls get painted over when blitting.
'   ***********************************************************************
    Dim cCtl As Control
    Dim hWnd As Long
    
    On Error Resume Next
    
    m_bDontPaint = True ' this stops the recursion caused by the refresh
    
'   ***** Looks for controls without hwnd properties. Assumes these
'   ***** are graphical
    For Each cCtl In ContainedControls
        hWnd = cCtl.hWnd
        If Err Then ' control doesn't have an hwnd
            On Error GoTo 0
            
            On Error Resume Next
            
            cCtl.Refresh
        End If
    Next
'   *****

    m_bDontPaint = False ' reset the flag

End Sub

Private Function IsParentActiveWindow() As Boolean
'   ***********************************************************************
'   * Return:   Boolean: If the parent is the active window or not
'   * Purpose:  Returns whether the parent is active or not
'   * Added:    Ver 1.0a
'   ***********************************************************************
    Dim hwndActiveWindow As Long
    
    On Error Resume Next
    
    hwndActiveWindow = GetActiveWindow()
    
    IsParentActiveWindow = (hwndActiveWindow = Parent.hWnd)
End Function

Private Sub SetActiveFlag()
'   ***********************************************************************
'   * Purpose:  Sets the Active window flag
'   * Added:    Ver 1.0a
'   ***********************************************************************
    m_bParentIsActive = IsParentActiveWindow()
End Sub
