VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CHighlightText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'   ******************************************************************************
'   * Purpose:  Handles highlighting of text in textboxes, combos, etc
'   * File:         CHighlight.cls
'   ******************************************************************************
Option Explicit

' stores whether the mousedown event of the control fired
Private m_bMouseDown As Boolean

Public Property Let MouseDown(bMouseDown As Boolean) ' sets mousedown to true
    m_bMouseDown = bMouseDown
End Property
Public Property Get MouseDown() As Boolean ' returns the value of MouseDown
    MouseDown = m_bMouseDown
End Property
Private Sub HighlightText(cControl As Control)
'   ******************************************************************************
'   * Params:   cControl: any control that has a text property
'   * Purpose:  Sets the properties on the passed in control to select the text.
'   ******************************************************************************
    cControl.SelStart = 0 ' must be 0
    cControl.SelLength = Len(cControl.Text) ' select all text
End Sub
Public Sub GotFocus(cControl As Control)
'   ******************************************************************************
'   * Params:   cControl: any control that has a text property
'   * Purpose:  Called on the gotfocus event of the control that was passed in.
'   *               Decides if the text will be selected or not
'   ******************************************************************************
    If m_bMouseDown Then ' text doesn't get selected when the mouse is down
        m_bMouseDown = False ' reset the variable
    Else ' only happens when the control was tabbed to
        HighlightText cControl ' select the text
    End If
End Sub
