VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CPaint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'   ******************************************************************************
'   * Purpose:  Handles the drawing of text and filling backgrounds
'   * File:         CPaint.cls
'   ******************************************************************************
Option Explicit
'   ***** backmode constants
Private Const BKMODE_OPAQUE = 2
Private Const BKMODE_TRANSPARENT = 1
'   *****
'   ***** drawtext constants
Private Const DT_SINGLELINE = &H20
Private Const DT_BOTTOM = &H8
Private Const DT_CENTER = &H1
Private Const DT_LEFT = &H0
Private Const DT_RIGHT = &H2
Private Const DT_TOP = &H0
Private Const DT_VCENTER = &H4
Private Const DT_WORDBREAK = &H10
Private Const DT_NOCLIP = &H100
Private Const DT_END_ELIPSE = &H8000
Private Const DT_WORD_ELIPSE = &H40000
'   *****
'   ***** Font constants
Private Const OUT_DEFAULT_PRECIS = 0
Private Const OUT_STRING_PRECIS = 1
Private Const OUT_CHARACTER_PRECIS = 2
Private Const OUT_STROKE_PRECIS = 3
Private Const OUT_TT_PRECIS = 4
Private Const OUT_DEVICE_PRECIS = 5
Private Const OUT_RASTER_PRECIS = 6
Private Const OUT_TT_ONLY_PRECIS = 7
Private Const CLIP_DEFAULT_PRECIS = 0
Private Const CLIP_CHARACTER_PRECIS = 1
Private Const CLIP_STROKE_PRECIS = 2
Private Const CLIP_LH_ANGLES = &H10
Private Const CLIP_TT_ALWAYS = &H20
Private Const CLIP_EMBEDDED = &H80
Private Const DEFAULT_QUALITY = 0
Private Const DRAFT_QUALITY = 1
Private Const PROOF_QUALITY = 2
Private Const DEFAULT_PITCH = 0
Private Const FIXED_PITCH = 1
Private Const VARIABLE_PITCH = 2
Private Const TMPF_FIXED_PITCH = 1
Private Const TMPF_VECTOR = 2
Private Const TMPF_DEVICE = 8
Private Const TMPF_TRUETYPE = 4
Private Const ANSI_CHARSET = 0
Private Const DEFAULT_CHARSET = 1
Private Const SYMBOL_CHARSET = 2
Private Const SHIFTJIS_CHARSET = 128
Private Const OEM_CHARSET = 255
Private Const NTM_REGULAR = &H40&
Private Const NTM_BOLD = &H20&
Private Const NTM_ITALIC = &H1&
Private Const LF_FULLFACESIZE = 64
Private Const RASTER_FONTTYPE = 1
Private Const DEVICE_FONTTYPE = 2
Private Const TRUETYPE_FONTTYPE = 4
Private Const FF_DONTCARE = 0
Private Const FF_ROMAN = 16
Private Const FF_SWISS = 32
Private Const FF_MODERN = 48
Private Const FF_SCRIPT = 64
Private Const FF_DECORATIVE = 80
Private Const FW_DONTCARE = 0
Private Const FW_THIN = 100
Private Const FW_EXTRALIGHT = 200
Private Const FW_LIGHT = 300
Private Const FW_NORMAL = 400
Private Const FW_MEDIUM = 500
Private Const FW_SEMIBOLD = 600
Private Const FW_BOLD = 700
Private Const FW_EXTRABOLD = 800
Private Const FW_HEAVY = 900
Private Const FW_ULTRALIGHT = FW_EXTRALIGHT
Private Const FW_REGULAR = FW_NORMAL
Private Const FW_DEMIBOLD = FW_SEMIBOLD
Private Const FW_ULTRABOLD = FW_EXTRABOLD
Private Const FW_BLACK = FW_HEAVY
Private Const LF_FACESIZE = 32
Private Const GCP_DBCS = &H1
Private Const GCP_REORDER = &H2
Private Const GCP_USEKERNING = &H8
Private Const GCP_GLYPHSHAPE = &H10
Private Const GCP_LIGATE = &H20
Private Const GCP_DIACRITIC = &H100
Private Const GCP_KASHIDA = &H400
Private Const GCP_ERROR = &H8000
Private Const FLI_MASK = &H103B
Private Const GCP_JUSTIFY = &H10000
Private Const GCP_NODIACRITICS = &H20000
Private Const FLI_GLYPHS = &H40000
'   *****

'   ***** bitblt constants
Private Const SRCCOPY = &HCC0020
'   *****

'   ***** ExtTextOut constants
Private Const ETO_CLIPPED = 4
Private Const ETO_GRAYED = 1
Private Const ETO_OPAQUE = 2
'   *****

'   ***** font type
Private Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(LF_FACESIZE) As Byte
End Type
'   *****

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

'   ***** API declarations
Private Declare Function DrawTextAPI Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, _
                ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function ExtTextOut Lib "gdi32" Alias "ExtTextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal wOptions As Long, lpRect As RECT, ByVal lpString As String, ByVal nCount As Long, lpDx As Long) As Long
Private Declare Function CreateFontIndirect& Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT)
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
'   *****

'   ***** alignment constants
Private Enum GTAlignmentConstants
    gtLeftJustify
    gtRightJustify
    gtCenter
End Enum
'   *****

Private m_hDCMem As Long ' stores the memory dc
Private m_hOldBmpMem As Long ' stores the original bitmap in the dc
Private m_hBmpMem As Long ' the new bitmap in the dc

Public Property Get hDCMem() As Long ' returns the handle to the dc in memory
    hDCMem = m_hDCMem
End Property
Public Function GetMemDC(ByVal hDCUserControl As Long, lWidth As Long, lHeight As Long, Optional bInitBackground As Boolean = False) As Long
'   ***********************************************************************
'   * Params:   hDCUserControl: the dc of the user control (need to create the compatible dc and bitmap),
'   *               lWidth: the width of the bitmap to create, lHeight: the height of the bitmap to create,
'   *               bInitBackground: Optional: whether or not to paint the background (not used anymore)
'   * Return:   Long: the handle to the dc created in memory
'   * Purpose:  Creates a memory dc so that all drawing takes place in memory.
'   ***********************************************************************
    ReleaseObjects ' releases objects if bitmaps needs to be recreated
    
    m_hDCMem = CreateCompatibleDC(hDCUserControl) ' create a dc
    m_hBmpMem = CreateCompatibleBitmap(hDCUserControl, lWidth, lHeight) ' create a bitmap
    m_hOldBmpMem = SelectObject(m_hDCMem, m_hBmpMem) '  select the new bitmap into the new dc, store the prev bitmap
    
    If bInitBackground Then ' when the background need to be painted
        ' paints the background
        DrawBackground m_hDCMem, , , lWidth, lHeight, GetBkColor(hDCUserControl)
    End If
    
    GetMemDC = m_hDCMem ' return the hdc

End Function

Public Sub BltMemDC(ByVal hDCUserControl As Long, lWidth As Long, lHeight As Long)
'   ***********************************************************************
'   * Params:   hDCUserControl: the dc of the user control to blit to, lWidth: the width to blit,
'   *               lHeight: the height to blit
'   * Purpose:  Blits the memory bitmap to the usercontrol.
'   ***********************************************************************
    BitBlt hDCUserControl, 0, 0, lWidth, lHeight, m_hDCMem, 0, 0, SRCCOPY ' blit the bitmap
End Sub

Private Sub Class_Terminate()
    ReleaseObjects ' release all objects
End Sub
Public Sub DrawBackground(ByVal hdc As Long, Optional lLeft As Long, Optional lTop As Long, Optional lWidth As Long, Optional lHeight As Long, _
                                            Optional vBackColor As Variant)
'   ***********************************************************************
'   * Params:   hdc: the dc to draw on, lLeft: Optional: the left of the rect, lTop: Optional: the top of the rect, lWidth: Optional:
'   *               the width of the rect, lHeight: Optional: the height of the rect, vBackColor: Optional: the backcolor for the dc
'   * Purpose:  Fills the rect with the color specified.
'   ***********************************************************************
    Dim r As RECT
    Dim lOldBackColor As Long
    Dim lBackColor As Long
    
'   ***** puts the dimensions into a rect structure
    r.Left = lLeft
    r.Top = lTop
    r.Bottom = r.Top + lHeight
    r.Right = r.Left + lWidth
'   *****

    If IsMissing(vBackColor) Then ' check to see if the backcolor was passed
        lBackColor = GetBkColor(hdc) ' use the backcolor of the dc
    Else ' the backcolor was passed
        lBackColor = GetBackColor(CLng(vBackColor)) ' returns the value of even system colors
    End If
    
    lOldBackColor = SetBkColor(hdc, lBackColor) ' set the back color of the dc
    
    ' fills the rect with the back color. Using ExtTextOut (without text) is quicker than FillRect
    ExtTextOut hdc, 0, 0, ETO_CLIPPED Or ETO_OPAQUE, r, "", 0, 0
    
    SetBkColor hdc, lOldBackColor ' reset the old backcolor
End Sub

Private Function CreateFont(sFontName As String, lFontHeight As Long, Optional bBold As Boolean, _
                    Optional bItalic As Boolean, Optional bStrikeOut As Boolean, Optional bUnderline As Boolean) As Long
'Private Function CreateFont(hdc As Long, sFontName As String, lFontHeight As Long, Optional bBold As Boolean, _
                    Optional bItalic As Boolean, Optional bStrikeOut As Boolean, Optional bUnderline As Boolean) As Long
'   ***********************************************************************
'   * Params:   Params: sFontName: the name of the font to create, lFontHeight: the size of the font, bBold: Optional: True/False,
'   *               bItalic: Optional: True/False, bStrikeOut: Optional: True/False, bUnderline: Optional: True/False
'   * Return:   Long: the handle to the font that was created.
'   * Purpose:  Creates a font and returns the handle to it.
'   ***********************************************************************
    Dim lfFont As LOGFONT ' the font structure to fill
    Dim aTempArray() As Byte ' byte array to hold the fontname
    Dim i As Integer
    
    lfFont.lfHeight = lFontHeight ' font height
    lfFont.lfWidth = 0 ' want to use zero. Figures out the width based on the height
    lfFont.lfEscapement = 0 ' no escapement
    lfFont.lfOrientation = lfFont.lfEscapement ' same as the escapement
    
    If bBold Then ' if true set the weight to the appropriate value
        lfFont.lfWeight = 700
    Else
        lfFont.lfWeight = 400
    End If
    
'   ***** font structure expects 0 or non zero (usually 1) for the value, so multiply by -1
    lfFont.lfItalic = bItalic * -1
    lfFont.lfUnderline = bUnderline * -1
    lfFont.lfStrikeOut = bStrikeOut * -1
'   *****

    lfFont.lfOutPrecision = OUT_DEFAULT_PRECIS
    lfFont.lfClipPrecision = OUT_DEFAULT_PRECIS
    
    lfFont.lfQuality = DEFAULT_QUALITY '
    lfFont.lfPitchAndFamily = DEFAULT_PITCH Or FF_DONTCARE
    lfFont.lfCharSet = DEFAULT_CHARSET
    
    ' converts the font name from unicode
    aTempArray = StrConv(sFontName & vbNullChar, vbFromUnicode)
    
'   ***** puts the font name into the byte array for face name
    For i = 0 To UBound(aTempArray)
        lfFont.lfFaceName(i) = aTempArray(i)
    Next i
'   *****

    CreateFont = CreateFontIndirect(lfFont) ' create the font and return the handle to it
    
End Function

Private Sub DrawText(hdc As Long, sText As String, rectCol As RECT, lOptions As Long, eColAlignment As GTAlignmentConstants)
'   ***********************************************************************
'   * Params:   hdc: the dc to draw on, sText: the text to draw, rectCol: the bounding rectangle,
'   *               lOptions: the desiredDrawText options for this purpose,eColAlignment: how to align the text (left, right, center)
'   * Purpose:  Draws the text that is passed in.
'   ***********************************************************************
    Dim sTempText As String
    
    Select Case eColAlignment
        Case vbLeftJustify:
            lOptions = lOptions Or DT_LEFT  ' add left justify to options
            sTempText = Space(2) & sText ' adds 2 spaces at the front of the text
        Case vbRightJustify:
            lOptions = lOptions Or DT_RIGHT ' adds right justify to options
            sTempText = sText & Space(2) ' adds 2 spaces at the back of the text
        Case Else: ' center
            lOptions = lOptions Or DT_CENTER ' add center to options
            sTempText = sText ' uses the text as is
    End Select
    
    DrawTextAPI hdc, sTempText, Len(sTempText), rectCol, lOptions ' draw the text
    
End Sub

Friend Sub PaintText(sText As String, sFontName As String, lLeft As Long, lTop As Long, lRight As Long, lBottom As Long, _
                lFontHeight As Long, lOptions As Long, Optional eColAlignment As GTAlignmentConstants = gtCenter, _
                Optional bBold As Boolean, Optional bItalic As Boolean, Optional bStrikeOut As Boolean, Optional bUnderline As Boolean, _
                Optional vBackColor, Optional vForeColor)
'   ***********************************************************************
'   * Params:   sText: the text to draw on the dc, sFontName: the font to use, lLeft: the left of the bounding rect, lTop: the top of
'   *               the bounding rect, lRight: the right edge of the bounding rect, lBottom: the bottom edge of the bounding rect,
'   *               lFontHeight: the size of the font to be created, lOptions: the DrawText constants to use, eColAlignment Optional:
'   *               whether the text should be left, right or centered, bBold: Optional: True/False, bItalice: Optional: True/False,
'   *               bStrikeOut: Optional: True/False, bUnderline: Optional: True/False, vBackColor: Optional: the backcolor of the dc,
'   *               vForeColor: Optional: the forecolor for the text
'   * Purpose:  Draws the text on the memory dc using the correct font and colors.
'   ***********************************************************************
    Dim hFont As Long ' the handle to the font
    Dim hFontOld As Long ' the previously selected font
    Dim r As RECT
    Dim lOldBackColor As Long ' the previous backcolor
    Dim lOldForeColor As Long ' the previous forecolor
    Dim lOldBackMode As Long ' the previous backmode
    
    ' creates the font and returns a handle to it
    hFont = CreateFont(sFontName, lFontHeight, bBold, bItalic, bStrikeOut, bUnderline)
'    hFont = CreateFont(m_hDCMem, sFontName, lFontHeight, bBold, bItalic, bStrikeOut, bUnderline)
    
    If hFont <> 0 Then ' as long as the font was created
        hFontOld = SelectObject(m_hDCMem, hFont) ' select the new font and save the old font
    End If
    
    ' set the backmode of the dc to transparent so the background shows around the text, save the previous backmode
    lOldBackMode = SetBkMode(m_hDCMem, BKMODE_TRANSPARENT)
    
    If Not IsMissing(vBackColor) Then
        lOldBackColor = SetBkColor(m_hDCMem, vBackColor) ' sets the backcolor. Not used anymore
    End If
    
    If Not IsMissing(vForeColor) Then
        lOldForeColor = SetTextColor(m_hDCMem, vForeColor) ' sets the text color
    End If
    
'   ***** create the bounding rect for the text
    r.Left = lLeft
    r.Top = lTop
    r.Bottom = lBottom
    r.Right = lRight
'   *****

    DrawText m_hDCMem, sText, r, lOptions, eColAlignment ' call the DrawText method of the class
    
    If hFont <> 0 Then ' if the font was created
        SelectObject m_hDCMem, hFontOld ' reselect the old font
        DeleteObject hFont ' delete the font that was created
    End If
    
    If Not IsMissing(vForeColor) Then 'only if previously set
        SetTextColor m_hDCMem, lOldForeColor 'reset the forecolor
    End If
    
    If Not IsMissing(vBackColor) Then 'only if previously set
        SetBkColor m_hDCMem, lOldBackColor ' reset the backcolor
    End If
    
    SetBkMode m_hDCMem, lOldBackMode ' reset the backmode
End Sub

Private Sub ReleaseObjects()
'   ***********************************************************************
'   * Purpose: Deletes the objects that were created.
'   ***********************************************************************

    If m_hBmpMem <> 0 Then ' checks to see if there is a bitmap
        SelectObject m_hDCMem, m_hOldBmpMem ' reselect the old bitmap
        
        DeleteObject m_hBmpMem ' delete the new bitmap
        DeleteDC m_hDCMem ' delete the dc
    End If
End Sub

Friend Function GetBackColor(lBackColor As OLE_COLOR) As OLE_COLOR
'   ***********************************************************************
'   * Params:   lBackColor: the backcolor. this could be a system color with the hiword of 8.
'   * Return:   OLE_COLOR: the value of the color
'   * Purpose:  Translates all colors (including system colors) to the actual color
'   ***********************************************************************

    Dim lColor As Long
    
    lColor = lBackColor ' holds the color
    
    If lColor And &H80000000 Then ' check for a system color
        lColor = lColor And &HFFFFFF ' ands with &HFFFFFF to get the 2 digit system color to be used with getsyscolor
        GetBackColor = GetSysColor(lColor) ' returns the actual color value
    Else ' not a system color
        GetBackColor = lColor 'returns the original color
    End If
    
End Function

