VERSION 5.00
Begin VB.UserControl GTGroupList 
   CanGetFocus     =   0   'False
   ClientHeight    =   1425
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2130
   PropertyPages   =   "GTGroupList.ctx":0000
   ScaleHeight     =   95
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   142
   ToolboxBitmap   =   "GTGroupList.ctx":0059
   Begin VB.Timer tmrTimer 
      Left            =   1230
      Top             =   1080
   End
End
Attribute VB_Name = "GTGroupList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'   ******************************************************************************
'   * Purpose:  This is the grouplist control.
'   * File:         GTGroupList.ctl
'   ******************************************************************************
Option Explicit

'   ***** Appearance constants
Public Enum GTAppearanceConstants
    gtFlat
    gt3D
End Enum
'   *****

'   ***** Borderstyle constants
Public Enum GTBorderStyleConstants
    gtNone
    gtFixedSingle
End Enum
'   *****

'   ***** OLEdrop constants
Public Enum GTOLEDropConstants
    gtOLEDropNone
    gtOLEDropManual
End Enum
'   *****

'   ***** scroll button constants
Private Const Up = 1
Private Const Down = 2
Private Const None = 4
Private Const Both = Up Or Down
'   *****
'   ***** area paint constants
Private Const Group = 1
Private Const Items = 2
Private Const ActiveItem = 4
Private Const ScrollButton = 8
Private Const All = Group Or Items Or ActiveItem Or ScrollButton
'   *****
'   ***** Default Property Values:
Const m_def_Appearance = 1
Const m_def_BorderStyle = 1
Const m_def_MaskColor = vbWhite
Const m_def_UseMaskColor = True
Const m_def_GroupForeColor = vbButtonText
Const m_def_ForeColor = vbHighlightText
Const m_def_BackColor = vb3DShadow
Const m_def_ToolTips = True
Const m_def_ToolTipsDelay = 2000
'   *****

'   ***** Variables
Private WithEvents m_oGroups As GTGroups
Attribute m_oGroups.VB_VarHelpID = -1
Private m_iOffset As Integer
Private m_iScalePerPixel As Integer
Private m_oCurrentGroup As GTGroup
Private m_oSelectedGroup As GTGroup
Private WithEvents m_oLargeImages As GTListImages
Attribute m_oLargeImages.VB_VarHelpID = -1
Private WithEvents m_oSmallImages As GTListImages
Attribute m_oSmallImages.VB_VarHelpID = -1
Private m_oActiveGroupItem As GTGroupItem
Private m_CDrawRect As CDrawRect
Private m_lGroupHeight As Long
Private m_lGroupItemTextHeight As Long
Private m_lItemBkStart As Long
Private m_lItemBkStop As Long
Private m_byPrevScrollButton As Byte
Private m_bRedraw As Boolean
Private WithEvents m_CToolTips As CToolTips
Attribute m_CToolTips.VB_VarHelpID = -1
Private m_CPaint As CPaint
Private m_oSelectedGroupItem As GTGroupItem
'   *****

'   ***** Property Variables:
Dim m_eAppearance As GTAppearanceConstants
Dim m_eBorderStyle As GTBorderStyleConstants
Dim m_bUseMaskColor As Boolean
Dim m_lGroupForeColor As OLE_COLOR
Private m_oFont As StdFont
Private m_oGroupFont As StdFont
Private m_lForeColor As OLE_COLOR
Private m_lBackColor As OLE_COLOR
'   *****

'   ***** Event Declarations:
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_HelpID = 129
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when you press and release a mouse button and then press and release it again over an object."
Attribute DblClick.VB_HelpID = 106
Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Attribute KeyDown.VB_HelpID = 32
Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Attribute KeyPress.VB_HelpID = 36
Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Attribute KeyUp.VB_HelpID = 32
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Attribute MouseDown.VB_HelpID = 124
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Attribute MouseMove.VB_HelpID = 121
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Attribute MouseUp.VB_HelpID = 124
Event OLECompleteDrag(Effect As Long)
Attribute OLECompleteDrag.VB_Description = "OLECompleteDrag event"
Attribute OLECompleteDrag.VB_HelpID = 120
Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute OLEDragDrop.VB_Description = "OLEDragDrop event"
Attribute OLEDragDrop.VB_HelpID = 119
Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
Attribute OLEDragOver.VB_Description = " OLEDragOver event"
Attribute OLEDragOver.VB_HelpID = 118
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Attribute OLEGiveFeedback.VB_Description = "OLEGiveFeedback event"
Attribute OLEGiveFeedback.VB_HelpID = 116
Event OLESetData(Data As DataObject, DataFormat As Integer)
Attribute OLESetData.VB_Description = "OLESetData event"
Attribute OLESetData.VB_HelpID = 117
Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
Attribute OLEStartDrag.VB_Description = "OLEStartDrag event"
Attribute OLEStartDrag.VB_HelpID = 115
Event GroupClick(Group As GTGroup)
Attribute GroupClick.VB_Description = "Occurs when a user clicks a Group object."
Attribute GroupClick.VB_HelpID = 74
Event GroupItemClick(GroupItem As GTGroupItem)
Attribute GroupItemClick.VB_Description = "Occurs when a GroupItem object is clicked."
Attribute GroupItemClick.VB_HelpID = 56
Attribute GroupItemClick.VB_MemberFlags = "200"
'   *****

'   ***** Returns/sets whether tooltips will be shown
Public Property Get ToolTips() As Boolean
Attribute ToolTips.VB_Description = "Enables/disables ToolTips for GroupItems."
Attribute ToolTips.VB_HelpID = 89
Attribute ToolTips.VB_ProcData.VB_Invoke_Property = ";Misc"
    ToolTips = m_CToolTips.ToolTips
End Property
Public Property Let ToolTips(ByVal New_ToolTips As Boolean)
    If m_CToolTips.ToolTips = New_ToolTips Then
        Exit Property
    End If
    m_CToolTips.ToolTips = New_ToolTips
    PropertyChanged "ToolTips"
End Property
'   *****

'   ***** Returns/sets the ToolTipDelay property. This sets how long the mouse
'   ***** must be paused over a button before the tooltip is displayed.
Public Property Get ToolTipsDelay() As Long
Attribute ToolTipsDelay.VB_Description = "Amount of time before a tooltip appears when the mouse pauses over a GroupItem object."
Attribute ToolTipsDelay.VB_HelpID = 90
Attribute ToolTipsDelay.VB_ProcData.VB_Invoke_Property = ";Misc"
    ToolTipsDelay = m_CToolTips.ToolTipsDelay
End Property
Public Property Let ToolTipsDelay(ByVal New_ToolTipsDelay As Long)
    If m_CToolTips.ToolTipsDelay = New_ToolTipsDelay Then
        Exit Property
    End If
    m_CToolTips.ToolTipsDelay = New_ToolTipsDelay
    tmrTimer.Interval = New_ToolTipsDelay
    PropertyChanged "ToolTipsDelay"
End Property
'   *****

'   ***** Returns/sets the forecolor property for the groups
Public Property Let GroupForeColor(lForeColor As OLE_COLOR)
Attribute GroupForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute GroupForeColor.VB_HelpID = 35
Attribute GroupForeColor.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
    m_lGroupForeColor = lForeColor
    Paint Group
End Property
Public Property Get GroupForeColor() As OLE_COLOR
    GroupForeColor = m_lGroupForeColor
End Property
'   *****

'   ***** Returns a reference to the LargeImages collection
Public Property Get LargeImages() As GTListImages
Attribute LargeImages.VB_Description = "Returns a reference to a collection of ListImage objects."
Attribute LargeImages.VB_HelpID = 50
    Set LargeImages = m_oLargeImages
End Property
'   *****

'   ***** Returns a reference to the SmallImages collection
Public Property Get SmallImages() As GTListImages
Attribute SmallImages.VB_Description = "Returns a reference to a collection of ListImage objects."
Attribute SmallImages.VB_HelpID = 75
    Set SmallImages = m_oSmallImages
End Property
'   *****

'   ***** Returns/sets the active group. This will force the group
'   ***** to slide to the top.
Public Property Set SelectedGroup(oGroup As GTGroup)
Attribute SelectedGroup.VB_Description = "Returns a reference to the currently selected Group object."
Attribute SelectedGroup.VB_HelpID = 70
    Dim oTargetGroup As GTGroup
    
    If m_oSelectedGroup Is oGroup Then
        Exit Property
    End If
    
    If oGroup Is Nothing Then
        Err.Raise vbObjectError + 1054, , "SelectedGroup cannot be nothing."
        Exit Property
    End If
    
    If oGroup.Visible Then
        Set oTargetGroup = oGroup
    Else
        Set oTargetGroup = GetClosestVisibleGroup(oGroup)
        If oTargetGroup Is Nothing Then
            Exit Property
        End If
    End If
    
    Set m_oCurrentGroup = oTargetGroup
    Paint All, True
    Set m_oSelectedGroup = m_oCurrentGroup
    Set m_oGroups.SelectedGroup = m_oCurrentGroup
    
End Property
Public Property Get SelectedGroup() As GTGroup
    If m_oSelectedGroup Is Nothing Then
        Err.Raise vbObjectError + 1000, , "Invalid object"
        Exit Property
    End If
    Set SelectedGroup = m_oSelectedGroup
End Property
'   *****

'   ***** Returns a reference to the Groups collection
Public Property Get Groups() As GTGroups
Attribute Groups.VB_Description = "Returns a reference to a collection of Group objects."
Attribute Groups.VB_HelpID = 39
    Set Groups = m_oGroups
End Property
'   *****

'   ***** Returns/sets whether the control will appear 3D or Flat.
Public Property Get Appearance() As GTAppearanceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
Attribute Appearance.VB_HelpID = 22
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
    Appearance = m_eAppearance
End Property
Public Property Let Appearance(ByVal New_Appearance As GTAppearanceConstants)
    m_eAppearance = New_Appearance
    PropertyChanged "Appearance"
    CalcOffset
    Paint All
End Property
'   *****

'   ***** Returns/sets the backcolor for the groupitems
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the backcolor for the groupitem background for all GTGroup objects."
Attribute BackColor.VB_HelpID = 5000
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = m_lBackColor
End Property
Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    m_lBackColor = New_BackColor
    Paint All
    PropertyChanged "BackColor"
End Property
'   *****

'   ***** Returns/sets whether the control will have a border or not
Public Property Get BorderStyle() As GTBorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_HelpID = 2
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_eBorderStyle
End Property
Public Property Let BorderStyle(ByVal New_BorderStyle As GTBorderStyleConstants)
    m_eBorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
    CalcOffset
    Paint All
End Property
'   *****

'   ***** Ver 1.0a No longer used
'Private Sub GTMsgHook1_Message(ByVal hWnd As Long, ByVal MsgID As Long, ByVal wParam As Long, ByVal lParam As Long)
''   ****************************************************************************
''   * Params:   hWnd: the window handle that is subclassed, MsgID: the message that was intercepted,
''   *               wParam: the wParam of the message, lParam: the lParam of the message
''   * Purpose:  Fires when a Message in the Messages collection for the Window is intercepted
''   ****************************************************************************
'    Select Case MsgID
'        Case WM_SYSCOLORCHANGE:
'            Paint All
'    End Select
'
'End Sub
'   *****

Private Sub m_CToolTips_TimerIntervalChanged(lInterval As Long)
'   ****************************************************************************
'   * Params:   lInterval: the new time to set the Interval property of the timer
'   * Purpose:  Fires when the Interval property of the Timer needs to be changed.
'   ****************************************************************************
    tmrTimer.Interval = lInterval
End Sub

Private Sub m_CToolTips_TimerStatusChanged(bEnabled As Boolean)
'   ****************************************************************************
'   * Params:   bEnabled: Whether the Timer should be enabled or not.
'   * Purpose:  Fires when the Enabled property of the Timer needs to be changed.
'   ****************************************************************************
    tmrTimer.Enabled = bEnabled
End Sub

Private Sub m_oGroups_Added(oGroup As GTGroup)
'   ***********************************************************************
'   * Params:   oGroup: the GTGroup object that was added
'   * Purpose:  Fired when a GTGroup object is added to the Groups collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    If oGroup.Index = 1 Or m_oSelectedGroup Is Nothing Then
        Set m_oCurrentGroup = oGroup
        Set m_oSelectedGroup = oGroup
        Set m_oGroups.SelectedGroup = oGroup
    End If
    
    Paint All
    
    If Not Ambient.UserMode Then
        PropertyChanged "Groups"
    End If
End Sub

Private Sub m_oGroups_Changed(oGroup As GTGroup, sProperty As String)
'   ***********************************************************************
'   * Params:   oGroup: the GTGroup object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTGroup object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    Dim oTargetGroup As GTGroup
    
    Select Case sProperty
        Case "View":
            Paint Items
        Case "GroupItemBackColor", "GroupItemForeColor":
            If oGroup Is m_oSelectedGroup Then
                Paint Items
            End If
        Case "Alignment", "Text":
            Paint Group
        Case "Visible":
            If Not oGroup.Visible Then
                If oGroup Is m_oSelectedGroup Then
                    Set m_oSelectedGroup = GetClosestVisibleGroup(oGroup)
                End If
            End If
            Paint All
    End Select
            
    If Not Ambient.UserMode Then
        PropertyChanged "Groups"
    End If
End Sub


Private Sub m_oGroups_GroupItemAdded(oGroup As GTGroup, oGroupItem As GTGroupItem)
'   ***********************************************************************
'   * Params:   oGroup: the parent of the object, oGroupItem: the GTGroupItem object that was added
'   * Purpose:  Fired when a GTGroupItem object is added to the GroupItems collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    If oGroup Is m_oSelectedGroup Then
        Paint Items
    End If
End Sub


Private Sub m_oGroups_GroupItemChanged(oGroup As GTGroup, oGroupItem As GTGroupItem, sProperty As String)
'   ***********************************************************************
'   * Params:   oGroup: the parent of the object, oGroupItem: the GTGroupItem
'   *               object that was changed, sProperty: the property that was changed.
'   * Purpose:  Fired when a GTGroupItem object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    If oGroup Is m_oSelectedGroup Then
        Paint Items
    End If
End Sub

Private Sub m_oGroups_GroupItemRemoved(oGroup As GTGroup, ByVal oGroupItem As GTGroupItem)
'   ***********************************************************************
'   * Params:   oGroup: the parent of the object, oGroupItem: the GTGroupItem object that was removed
'   * Purpose:  Fired when a GTGroupItem object is removed from the GroupItems collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   * Modified: Ver 1.0a    Reinitalize the activegroupitem when removing the active groupitem
'   ***********************************************************************
'   ***** Ver 1.0a Reinitalize the activegroupitem when removing
    If oGroupItem Is m_oActiveGroupItem Then
        Set m_oActiveGroupItem = Nothing
    End If
'   *****
    If oGroup Is m_oSelectedGroup Then
        Paint Items
    End If
End Sub

Private Sub m_oGroups_Removed(ByVal oGroup As GTGroup)
'   ***********************************************************************
'   * Params:   oGroup: the GTGroup object that was removed
'   * Purpose:  Fired when a GTGroup object is removed from the Groups collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   ***********************************************************************
    If m_oGroups.Count = 0 Then
        Set m_oSelectedGroup = Nothing
    ElseIf m_oSelectedGroup Is oGroup Then ' when the selected group was deleted, reset to the first group
        ' have to be the same otherwise draws incorrectly
        Set m_oCurrentGroup = m_oGroups(1)
        Set m_oSelectedGroup = m_oCurrentGroup
    Else
        ' have to be the same otherwise draws incorrectly
        Set m_oCurrentGroup = m_oSelectedGroup
    End If
    
    Set m_oGroups.SelectedGroup = m_oSelectedGroup
    
    Paint All
    
    If Not Ambient.UserMode Then
        PropertyChanged "Groups"
    End If
End Sub

Private Sub m_oLargeImages_ImageAdded(oListImage As GTListImage)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was added
'   * Purpose:  Fired when a GTListImage object is added to the LargeImages collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    If oListImage.Index = 1 Then
        m_oGroups.LargePicHeight = m_oLargeImages.Height
        m_oGroups.LargePicWidth = m_oLargeImages.Width
    End If
    PropertyChanged "Images"
End Sub

Private Sub m_oLargeImages_ImageChanged(oListImage As GTListImage, sProperty As String)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTListImage object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub m_oLargeImages_ImageRemoved(oListImage As GTListImage)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was removed
'   * Purpose:  Fired when a GTListImage object is removed from the LargeImages collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub m_oSmallImages_ImageAdded(oListImage As GTListImage)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was added
'   * Purpose:  Fired when a GTListImage object is added to the SmallImages collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    If oListImage.Index = 1 Then
        m_oGroups.SmallPicHeight = m_oSmallImages.Height
        m_oGroups.SmallPicWidth = m_oSmallImages.Width
    End If
    PropertyChanged "Images"
End Sub

Private Sub m_oSmallImages_ImageChanged(oListImage As GTListImage, sProperty As String)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTListImage object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub m_oSmallImages_ImageRemoved(oListImage As GTListImage)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was removed
'   * Purpose:  Fired when a GTListImage object is removed from the SmallImages collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub tmrTimer_Timer()
'   ****************************************************************************
'   * Purpose:  Fires interval has expired. This will call the TimerExpired method
'   *               of the CToolTips. This had to be done this way because adding a reference to
'   *               the timer doesn't let the Terminate event fire and there for holds the instance
'   *               of the control in memory and causes major problems
'   ****************************************************************************
    m_CToolTips.TimerExpired
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
'   ****************************************************************************
'   * Params:   PropertyName: the name of the property that was changed.
'   * Purpose:  Fires when one of the Ambient properties was changed.
'   ****************************************************************************
    Select Case PropertyName
        Case "ScaleUnits":
            CalculateScaleUnits
            
    End Select
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

'   ***** Returns/sets the enabled property
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_HelpID = 18
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property
'   *****

'   ***** Returns/sets the Font object for the groupitems. The whole font object needs to change otherwise there
'   ***** is no notification (ie. changing bold.); this is limitation of VB
Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_HelpID = 31
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512
    Set Font = m_oFont
End Property
Public Property Set Font(ByVal New_Font As StdFont)
    Set m_oFont = New_Font
    PropertyChanged "Font"
    CalcGroupItemHeight
    Paint All
End Property
'   *****

'   ***** Returns/sets the GroupFont object for the groups. The whole font object needs to change otherwise there
'   ***** is no notification (ie. changing bold.); this is limitation of VB
Public Property Get GroupFont() As StdFont
Attribute GroupFont.VB_Description = "Returns a Font object."
Attribute GroupFont.VB_HelpID = 33
Attribute GroupFont.VB_ProcData.VB_Invoke_Property = ";Font"
    Set GroupFont = m_oGroupFont
End Property
Public Property Set GroupFont(ByVal New_Font As StdFont)
    Set m_oGroupFont = New_Font
    PropertyChanged "GroupFont"
    CalcGroupHeight
    m_oGroups.TextHeight = m_lGroupHeight
    Paint All
End Property
'   *****

'   ***** Returns/sets the forecolor property for the groupitems. This color will be used when
'   ***** GroupItemForeColor for the Group is Null.
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_HelpID = 5000
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = m_lForeColor
End Property
Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_lForeColor = New_ForeColor
    PropertyChanged "ForeColor"
    Paint Items
End Property
'   *****

'   ***** Returns the hWnd of the usercontrol.
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
Attribute hWnd.VB_HelpID = 43
Attribute hWnd.VB_UserMemId = -515
    hWnd = UserControl.hWnd
End Property
'   *****

Private Sub UserControl_Initialize()
'   ****************************************************************************
'   * Purpose:  Fires when the control is first instaniated. The control has not
'   *               yet been sited on the container. Initalizes certain variables and Messages
'   *               are added to be intercepted.
'   * Modified: Ver 1.0a    Removed code to add window to subclass. No longer needed
'   ****************************************************************************
'   ***** Ver 1.0a No longer used
'    Dim oWindow As GTWindow
'    Dim oMessage As GTMessage
'   *****

    Set m_CPaint = New CPaint
    Set m_CDrawRect = New CDrawRect
    Set m_oGroups = New GTGroups
    Set m_oLargeImages = New GTListImages
    Set m_oSmallImages = New GTListImages
    
'   ***** Needs an hdc to create the mask when the image is first
'   ***** added
    m_oLargeImages.DestinationDC = hdc
    m_oSmallImages.DestinationDC = hdc
'   *****

'   ***** Ver 1.0a No longer used
''   ***** Add the hwnd of the user control to be subclassed  and add the
''   ***** WM_SYSCOLORCHANGE constant. This is so the background
''   ***** changes when system color changes.
'    Set oWindow = GTMsgHook1.Windows.Add(, , , UserControl.hWnd)
'    If Not oWindow Is Nothing Then
'        Set oMessage = oWindow.Messages.Add(, , WM_SYSCOLORCHANGE, "WM_SYSCOLORCHANGE")
'    End If
''   *****
'   *****
    Set m_CToolTips = New CToolTips
    
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

'   ***** Returns/sets the MaskColor property. This property defines the part of an image
'   ***** to be transparent
Public Property Get MaskColor() As OLE_COLOR
Attribute MaskColor.VB_Description = "Returns/sets the color that specifies transparent areas in the MaskPicture."
Attribute MaskColor.VB_HelpID = 54
Attribute MaskColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    MaskColor = m_oLargeImages.MaskColor
End Property
Public Property Let MaskColor(ByVal New_MaskColor As OLE_COLOR)
    m_oLargeImages.MaskColor = New_MaskColor
    m_oSmallImages.MaskColor = New_MaskColor
    PropertyChanged "MaskColor"
    
    Paint Items
End Property
'   *****

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is down. ToolTips are turned off.
'   *               This will determine that if a group, groupitem, or scrollbutton
'   *               was clicked or nothing at all. The group will become active
'   *               and redraw the groups. Will show the group sliding into
'   *               place. For groupitems, an inset rect will be drawn around
'   *               the groupitem. For scrollbuttons, the button will drawn in
'   *               the down state.
'   * Modified: 1.0a    Added code to check if control is active after coming
'   *                           returning from GroupItemClick.
'   ****************************************************************************
    Dim oGroup As GTGroup
    Dim oGroupItem As GTGroupItem
    Dim byScrollButton As Byte
    
    RaiseEvent MouseDown(Button, Shift, x, y)
    
    If m_oGroups.Count = 0 Then
        Exit Sub
    End If
    
    If Not (Button = vbLeftButton) Then
        Exit Sub
    End If
    
    CaptureMouse x, y, Button, True ' turn capture off
    
'   ***** Check for a scrollbutton and then processes it
    byScrollButton = ScrollButtonHitTest(x, y)
    m_byPrevScrollButton = byScrollButton
    If Not byScrollButton = None Then
        Paint ScrollButton, , byScrollButton, True
        Exit Sub
    End If
'   *****

'   ***** Checks for a group and repaints with the new group
'   ***** Does nothing when the group is the selectedgroup
    Set oGroup = GroupHitTest(x, y)
    If Not oGroup Is Nothing Then
        
        If Not oGroup Is m_oSelectedGroup Then
            Set m_oCurrentGroup = oGroup
            Paint All, True
        End If
        
        RaiseEvent GroupClick(oGroup)
        
        If Not oGroup Is m_oSelectedGroup Then
            Set m_oSelectedGroup = oGroup
            Set m_oGroups.SelectedGroup = oGroup
        End If
        
        Exit Sub
    End If
'   *****

'   ***** Checks for a groupitem. If found the groupitems get
'   ***** repainted.
    Set oGroupItem = GroupItemsHitTest(x, y)
    If Not oGroupItem Is Nothing Then
        
        m_CToolTips.MouseDown
        
        If oGroupItem Is m_oActiveGroupItem Then
            m_oActiveGroupItem.Down = True
'   ***** set the selectedgroupitem to the active groupitem;
'   ***** This is used when moving the mouse off the groupitem
'   ***** when the mouse is down
            Set m_oSelectedGroupItem = m_oActiveGroupItem
'   *****
            Paint ActiveItem

            RaiseEvent GroupItemClick(oGroupItem)
                    
'   ***** Bug #734 Ver 1.0a Redraws active item when mouse not over control
            If Not IsGroupListActive() Then
                m_oActiveGroupItem.Down = False
                Set m_oSelectedGroupItem = Nothing
                Set m_oActiveGroupItem = Nothing
                Paint Items
            End If
'   *****
        End If

    End If
'   *****

End Sub

'   ***** Returns/sets the MouseIcon property
Public Property Get MouseIcon() As StdPicture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
Attribute MouseIcon.VB_HelpID = 58
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = ";Misc"
    Set MouseIcon = UserControl.MouseIcon
End Property
Public Property Set MouseIcon(ByVal New_MouseIcon As StdPicture)
    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property
'   *****

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is moved over the user control.
'   *               If the mouse is over a group, nothing happens. If over a
'   *               groupitem, a raised rect will be drawn, if the mouse is down
'   *               and a groupitem is active and the mouse moves off the
'   *               groupitem, the rect around it will be drawn raised; when
'   *               moved back over the groupitem, the rect will be drawn
'   *               inset. If over a scrollbutton and the mouse is down and
'   *               the mouse is moved off the scrollbutton,. the button will
'   *               be drawn in the up state. If move back over the scrollbutton
'   *               the button will be drawn in the down state.
'   ****************************************************************************
    Dim oGroupItem As GTGroupItem
    
    If Not (Button = vbLeftButton) Then
        CaptureMouse x, y, Button
    End If
    
    If m_oGroups.Count > 0 Then
'   ***** Checks to see if over a groupitem. This is so the active rect
'   ***** can be drawn around the groupitem. If not over a groupitem,
'   ***** the tooltips are turned off
        Set oGroupItem = GroupItemsHitTest(x, y)
        If Not oGroupItem Is Nothing Then
            m_CToolTips.MouseMove UserControl.hWnd, oGroupItem
            If oGroupItem Is m_oActiveGroupItem Then
                
'   ***** Used when the left button is down whether to show a raised active rect or
'   ***** inset
                If Button And vbLeftButton Then
                    If m_oActiveGroupItem Is m_oSelectedGroupItem Then
                        If Not m_oSelectedGroupItem.Down Then
                            m_oActiveGroupItem.Down = True
                            Paint ActiveItem
                        End If
                    End If
                End If
'   *****

            Else
                Set m_oActiveGroupItem = oGroupItem
                Paint Items
            End If
        Else
            m_CToolTips.HideToolTip
            
            If Button And vbLeftButton Then
                If Not m_oActiveGroupItem Is Nothing Then
                    m_oActiveGroupItem.Down = False
                End If
                Paint ActiveItem
            Else
                If Not m_oActiveGroupItem Is Nothing Then
                    Set m_oActiveGroupItem = Nothing
                    Set m_oSelectedGroupItem = Nothing
                    Paint Items
                End If
            End If
        End If
    End If
'   *****

    RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

'   ***** Returns/sets the MousePointer constant.
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
Attribute MousePointer.VB_HelpID = 59
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Misc"
    MousePointer = UserControl.MousePointer
End Property
Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property
'   *****

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is released. This will turn tooltips
'   *               back on. If over a groupitem, the groupitem will be drawn
'   *               with a raised rect and the GroupItemClick event will
'   *               be fired. The Active and Down properties will be set to false.
'   *               If over a scrollbutton, the button will be drawn in the up state.
'   *               The buttons will be redraw scrolled. If over a groupitem
'   ****************************************************************************
    Dim byScrollButton As Byte
    
    CaptureMouse x, y, Button ' captures the mouse
    
    If m_oGroups.Count > 0 And Button = vbLeftButton Then
'   ***** If there is an active groupitem, then reset the down property
'   ***** and repaint the groupitems
        If Not m_oActiveGroupItem Is Nothing Then
            If m_oActiveGroupItem.Down Then
                m_oActiveGroupItem.Down = False
                Paint Items
            End If
                        
'   ***** set selectedgroupitem.down to false regardless of the activegroupitem
            If Not m_oSelectedGroupItem Is Nothing Then
                m_oSelectedGroupItem.Down = False
            End If
'   *****
        End If
'   *****

'   ***** Check to see if over a scrollbar and sets the scrolloffset for the
'   ***** selected group. Also repaints the scrollbuttons
        byScrollButton = ScrollButtonHitTest(x, y)
        If Not byScrollButton = None Then
            If m_byPrevScrollButton = byScrollButton Then
                SetScrollOffset byScrollButton
            End If
        End If
        Paint Items, , byScrollButton, True
    End If
'   *****

    RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

'   ***** OLE Drag/Drop events
Private Sub UserControl_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub

Public Sub OLEDrag()
Attribute OLEDrag.VB_Description = "Starts an OLE drag/drop event with the given control as the source."
Attribute OLEDrag.VB_HelpID = 135
    UserControl.OLEDrag
End Sub

Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, x, y)
End Sub

Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, x, y, State)
End Sub

Private Sub UserControl_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub

Private Sub UserControl_OLESetData(Data As DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub

Private Sub UserControl_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub
'   *****

'   Returns/sets the OLEDropMode property.
Public Property Get OLEDropMode() As GTOLEDropConstants
Attribute OLEDropMode.VB_Description = "Returns/Sets whether this control can act as an OLE drop target."
Attribute OLEDropMode.VB_HelpID = 62
Attribute OLEDropMode.VB_ProcData.VB_Invoke_Property = ";Misc"
    OLEDropMode = UserControl.OLEDropMode
End Property
Public Property Let OLEDropMode(ByVal New_OLEDropMode As GTOLEDropConstants)
    UserControl.OLEDropMode() = New_OLEDropMode
    PropertyChanged "OLEDropMode"
End Property
'   *****

'   ***** Returns/sets the UseMaskColor property. This is used for drawing
'   ***** pictures transparent and is used in conjunction with the MaskColor property.
Public Property Get UseMaskColor() As Boolean
Attribute UseMaskColor.VB_Description = "Returns/sets a value which determines if the ImageList control will use the MaskColor property."
Attribute UseMaskColor.VB_HelpID = 93
Attribute UseMaskColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    UseMaskColor = m_oLargeImages.UseMaskColor
End Property
Public Property Let UseMaskColor(ByVal New_UseMaskColor As Boolean)
    m_oLargeImages.UseMaskColor = New_UseMaskColor
    m_oSmallImages.UseMaskColor = New_UseMaskColor
    PropertyChanged "UseMaskColor"
    
    Paint Items
End Property
'   *****

Public Function HitTest(x As Single, y As Single) As GTGroupItem
Attribute HitTest.VB_Description = "Returns a reference to the GroupItem object located at the coordinates of x and y. Used with drag and drop operations."
Attribute HitTest.VB_HelpID = 3
'   *****************************************************************************
'   * Params:   X: the left point, Y: the top point
'   * Return:   GTGroupItem: a GTGroupItem object if X,Y intersects a
'   *               GroupItem, Nothing if not
'   * Purpose:  Returns a GroupItem if the X,Y point if over a GroupItem.
'   *****************************************************************************
    Set HitTest = GroupItemsHitTest(x, y)
End Function

Private Sub UserControl_InitProperties()
'   *************************************************************************
'   * Purpose:  Intializes the property variables . This is fired when a
'   *               control is first instanciated.
'   *************************************************************************
    m_bRedraw = False
    
    m_eAppearance = gt3D
    m_eBorderStyle = gtFixedSingle
    Set m_oFont = Ambient.Font
    CalcGroupItemHeight
    Set m_oGroupFont = Ambient.Font
    CalcGroupHeight
    
    UserControl.BackColor = m_def_BackColor
    m_lBackColor = m_def_BackColor
    
    m_lGroupForeColor = m_def_GroupForeColor
    m_lForeColor = m_def_ForeColor
    
    m_oLargeImages.UseMaskColor = False
    m_oSmallImages.UseMaskColor = False
    
    m_oLargeImages.UseMaskColor = m_def_UseMaskColor
    m_oSmallImages.UseMaskColor = m_def_UseMaskColor
    
    m_oLargeImages.MaskColor = m_def_MaskColor
    m_oSmallImages.MaskColor = m_def_MaskColor
    
    m_oGroups.LargePicHeight = m_oLargeImages.Height
    m_oGroups.LargePicWidth = m_oLargeImages.Width
    m_oGroups.SmallPicHeight = m_oSmallImages.Height
    m_oGroups.SmallPicWidth = m_oSmallImages.Width
    
    m_oGroups.TextHeight = m_lGroupHeight
    
    m_CToolTips.ToolTips = m_def_ToolTips
    m_CToolTips.ToolTipsDelay = m_def_ToolTipsDelay
    tmrTimer.Interval = m_CToolTips.ToolTipsDelay
    
'   ***** gets the number of scaleunits per pixel based on the container's scalemode
    CalculateScaleUnits
'   *****

'   ***** calculates the offset from the left and top based on the appearance and
'   ***** borderstyle properties
    CalcOffset
'   *****
    
    m_bRedraw = True
    
'   ***** Ver 1.0a No longer used
''   ***** turns on subclassing. Turn off for debugging
'#If DEBUG_SWITCH = 2 Then
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = 1 Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
''   *****
'   *****
    Paint All
End Sub

Private Sub UserControl_Paint()
'   **************************************************************
'   * Purpose:  Fired when the control needs to be repainted.
'   *               Calls the internal Paint proc. Not used because
'   *               autoredraw is used.
'   **************************************************************
    Paint All
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'   *************************************************************************
'   * Purpose:  Retrieves the properties from the property bag for those
'   *               properties that can be set at designtime or thru the proppages.
'   *               The control is sited on the container that is point.
'   *************************************************************************
    Dim lMaskColor As OLE_COLOR
    Dim bUseMaskColor As Boolean
    
    m_bRedraw = False
    
    m_lBackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    UserControl.BackColor = m_lBackColor
        
    m_eAppearance = PropBag.ReadProperty("Appearance", gt3D)
    m_eBorderStyle = PropBag.ReadProperty("BorderStyle", gtFixedSingle)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    
    Set m_oFont = PropBag.ReadProperty("Font", Ambient.Font)
    CalcGroupItemHeight
    Set m_oGroupFont = PropBag.ReadProperty("GroupFont", Ambient.Font)
    CalcGroupHeight
    
    m_lForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    m_lGroupForeColor = PropBag.ReadProperty("GroupForeColor", m_def_GroupForeColor)
    
    m_CToolTips.ToolTips = PropBag.ReadProperty("ToolTips", m_def_ToolTips)
    m_CToolTips.ToolTipsDelay = PropBag.ReadProperty("ToolTipsDelay", m_def_ToolTipsDelay)
    tmrTimer.Interval = m_CToolTips.ToolTipsDelay
    
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    UserControl.OLEDropMode = PropBag.ReadProperty("OLEDropMode", 0)
    bUseMaskColor = PropBag.ReadProperty("UseMaskColor", m_def_UseMaskColor)
    m_oLargeImages.UseMaskColor = bUseMaskColor
    m_oSmallImages.UseMaskColor = bUseMaskColor
    
    m_oLargeImages.Width = PropBag.ReadProperty("LargeImagesWidth", 32)
    m_oLargeImages.Height = PropBag.ReadProperty("LargeImagesHeight", 32)
    m_oSmallImages.Width = PropBag.ReadProperty("SmallImagesWidth", 16)
    m_oSmallImages.Height = PropBag.ReadProperty("SmallImagesHeight", 16)
    
    m_oGroups.LargePicHeight = m_oLargeImages.Height
    m_oGroups.LargePicWidth = m_oLargeImages.Width
    m_oGroups.SmallPicHeight = m_oSmallImages.Height
    m_oGroups.SmallPicWidth = m_oSmallImages.Width
    
    lMaskColor = PropBag.ReadProperty("MaskColor", m_def_MaskColor)
    m_oLargeImages.MaskColor = lMaskColor
    m_oSmallImages.MaskColor = lMaskColor
    
    m_oGroups.TextHeight = m_lGroupHeight
    
'   ***** reads the properties for the collections. These are the properties set in
'   ***** the prop pages
    m_oLargeImages.ReadObjectProps PropBag, "LargeImages"
    m_oSmallImages.ReadObjectProps PropBag, "SmallImages"
    ReadObjectProps PropBag
'   *****

'   ***** gets the number of scaleunits per pixel based on the container's scalemode
    CalculateScaleUnits
'   *****

'   ***** calculates the offset from the left and top based on the appearance and
'   ***** borderstyle properties
    CalcOffset
'   *****
    
    m_bRedraw = True
    
'   ***** Ver 1.0a No longer used
''   ***** turns on subclassing. Turn off for debugging
'#If DEBUG_SWITCH = 2 Then
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = 1 Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
''   *****
'   *****

    Paint All
End Sub

Private Sub UserControl_Resize()
'   **************************************************************************
'   * Purpose:  Fired when the control is resized. Passes the
'   *               scalewidth - offset and scaleheight -offset to m_oGroups.
'   *               Repaints the whole control.
'   **************************************************************************
    m_oGroups.Move ScaleWidth - m_iOffset, ScaleHeight - m_iOffset
    Paint All
End Sub

Private Sub UserControl_Terminate()
'   **************************************************************************
'   * Purpose:  Fired when the control is destroyed gracefully. Doesn't
'   *               occur when the user hits Stop or end. Releases all objects.
'   *               and cleans up.
'   **************************************************************************
'   ***** Ver 1.0a No longer used
'    GTMsgHook1.Subclass = False
'   *****

    Set m_CPaint = Nothing
    Set m_CToolTips = Nothing
    Set m_CDrawRect = Nothing
    Set m_oGroups = Nothing
    m_oLargeImages.Clear
    m_oSmallImages.Clear
    Set m_oLargeImages = Nothing
    Set m_oSmallImages = Nothing
    Set m_oGroupFont = Nothing
    Set m_oActiveGroupItem = Nothing
    Set m_oSelectedGroupItem = Nothing
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
'   **************************************************************************
'   * Purpose:  Fired at designtime when properties have been changed.
'   *               Saves the properties in the property bag.
'   **************************************************************************

    Call PropBag.WriteProperty("Appearance", m_eAppearance, gt3D)
    Call PropBag.WriteProperty("BackColor", m_lBackColor, m_def_BackColor)
    Call PropBag.WriteProperty("BorderStyle", m_eBorderStyle, gtFixedSingle)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", m_oFont)
    Call PropBag.WriteProperty("ForeColor", m_lForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("GroupFont", m_oGroupFont)
    Call PropBag.WriteProperty("GroupForeColor", m_lGroupForeColor, m_def_GroupForeColor)
    Call PropBag.WriteProperty("MaskColor", m_oLargeImages.MaskColor, m_def_MaskColor)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
    Call PropBag.WriteProperty("OLEDropMode", UserControl.OLEDropMode, 0)
    Call PropBag.WriteProperty("UseMaskColor", m_oLargeImages.UseMaskColor, m_def_UseMaskColor)
    Call PropBag.WriteProperty("LargeImagesWidth", m_oLargeImages.Width, 32)
    Call PropBag.WriteProperty("LargeImagesHeight", m_oLargeImages.Height, 32)
    Call PropBag.WriteProperty("SmallImagesWidth", m_oSmallImages.Width, 16)
    Call PropBag.WriteProperty("SmallImagesHeight", m_oSmallImages.Height, 16)
    Call PropBag.WriteProperty("ToolTips", m_CToolTips.ToolTips, m_def_ToolTips)
    Call PropBag.WriteProperty("ToolTipsDelay", m_CToolTips.ToolTipsDelay, m_def_ToolTipsDelay)
        
    If Not Ambient.UserMode Then
'   ***** Write the value for the collections when changed thru the prop pages
        m_oLargeImages.WriteObjectProps PropBag, "LargeImages"
        m_oSmallImages.WriteObjectProps PropBag, "SmallImages"
        WriteObjectProps PropBag
'   *****
    End If
    
End Sub
Private Sub CalculateScaleUnits()
'   *********************************************************************************
'   * Purpose:  Calculates the number of scale units per pixel because all
'   *               drawing is based on pixels. This allows the values to be returned
'   *               in the Scale that user is expecting. This is based on the ScaleMode
'   *               of the container.
'   *********************************************************************************
    Dim iScalePerPixel As Integer
    
    Select Case Ambient.ScaleUnits
        Case "Twip":
            iScalePerPixel = ScaleX(1, vbPixels, vbTwips)
        Case "Pixel":
            iScalePerPixel = 1
        Case "Inch":
            iScalePerPixel = ScaleX(1, vbPixels, vbInches)
        Case "User":
            iScalePerPixel = 1
'            iScalePerPixel = ScaleX(1, vbPixels, vbUser)
        Case "Point":
            iScalePerPixel = ScaleX(1, vbPixels, vbPoints)
        Case "Millimeter":
            iScalePerPixel = ScaleX(1, vbPixels, vbMillimeters)
        Case "Centimeter":
            iScalePerPixel = ScaleX(1, vbPixels, vbCentimeters)
    End Select
    
    m_oGroups.ScalePerPixel = iScalePerPixel ' passed to the collection
    m_iScalePerPixel = iScalePerPixel
    
'   ***** Needs to be passed to the collections
    m_oGroups.HiMetricPerPixel = ScaleX(1, vbPixels, vbHimetric)
    m_oLargeImages.HiMetricPerPixel = ScaleX(1, vbPixels, vbHimetric)
    m_oSmallImages.HiMetricPerPixel = ScaleX(1, vbPixels, vbHimetric)
'   *****

End Sub
Private Sub ReadObjectProps(oPropBag As PropertyBag)
'   ***********************************************************************
'   * Params:   oPropBag: the property bag to read property values from
'   * Purpose:  Reads the properties from the property bag. Reads only
'   *               the properties for objects that were changed at design time
'   *               thru the property pages.
'   ***********************************************************************
    Dim i As Long
    Dim j As Long
    Dim lCount As Long
    Dim lItemCount As Long
    Dim oGroup As GTGroup
    Dim oGroupItem As GTGroupItem
    
    lCount = oPropBag.ReadProperty("NumGroups", 0)
    
    For i = 1 To lCount
        
        Set oGroup = m_oGroups.Add()
        
        oGroup.Alignment = oPropBag.ReadProperty("GroupAlignment" & i, gtLeftAlign)
        oGroup.Text = oPropBag.ReadProperty("GroupText" & i, "")
        oGroup.Tag = oPropBag.ReadProperty("GroupTag" & i, "")
        oGroup.Key = oPropBag.ReadProperty("GroupKey" & i, "")
        oGroup.View = oPropBag.ReadProperty("GroupView" & i, gtLargePicture)
        oGroup.Visible = oPropBag.ReadProperty("GroupVisible" & i, True)
        oGroup.GroupItemBackColor = oPropBag.ReadProperty("GroupItemsBackColor" & i, Null)
        oGroup.GroupItemForeColor = oPropBag.ReadProperty("GroupItemsForeColor" & i, Null)
        lItemCount = oPropBag.ReadProperty("NumGroupItems" & i, 0)
    
'   ***** Reads the GroupItem properties. Not used at this time
        For j = 1 To lItemCount
            Set oGroupItem = oGroup.GroupItems.Add()
            
            oGroupItem.LargePicture = oPropBag.ReadProperty("Group" & i & "ItemLargePicture" & j, 0)
            oGroupItem.SmallPicture = oPropBag.ReadProperty("Group" & i & "ItemSmallPicture" & i, 0)
            oGroupItem.Text = oPropBag.ReadProperty("Group" & i & "ItemText" & j, "")
            oGroupItem.Tag = oPropBag.ReadProperty("Group" & i & "ItemTag" & j, "")
            oGroupItem.Key = oPropBag.ReadProperty("Group" & i & "ItemKey" & j, "")
            oGroupItem.Visible = oPropBag.ReadProperty("Group" & i & "ItemVisible" & j, True)
        Next
'   *****
    Next
    
End Sub

Private Sub WriteObjectProps(oPropBag As PropertyBag)
'   ***********************************************************************
'   * Params:   oPropBag: the property bag to write property values to
'   * Purpose:  Writes the properties to the property bag. Writes only
'   *               the properties for objects that were changed at design time
'   *               thru the property pages.
'   ***********************************************************************
    Dim i As Long
    Dim j As Long
    Dim oGroup As GTGroup
    Dim oGroupItem As GTGroupItem
    
    Call oPropBag.WriteProperty("NumGroups", m_oGroups.Count, 0)
    
    For i = 1 To m_oGroups.Count
        
        Set oGroup = m_oGroups(i)
        
        Call oPropBag.WriteProperty("GroupAlignment" & i, oGroup.Alignment, gtLeftAlign)
        Call oPropBag.WriteProperty("GroupText" & i, oGroup.Text, "")
        Call oPropBag.WriteProperty("GroupTag" & i, oGroup.Tag, "")
        Call oPropBag.WriteProperty("GroupKey" & i, oGroup.Key, "")
        Call oPropBag.WriteProperty("GroupView" & i, oGroup.View, gtLargePicture)
        Call oPropBag.WriteProperty("GroupVisible" & i, oGroup.Visible, True)
        Call oPropBag.WriteProperty("GroupItemsBackColor" & i, oGroup.GroupItemBackColor, Null)
        Call oPropBag.WriteProperty("GroupItemsForeColor" & i, oGroup.GroupItemForeColor, Null)
        Call oPropBag.WriteProperty("NumGroupItems" & i, oGroup.GroupItems.Count, 0)
        
'   ***** Saves the groupitems properties. Not used at this time
        For j = 1 To oGroup.GroupItems.Count
            Set oGroupItem = oGroup.GroupItems(i)
            
            Call oPropBag.WriteProperty("Group" & i & "ItemLargePicture" & j, oGroupItem.LargePicture, Nothing)
            Call oPropBag.WriteProperty("Group" & i & "ItemSmallPicture" & i, oGroupItem.SmallPicture, Nothing)
            Call oPropBag.WriteProperty("Group" & i & "ItemText" & i, oGroupItem.Text, "")
            Call oPropBag.WriteProperty("Group" & i & "ItemTag" & i, oGroupItem.Tag, "")
            Call oPropBag.WriteProperty("Group" & i & "ItemKey" & i, oGroupItem.Key, "")
            Call oPropBag.WriteProperty("Group" & i & "ItemVisible" & i, oGroupItem.Visible, True)
        Next
'   *****
    Next
    
End Sub
Private Sub DrawBorder(hdc As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on.
'   * Purpose:  Draws the border based on the Appearance and BorderStyle
'   *               properties.
'   *********************************************************************************
    If m_eAppearance = gt3D And m_eBorderStyle = gtFixedSingle Then
        m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, Inset
    ElseIf m_eBorderStyle = gtFixedSingle Then
        m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, FixedSingle
    End If
End Sub
Private Sub CalcOffset()
'   *********************************************************************************
'   * Purpose:  Calculates how far left and from the top to start the drawing
'   *               of the objects. This is calculated by the value of the Appearance
'   *               and BorderStyle properties.
'   *********************************************************************************
    If m_eAppearance = gt3D And m_eBorderStyle = gtFixedSingle Then
        m_iOffset = 2
    ElseIf m_eBorderStyle = gtFixedSingle Then
        m_iOffset = 1
    Else
        m_iOffset = 0
    End If
    
    m_oGroups.Offset = m_iOffset

End Sub

Private Sub Paint(byWhat As Byte, Optional bDrawMovingGroups As Boolean = False, Optional byButton As Byte = Up, _
                            Optional bScrollButtonDown As Boolean = False, Optional bGroupRemoved As Boolean = False)
'   *********************************************************************************
'   * Params:   byWhat: what needs to be drawn (all, scrollbuttons, groupitems,
'   *               etc, bDrawMovingGroups: Optional: whether to draw the groups
'   *               as moving or just draw in place, byButton: Optional: which
'   *               direction to scroll (up or down), bScrollbuttondown: Optional:
'   *               if the scrollbutton is in the down state.
'   * Purpose:  Paints the groups and groupitems onto the dc. The Groups can
'   *               be painted animated (moving) when a new group is active or
'   *               the groupitems are painted and the active groupitem draw with
'   *               a rect around it, or a scrollbutton is drawn in the up or down state.
'   *********************************************************************************
    Dim lTop As Long
    Dim lStart As Long
    Dim lStop As Long
    Dim bEndLoop As Boolean
    Dim iDifference As Integer
    Dim bMoveUp As Boolean
    Dim lGroupItemsTop As Long
    Dim lGroupItemStart As Long
    Dim rectBackground As RECT
    Dim rc As Boolean
    Dim hDCMem As Long
    Dim bSkipGroupItems As Boolean
    
    If Not m_bRedraw Then
        Exit Sub
    End If
    
'   ***** If no selected group (if there are groups, there is always a selected
'   ***** group) draw the control name
    If m_oSelectedGroup Is Nothing Then
        hDCMem = m_CPaint.GetMemDC(UserControl.hdc, ScaleWidth, ScaleHeight)
        m_CPaint.DrawBackground hDCMem, 0, 0, ScaleWidth, ScaleHeight, m_lBackColor
        DrawBorder hDCMem
        PrintDisplayName hDCMem
        m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight
        Exit Sub
    End If
'   *****

'   ***** If groups overlap, don't draw groupitems
    bSkipGroupItems = GroupsOverlap()
    If bSkipGroupItems Then
        bDrawMovingGroups = False
    End If
'   *****

'   ***** If redrawing the entire control, get a new memdc. Otherwise, draw only what is specified by
'   ***** the param
    If byWhat = All Then
        hDCMem = m_CPaint.GetMemDC(UserControl.hdc, ScaleWidth, ScaleHeight)
    Else
        hDCMem = m_CPaint.hDCMem
    End If
'   *****

'   ***** Find the number of groups between the selected group (previously selected)
'   ***** and the currentgroup ( the newly selected group). The groups between the
'   ***** selected group and currentgroup and the current group are the moving groups
    If m_oSelectedGroup.Index > m_oCurrentGroup.Index Then
        iDifference = m_oSelectedGroup.Index - m_oCurrentGroup.Index + 1
    Else
        iDifference = m_oCurrentGroup.Index - m_oSelectedGroup.Index + 1
    End If
'   ****

'   ***** If the current group index is higher than the selected group, the groups
'   ***** will be moving up
    bMoveUp = (m_oSelectedGroup.Index - m_oCurrentGroup.Index < 0)
'   *****

    If byWhat = Group Or byWhat = All Then
        
'   ***** Draws the stationary groups
        DrawStationaryGroups hDCMem, lStart, lStop, bMoveUp, bDrawMovingGroups
'   *****

'   ***** Draw the border after drawing groups because if groups overlap, the border
'   ***** still shows
        DrawBorder hDCMem
'   *****

'   ***** Holds the groupitembackground start and stop points.
'   ***** This is used when drawing groupitems only
        m_lItemBkStart = lStart
        m_lItemBkStop = lStop
'   *****
        
        lTop = lStart
        
'   ***** If only drawing groups, get out
        If byWhat = Group Then
            m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight ' blits the updated control
            Exit Sub
        End If
'   *****

    End If
    
'   ***** If only items, set the start, stop, and top variables
    If byWhat = Items Then
        lStart = m_lItemBkStart
        lTop = m_lItemBkStart
        lStop = m_lItemBkStop
    End If
'   *****

'   ***** Drawn when what is not scrollbuttons.
    If Not (byWhat = ScrollButton) Then
'   ***** Loops until bEndLoop is true. When this loop draws the moving groups,
'   ***** this shows the groups in different positions and gives the illusion of moving.
        Do
    
            If bDrawMovingGroups Then
'   ***** Draws moving groups
                bEndLoop = DrawMovingGroups(hDCMem, iDifference - 1, lStart, lTop, lStop, bMoveUp)
'   *****
            Else
'   ***** Only draw group items when groups don't overlap
                If Not bSkipGroupItems Then
'   ***** Draws the groupitembackground when a group has been added or the group is set in code.
                ' draws the background and items for the previously selected group
                    DrawGroupItemBackground hDCMem, m_oSelectedGroup.GroupItemBackColor, lStart, lStop + 1, bMoveUp
                    If m_oSelectedGroup.GroupItems.Count > 0 Then
                        rc = DrawGroupItems(hDCMem, m_oSelectedGroup, lStart, lStop + 1)
                        If Not rc Then
                            Exit Do
                        End If
                    End If
                    If Not m_oActiveGroupItem Is Nothing Then
                        DrawGroupItemRect hDCMem
                    End If
'   *****
                End If
'   *****
                bEndLoop = True
            End If

'   ***** If not ending the loop, show the groups where they are
            If Not bEndLoop Then
                m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight ' blits the updated control
            End If
'   *****
        Loop Until bEndLoop
'   *****
    End If
'   *****

'   ***** If What is the activeitem, refreshes the image
    If byWhat = ActiveItem Then
        m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight ' blits the updated control
    End If
'   *****

'   ***** Only when draw moving groups, save the groupitembackground
'   ***** start and stop points
    If bDrawMovingGroups Then
        If Not bMoveUp Then
            m_lItemBkStart = lStart
            m_lItemBkStop = lTop + m_lGroupHeight ' - 1
        Else
            m_lItemBkStart = lTop
            m_lItemBkStop = lStart + m_lGroupHeight '
        End If
    End If
'   *****

'   ***** Draws the scrollbuttons
    If byWhat = ScrollButton Then
        DrawScrollButtons hDCMem, byButton, bScrollButtonDown
        m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight ' blits the updated control
    
    ElseIf byWhat = All Or byWhat = Items Then
        
        Select Case ScrollButtonsVisible(bDrawMovingGroups)
            Case None:

            Case Up:
                DrawScrollButtons hDCMem, Up, False
            Case Down:
                DrawScrollButtons hDCMem, Down, False
            Case Else:
                DrawScrollButtons hDCMem, Up, False
                DrawScrollButtons hDCMem, Down, False
        End Select
        
        m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight ' blits the updated control
    End If
'   *****
End Sub
Private Sub DrawStationaryGroups(hdc As Long, lStart As Long, lStop As Long, bMoveUp As Boolean, bDrawMovingGroups As Boolean)
'   *********************************************************************************
'   * Params:   hdc: the dc to draw on, lStart: the position on the control to
'   *               start drawing (depending on the way the groups are moving
'   *               this value could be from the top or bottom), lStart: the position
'   *               on the control to stop drawing (depending on the way the
'   *               groups are moving this value could be from the top or bottom),
'   *               bDrawMovingGroups: whether or not groups are moving (sets a different
'   *               variable)
'   * Purpose:  Draws the groups that aren't moving or draws all groups when
'   *               bDrawMovingGroups is False. lStart or lStop will be returned with
'   *               the place to start drawing the moving groups depending on the
'   *               drawmovinggroups flag.
'   *********************************************************************************
    Dim lWidth As Long
    Dim lLeft As Long
    Dim lTop As Long
    Dim i As Long
    Dim lScaleWidth As Long
    Dim rectGroup As RECT
    Dim oGroup As GTGroup
    Dim lGroupStop As Long
    Dim lOldBackColor As Long
    Dim oTempFont As StdFont
    Dim lOldForeColor As OLE_COLOR
    
    If m_oSelectedGroup Is Nothing Then
        Exit Sub
    End If
    
'   ***** Sets the font and forecolor of the usercontrol
    Set oTempFont = UserControl.Font
    Set UserControl.Font = m_oGroupFont
    
    lOldForeColor = UserControl.ForeColor
    UserControl.ForeColor = m_lGroupForeColor
'   *****

    lScaleWidth = ScaleWidth - m_iOffset * 2
    
    lTop = m_iOffset
    lLeft = m_iOffset
        
    rectGroup.Left = lLeft
    rectGroup.Right = lLeft + lScaleWidth
    
'   ***** Decides which group to stop on
    If m_oCurrentGroup.Index = 1 Or Not (bDrawMovingGroups) Then
        lGroupStop = m_oCurrentGroup.Index
    ElseIf m_oSelectedGroup.Index > m_oCurrentGroup.Index Then
        lGroupStop = m_oCurrentGroup.Index
    Else
        lGroupStop = m_oSelectedGroup.Index
    End If
'   *****

    For Each oGroup In m_oGroups
        
'   ***** If the group is visible, draw the background for the group and the
'   ***** text
        If oGroup.Visible Then
            rectGroup.Top = lTop
            rectGroup.Bottom = lTop + m_lGroupHeight
            
            If Not (UserControl.BackColor = vb3DFace) Then
                lOldBackColor = SetBkColor(hdc, GetSysColor(COLOR_BTNFACE))
                ExtTextOut hdc, 0, 0, ETO_CLIPPED Or ETO_OPAQUE, rectGroup, "", 0, 0
                lOldBackColor = SetBkColor(hdc, lOldBackColor)
            End If
            
            m_CDrawRect.Draw3DRect hdc, lLeft, lTop, lScaleWidth, m_lGroupHeight, Raised
            
'            DrawText hDC, oGroup.Text, rectGroup, DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, oGroup.Alignment
            m_CPaint.PaintText oGroup.Text, m_oGroupFont.Name, rectGroup.Left, rectGroup.Top, rectGroup.Right, rectGroup.Bottom, _
                            TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, oGroup.Alignment, m_oGroupFont.Bold, _
                            m_oGroupFont.Italic, m_oGroupFont.Strikethrough, m_oGroupFont.Underline, GetBkColor(UserControl.hdc), _
                            GetTextColor(UserControl.hdc)
            lTop = lTop + m_lGroupHeight
        End If
'   *****

        If oGroup Is m_oGroups(lGroupStop) Then
            Exit For
        End If
        
    Next
    
    If bMoveUp Then
        lStop = lTop
    Else
        lStart = lTop
    End If
    
'   ***** Finds the stop group for the rest of the stationary groups
    If m_oCurrentGroup.Index > m_oSelectedGroup.Index Or Not bDrawMovingGroups Then
        lGroupStop = m_oCurrentGroup.Index + 1
    Else
        lGroupStop = m_oSelectedGroup.Index + 1
    End If
'   *****

    lTop = ScaleHeight - m_lGroupHeight - m_iOffset

    For i = m_oGroups.Count To lGroupStop Step -1
        Set oGroup = m_oGroups(i)
        
'   ***** If the group is visible, draw the background for the group and the
'   ***** text
        If oGroup.Visible Then
            rectGroup.Top = lTop
            rectGroup.Bottom = lTop + m_lGroupHeight
            
            If Not (UserControl.BackColor = vb3DFace) Then
                lOldBackColor = SetBkColor(hdc, GetSysColor(COLOR_BTNFACE))
                ExtTextOut hdc, 0, 0, ETO_CLIPPED Or ETO_OPAQUE, rectGroup, "", 0, 0
                lOldBackColor = SetBkColor(hdc, lOldBackColor)
            End If
    
            m_CDrawRect.Draw3DRect hdc, lLeft, lTop, lScaleWidth, m_lGroupHeight, Raised
    
'            DrawText hdc, oGroup.Text, rectGroup, DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, oGroup.Alignment
            m_CPaint.PaintText oGroup.Text, m_oGroupFont.Name, rectGroup.Left, rectGroup.Top, rectGroup.Right, rectGroup.Bottom, _
                            TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, oGroup.Alignment, m_oGroupFont.Bold, _
                            m_oGroupFont.Italic, m_oGroupFont.Strikethrough, m_oGroupFont.Underline, GetBkColor(UserControl.hdc), _
                            GetTextColor(UserControl.hdc)
    
            lTop = lTop - m_lGroupHeight
        End If
'   *****
    Next
    
    If bMoveUp Then
        lStart = lTop
    Else
        lStop = lTop + m_lGroupHeight
    End If
    
'   ***** Resets the forecolor and font
    UserControl.ForeColor = lOldForeColor
    Set UserControl.Font = oTempFont
    Set oTempFont = Nothing
'   *****
End Sub

Private Function DrawMovingGroups(hdc As Long, iDifference As Integer, lStart As Long, lStartTop As Long, lStop As Long, bMoveUp As Boolean) As Boolean
'   *********************************************************************************
'   * Params:   hdc: the dc to draw on, iDifference: the difference between
'   *               the first and last moving groups, lStart: where to start the drawing,
'   *               lStartTop: where to start thedrawing, lStop: where to stop the
'   *               drawing, bMoveUp: whether the groups are moving up or down.
'   * Purpose: Draws the groups that are moving. The groupitem background and
'   *               groups are also drawn. lStarttop is changed to be sent back.
'   * Modified: Ver 1.0a    Don't add 1 when drawing large images for current group
'   *********************************************************************************
    Dim lGroupStart As Long
    Dim lGroupStop As Long
    Dim i As Long
    Dim iStep As Integer
    Dim lLeft As Long
    Dim lTop As Long
    Dim lScaleWidth As Long
    Dim lScaleHeight As Long
    Dim rectGroup As RECT
    Dim lOldBackColor As Long
    Dim lHoldTop As Long
    Dim oTempFont As StdFont
    Dim lOldForeColor As OLE_COLOR
    
    If m_oSelectedGroup Is Nothing Then
        Exit Function
    End If
    
'   ***** Sets the font and forecolor of the usercontrol
    Set oTempFont = UserControl.Font
    Set UserControl.Font = m_oGroupFont
    
    lOldForeColor = UserControl.ForeColor
    UserControl.ForeColor = m_lGroupForeColor
'   *****

    lScaleHeight = ScaleHeight - m_iOffset * 2
    lScaleWidth = ScaleWidth - m_iOffset * 2
    
    lLeft = m_iOffset
    lTop = lStartTop
    
'   ***** Figures out the stop and start groups by the direction
    If Not bMoveUp Then
        lGroupStart = m_oCurrentGroup.Index + 1
        lGroupStop = m_oSelectedGroup.Index
        iStep = 1
    Else
        lGroupStop = m_oSelectedGroup.Index + 1
        lGroupStart = m_oCurrentGroup.Index
        iStep = -1
    End If
'   *****

'   ***** Draws the groupitems for the newly selected group
    If bMoveUp Then
        If lTop > lStop Then
            DrawGroupItemBackground hdc, m_oSelectedGroup.GroupItemBackColor, lTop, lStop + 1, bMoveUp
'   ***** Ver 1.0a. Added so current group draws when groups move up.
            If lTop > lStop Then
                DrawGroupItems hdc, m_oSelectedGroup, lStop, lTop
            Else
                DrawGroupItems hdc, m_oSelectedGroup, lTop, lStop
            End If
'   *****
        End If
    End If
'   *****

'   ***** The drawing of groups is done after this iteration because the stop point
'   ***** has been reached
    If Not bMoveUp Then
        If lTop + m_lGroupHeight * iDifference > lStop Then
            lTop = lStop - (m_lGroupHeight * iDifference)
            DrawMovingGroups = True
        End If
    Else
        If lTop < lStop + m_lGroupHeight * iDifference Then
            lTop = lStop + (m_lGroupHeight * (iDifference - 1))
            DrawMovingGroups = True
        End If
    End If
'   *****

'   ***** Draws the groupitems for the newly selected group
    If Not bMoveUp Then
        DrawGroupItemBackground hdc, m_oSelectedGroup.GroupItemBackColor, lTop + (m_lGroupHeight * iDifference), lStop, bMoveUp
        DrawGroupItems hdc, m_oSelectedGroup, lTop + (m_lGroupHeight * iDifference), lStop
    End If
'   *****

'   ***** Loops thru the groups and draws the background and text
    For i = lGroupStart To lGroupStop Step iStep
                        
        If m_oGroups(i).Visible Then
            rectGroup.Left = lLeft
            rectGroup.Top = lTop
            rectGroup.Bottom = lTop + m_lGroupHeight
            rectGroup.Right = lLeft + lScaleWidth
            
            If Not (UserControl.BackColor = vb3DFace) Then
                lOldBackColor = SetBkColor(hdc, GetSysColor(COLOR_BTNFACE))
                
                ExtTextOut hdc, 0, 0, ETO_CLIPPED Or ETO_OPAQUE, rectGroup, "", 0, 0
                lOldBackColor = SetBkColor(hdc, lOldBackColor)
            End If
    
            m_CDrawRect.Draw3DRect hdc, lLeft, lTop, lScaleWidth, m_lGroupHeight, Raised
    
            m_CPaint.PaintText m_oGroups(i).Text, m_oGroupFont.Name, rectGroup.Left, rectGroup.Top, rectGroup.Right, rectGroup.Bottom, _
                            TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, m_oGroups(i).Alignment, m_oGroupFont.Bold, _
                            m_oGroupFont.Italic, m_oGroupFont.Strikethrough, m_oGroupFont.Underline, GetBkColor(UserControl.hdc), _
                            GetTextColor(UserControl.hdc)
'            DrawText hDC, m_oGroups(i), rectGroup, DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, m_oGroups(i).Alignment
    
            If Not bMoveUp Then
                lTop = lTop + m_lGroupHeight
            Else
                lTop = lTop - m_lGroupHeight
            End If
        End If
        
    Next
'   *****

'   ***** Draws the groupitems for the newly selected group
    If Not bMoveUp Then
        DrawGroupItemBackground hdc, m_oCurrentGroup.GroupItemBackColor, lStart, lTop - (m_lGroupHeight * iDifference) + 1, bMoveUp
        DrawGroupItems hdc, m_oCurrentGroup, lStart, lTop - (m_lGroupHeight * iDifference) + 1
    Else
        DrawGroupItemBackground hdc, m_oCurrentGroup.GroupItemBackColor, lTop + (m_lGroupHeight * (iDifference + 1)), lStart + m_lGroupHeight + 1, bMoveUp
        
'   ***** Ver 1.0a Don't add 1 to height when large pictures
        If m_oCurrentGroup.View = gtLargePicture Then
            DrawGroupItems hdc, m_oCurrentGroup, lTop + (m_lGroupHeight * (iDifference + 1)), lStart + m_lGroupHeight
        Else
            DrawGroupItems hdc, m_oCurrentGroup, lTop + (m_lGroupHeight * (iDifference + 1)), lStart + m_lGroupHeight + 1
        End If
'   *****
    End If
'   *****
    
'   ***** Sets the starttop variable basedon the groupheight
    If DrawMovingGroups Then
        If Not bMoveUp Then
            lStartTop = lTop - (m_lGroupHeight * (iDifference + 1))
        Else
            lStartTop = lTop + m_lGroupHeight * (iDifference + 1)
        End If
    Else
        If Not bMoveUp Then
            lStartTop = lStartTop + m_lGroupHeight
        Else
            lStartTop = lStartTop - m_lGroupHeight
        End If
    End If
'   *****

'   ***** Reset the font and forecolor
    Set UserControl.Font = oTempFont
    UserControl.ForeColor = lOldForeColor
'   *****
End Function

Private Sub DrawGroupItemBackground(hdc As Long, vGroupItemsBackColor As Variant, ByVal lStartTop As Long, ByVal lStopBottom As Long, bMoveUp As Boolean)
'   *********************************************************************************
'   * Params:   hdc: the dc to draw on, vGroupItemsBackColor: the color to
'   *               draw behind the groupitems. lStartTop, where to start the rect,
'   *               lStopBottom: where to stop therect. bMoveUp: True when the
'   *               groups are moving up
'   * Purpose:  Draws the background for the groupitems The color is based
'   *               on the GroupItemBackcolor property of the active group or if that's
'   *               null, the shadow color.
'   *********************************************************************************
    Dim lScaleWidth As Long
    Dim lTop As Long
    Dim lStop As Long
    Dim r As RECT
    Dim lOldBackColor As Long
    Dim lBackColor As Long
    
    If lStopBottom = 0 Then
        lStop = ScaleHeight - m_iOffset
'    ElseIf lStartTop >= lStopBottom Then
'        Exit Sub
    Else
        lStop = lStopBottom
    End If
        
    lScaleWidth = ScaleWidth - m_iOffset * 2
    
    If bMoveUp Then
        lTop = lStartTop
    Else
        lTop = lStartTop
    End If
    
    r.Left = m_iOffset
    r.Top = lStartTop
    r.Right = r.Left + lScaleWidth
    r.Bottom = lStop - 1
    
'   ***** When the groupitembackcolor property of the group is null
'   ***** use the value backcolor property
    If IsNull(vGroupItemsBackColor) Then
        lBackColor = m_lBackColor
    Else
        lBackColor = CLng(vGroupItemsBackColor)
    End If
    lBackColor = m_CPaint.GetBackColor(lBackColor)
'   *****

    lOldBackColor = SetBkColor(hdc, lBackColor)
    ExtTextOut hdc, 0, 0, ETO_CLIPPED Or ETO_OPAQUE, r, "", 0, 0
    lOldBackColor = SetBkColor(hdc, lOldBackColor)
    
End Sub
Private Function DrawGroupItems(hdc As Long, oGroup As GTGroup, ByVal lTopStart As Long, ByVal lBottom As Long) As Boolean
'   *********************************************************************************
'   * Params:   hdc: the dc to draw on, oGroup: the group to draw the
'   *               groupitems for, lTopStart: the top point to start drawing the
'   *               groupitems, lBottom: the bottom point where not to draw past.
'   * Purpose:  Draws the groupitems for the group that is passed in. GroupItems
'   *               are drawn depending on the View property of the Group that
'   *               was passed in. This will draw the pictures and text. The text
'   *               is drawn underneath the image when the View is gtLargePicture,
'   *               or drawn next to the image when the View is gtSmallPicture.
'   *********************************************************************************
    Dim lLeft As Long
    Dim lTop As Long
    Dim i As Long
    Dim rectItem As RECT
    Dim oGroupItem As GTGroupItem
    Dim lScaleWidth As Long
    Dim lPicHeight As Long
    Dim lPicWidth As Long
    Dim bSkip As Boolean
    Dim eView As GTViewConstants
    Dim lHoldForeColor As OLE_COLOR
    Dim oHoldFont As StdFont
    Dim lStop As Long
    Dim lCenter As Long
    Dim bDontDraw As Boolean
    
    On Error Resume Next
    
    eView = oGroup.View
    
    lTop = lTopStart + GROUPITEMSTARTPOS
    
    If lBottom = 0 Then
        lStop = ScaleHeight - m_iOffset
    ElseIf lTopStart >= lBottom Then
        DrawGroupItems = False
        Exit Function
    Else
        lStop = lBottom
    End If
    
    lScaleWidth = ScaleWidth - m_iOffset * 2
    
    lCenter = ScaleWidth / 2
    lLeft = m_iOffset
    
'   ***** Sets the destinationDC to the usercontrol dc
    m_oLargeImages.DestinationDC = UserControl.hdc
    m_oSmallImages.DestinationDC = UserControl.hdc
'   *****

'   ***** sets the forecolor and font
    lHoldForeColor = UserControl.ForeColor
    
    If IsNull(oGroup.GroupItemForeColor) Then
        UserControl.ForeColor = m_lForeColor
    Else
        UserControl.ForeColor = oGroup.GroupItemForeColor
    End If
    
    Set oHoldFont = UserControl.Font
    Set UserControl.Font = m_oFont
'   *****

    lTop = lTop - oGroup.ScrollOffset
    
'   ***** Loops thru the groupitems and draws them
    For Each oGroupItem In oGroup.GroupItems

'   ***** Dont draw the groupitem if the picture is 0
        If eView = gtLargePicture Then
            bSkip = oGroupItem.LargePicture = 0
        Else
            bSkip = oGroupItem.SmallPicture = 0
        End If
'   *****

        If lTop < GROUPITEMSTARTPOS + lTopStart Then
            bDontDraw = True
        End If
        
        If Not bSkip Then
        
            If eView = gtLargePicture Then
'   ***** Draws the large images
                lPicWidth = m_oLargeImages.Width
                lPicHeight = m_oLargeImages.Height
                If lTop + lPicHeight > lStop Then
                    Set UserControl.Font = oHoldFont
                    Exit For
                Else
                    If Not bDontDraw Then
                        m_oLargeImages(oGroupItem.LargePicture).DrawPicture hdc, CSng(lCenter - lPicWidth / 2), CSng(lTop), , , gtTransparent, oGroup.GroupItemBackColor
                        If Err Then ' eat the error and still draw the text
                        
                        End If
                    End If
                End If
                
                lTop = lTop + lPicHeight
                rectItem.Left = lLeft
'   *****
            Else
'   ***** Draws the small images
                lPicHeight = m_oSmallImages.Height
                If lTop + IIf(m_lGroupItemTextHeight > lPicHeight, m_lGroupItemTextHeight, lPicHeight) > lStop Then
                    Set UserControl.Font = oHoldFont
                    Exit For
                Else
                    If Not bDontDraw Then
                        m_oSmallImages(oGroupItem.SmallPicture).DrawPicture hdc, CSng(lLeft + 2), CSng(lTop), , , gtTransparent, oGroup.GroupItemBackColor
                        If Err Then ' eat the error and still draw the text
                        
                        End If
                    End If
                End If
                                
                rectItem.Left = lLeft + m_oSmallImages.Width
            End If
'   *****
            rectItem.Top = lTop
            rectItem.Right = lScaleWidth - rectItem.Left
    
            If eView = gtLargePicture Then
'   ***** Draws the text with the large images
                If lTop + m_lGroupItemTextHeight <= lStop Then
                    rectItem.Bottom = rectItem.Top + m_lGroupItemTextHeight
                    If Not bDontDraw Then
                        m_CPaint.PaintText oGroupItem.Text, m_oFont.Name, rectItem.Left, rectItem.Top, rectItem.Right, rectItem.Bottom, _
                                        TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, gtCenter, m_oFont.Bold, _
                                        m_oFont.Italic, m_oFont.Strikethrough, m_oFont.Underline, GetBkColor(UserControl.hdc), _
                                        GetTextColor(UserControl.hdc)
'                        DrawText hDC, oGroupItem.Text, rectItem, DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, gtCenter
                    End If
                End If
                lTop = lTop + m_lGroupItemTextHeight + GROUPITEMSPACING
'   *****
            Else
'   ***** Draws the text with the small images
                rectItem.Bottom = rectItem.Top + IIf(m_lGroupItemTextHeight > lPicHeight, m_lGroupItemTextHeight, lPicHeight)
                If Not bDontDraw Then
                    m_CPaint.PaintText oGroupItem.Text, m_oFont.Name, rectItem.Left, rectItem.Top, rectItem.Right, rectItem.Bottom, _
                                    TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, 0, m_oFont.Bold, _
                                    m_oFont.Italic, m_oFont.Strikethrough, m_oFont.Underline, GetBkColor(UserControl.hdc), _
                                    GetTextColor(UserControl.hdc)
'                    DrawText hDC, oGroupItem.Text, rectItem, DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, gtLeftAlign
                End If
                lTop = lTop + IIf(m_lGroupItemTextHeight > lPicHeight, m_lGroupItemTextHeight, lPicHeight) + GROUPITEMSPACING
            End If
'   *****
        
        End If
        
        If lTop >= lStop Then
            Set UserControl.Font = oHoldFont
            Exit For
        End If
        
        bDontDraw = False
        bSkip = False
    Next
    
'   ***** Reset the font and forecolor
    Set UserControl.Font = oHoldFont
    UserControl.ForeColor = lHoldForeColor
'   *****

    DrawGroupItems = True

End Function

Private Sub DrawGroupItemRect(hdc As Long)
'   *********************************************************************************
'   * Param:    hdc: the dc to draw on
'   * Purpose:  Draws the active rect around the groupitem. If the View of
'   *               the active group is gtLargePicture, the rect is drawn around
'   *               the image only. If the View is gtSmallPicture: the rect is drawn
'   *               around the image and the text.
'   *********************************************************************************
    Dim lShadow As OLE_COLOR
    Dim lHilight As OLE_COLOR
    Dim lLeft As Long
    Dim lTop As Long
    Dim lWidth As Long
    Dim lHeight As Long
    
    lTop = m_oGroups.GetGroupItemTop(m_oActiveGroupItem) + 1 - m_oSelectedGroup.ScrollOffset
    
    If m_oSelectedGroup.View = gtLargePicture Then
        lWidth = m_oLargeImages.Width + 2
        lHeight = m_oLargeImages.Height + 2
        lLeft = ScaleWidth \ 2 - lWidth \ 2 + 1
    Else
        lWidth = m_oSmallImages.Width + GetGroupItemTextWidth(m_oActiveGroupItem.Text) + 2
'   ***** Ver 1.0a Rect now draws correctly for image height larger than text height
        If m_lGroupItemTextHeight > m_oSmallImages.Height Then
'        If m_lGroupItemTextHeight > lHeight Then
            lHeight = m_lGroupItemTextHeight
        Else
            lHeight = m_oSmallImages.Height + 2 ' ver 1.0a Adds 2 pixels to height
        End If
        lHeight = lHeight '+ 1
        lLeft = m_iOffset + 1
    
        If lWidth > ScaleWidth - m_iOffset * 2 Then
            lWidth = (ScaleWidth - m_iOffset * 2) - lLeft
        End If
    End If
    
    m_CDrawRect.Draw3DRect hdc, lLeft, lTop, lWidth, lHeight, IIf(m_oActiveGroupItem.Down, ActiveDown, ActiveUp)
End Sub

'Private Sub PaintBackground()
''   *********************************************************************************
''   * Purpose:  Paints the background when there are no groups.
''   *********************************************************************************
'     Dim rectBackground As RECT
'
'    rectBackground.Left = m_iOffset
'    rectBackground.Top = m_iOffset
'    rectBackground.Right = rectBackground.Left + ScaleWidth - m_iOffset
'    rectBackground.Bottom = rectBackground.Top + ScaleHeight - m_iOffset
'
'    ExtTextOut hdc, 0, 0, ETO_CLIPPED Or ETO_OPAQUE, rectBackground, "", 0, 0
'
'End Sub

Private Sub CalcGroupItemHeight()
'   *********************************************************************************
'   * Purpose:  Calculates the groupitemheight based on textheight of the
'   *               m_ofont
'   *********************************************************************************
    Dim oTempFont As StdFont
    
    Set oTempFont = UserControl.Font
    Set UserControl.Font = m_oFont
    
    m_lGroupItemTextHeight = TextHeight("O") + 4
    m_oGroups.GroupItemTextHeight = m_lGroupItemTextHeight
    
    Set UserControl.Font = oTempFont
    
    Set oTempFont = Nothing
    
End Sub

Private Sub CalcGroupHeight()
'   *********************************************************************************
'   * Purpose:  Calculates the groupheight based on textheight of the
'   *               m_ogroupfont.
'   *********************************************************************************
    Dim oTempFont As StdFont
    
    Set oTempFont = UserControl.Font
    Set UserControl.Font = m_oGroupFont
    
    m_lGroupHeight = TextHeight("O") + 4
    
    Set UserControl.Font = oTempFont
    
    Set oTempFont = Nothing
    
End Sub
Private Function GroupHitTest(x As Single, y As Single) As GTGroup
'   *********************************************************************************
'   * Params:   X: the left of the point to find, Y: the top of the point to find.
'   * Return:   GTGroup: the Group that was found at the X,Y point; Nothing if
'   *               no Group was found.
'   * Purpose:  Finds the Group at the X,Y point and returns it.Loops thru the
'   *               collection checking and added the heights.
'   *********************************************************************************
    Dim oGroup As GTGroup
    Dim oGroupItem As GTGroupItem
    Dim lTop As Long
    Dim i As Long
    Dim lGroupItemsTop As Long
    Dim lGroupItemsBottom As Long
    Dim oPicture As StdPicture
    Dim lScaleHeight As Long
    Dim lScaleWidth As Long
    Dim lPicHeight As Long
    Dim lPicWidth As Long
    
    If m_oSelectedGroup Is Nothing Then
        Exit Function
    End If
    
    lTop = m_iOffset
    lScaleHeight = ScaleHeight - m_iOffset
    lScaleWidth = ScaleWidth - m_iOffset
    
'   ***** Loops thru the groups and adds the heights along the
'   ***** way. When a group is found, passes back to the function.
'   ***** if the selected group is found, the loop is exited
    For Each oGroup In m_oGroups
        If oGroup.Visible Then
            If lTop < y And lTop + m_lGroupHeight > y Then
                Set GroupHitTest = oGroup
                Exit Function
            End If
            If oGroup Is m_oSelectedGroup Then
                lGroupItemsTop = lTop + m_lGroupHeight
                Exit For
            End If
                
            lTop = lTop + m_lGroupHeight
        End If
    Next
'   *****

    lTop = lScaleHeight - m_lGroupHeight + 1
    
'   ***** Loops thru the groups from the last to the selected group +1
    For i = m_oGroups.Count To m_oSelectedGroup.Index + 1 Step -1
        If m_oGroups(i).Visible Then
            If lTop < y And lTop + m_lGroupHeight > y Then
                Set GroupHitTest = m_oGroups(i)
                Exit Function
            End If
            
            lTop = lTop - m_lGroupHeight
        End If
    Next
'   *****
    
End Function

Private Sub DrawScrollButtons(hdc As Long, eButton As Byte, bDown As Boolean)
'   *********************************************************************************
'   * Params:   hdc: the dc to draw on, eButton: the up or down button,
'   *               bDown: the button is in the down state.
'   * Purpose:  Draws the scrollbutton using the DrawFrameControl api
'   *********************************************************************************
    Dim rectButton As RECT
    
    rectButton.Left = ScaleWidth - m_iOffset - (SCROLL_BUTTONSIZE + 2)
    rectButton.Right = rectButton.Left + SCROLL_BUTTONSIZE
    
    If eButton = Up Then
        rectButton.Top = m_lItemBkStart + 2
        rectButton.Bottom = rectButton.Top + SCROLL_BUTTONSIZE
        
        DrawFrameControl hdc, rectButton, DFC_SCROLL, DFCS_SCROLLUP Or IIf(bDown, DFCS_PUSHED, 0)
    Else
        rectButton.Top = m_lItemBkStop - (SCROLL_BUTTONSIZE + 2)
        rectButton.Bottom = rectButton.Top + SCROLL_BUTTONSIZE
        
        DrawFrameControl hdc, rectButton, DFC_SCROLL, DFCS_SCROLLDOWN Or IIf(bDown, DFCS_PUSHED, 0)
    End If
End Sub
Private Function ScrollButtonHitTest(x As Single, y As Single) As Byte
'   *********************************************************************************
'   * Params:   X: the left of the point to find, Y: the top of the point to find.
'   * Return:   Byte: the ScrollButton that was found at the X,Y point; Nothing if
'   *               no ScrollButton was found.
'   * Purpose:  Finds the ScrollButton at the X,Y point and returns it. Checks
'   *               where the button should be which is always in the same places
'   *               which is on the right side of the usercontrol, just below the
'   *               active group and just above the first group at the bottom.
'   *********************************************************************************
    Dim byScrollButton As Byte
    
    byScrollButton = ScrollButtonsVisible()
    If byScrollButton = None Then
        ScrollButtonHitTest = None
        Exit Function
    End If
    
    If x > ScaleWidth - m_iOffset - (SCROLL_BUTTONSIZE + 2) And x < ScaleWidth - m_iOffset - 2 Then
        If y > m_lItemBkStart + 2 And y < m_lItemBkStart + SCROLL_BUTTONSIZE + 2 Then
            If byScrollButton = Up Or byScrollButton = Both Then
                ScrollButtonHitTest = Up
                Exit Function
            End If
        ElseIf y > m_lItemBkStop - (SCROLL_BUTTONSIZE + 2) And y < m_lItemBkStop - 2 Then
            If byScrollButton = Down Or byScrollButton = Both Then
                ScrollButtonHitTest = Down
                Exit Function
            End If
        End If
    End If
    
    ScrollButtonHitTest = None

End Function
Private Function ScrollButtonsVisible(Optional bDrawMovingGroups As Boolean = False) As Byte
'   *********************************************************************************
'   * Params:  bDrawMovingGroups: whether or not the groups are moving.
'   * Return:   Byte: None, Up, Down, Both.
'   * Purpose:  Determines if the scrollbuttons (up, down, both) should be
'   *               visible or not. Based on the amount of space between the
'   *               active group and the next group in the collection and the number
'   *               of groupitems in the active group. Scrollbuttons show when
'   *               more groupitems exist than can be shown on the screen.
'   *********************************************************************************
    Dim lHeight As Long
    Dim lGroupItemHeight As Long
    Dim oGroup As GTGroup
    
'   ***** Determines if the scrollbuttons will be visible for the
'   ***** current group or the selected group
    If bDrawMovingGroups Then
        Set oGroup = m_oCurrentGroup
    Else
        Set oGroup = m_oSelectedGroup
    End If
    
'   ***** If there are not groupitems for the group, exit
    If oGroup.GroupItems.Count = 0 Then
        ScrollButtonsVisible = None
        Exit Function
    End If
'   *****

    lHeight = m_lItemBkStop - m_lItemBkStart + 2
    
'   ***** Gets the groupitem height if less than the space between
'   ***** the groups, no scrollbuttons need to be visible
    lGroupItemHeight = GetGroupItemHeight(oGroup)
    If lGroupItemHeight < lHeight Then
        ScrollButtonsVisible = None
        Exit Function
    End If
'   *****

'   ***** Determines which scrollbuttons will be shown
    If oGroup.ScrollOffset = 0 Then
        ScrollButtonsVisible = Down
    ElseIf lGroupItemHeight - oGroup.ScrollOffset < lHeight Then
        ScrollButtonsVisible = Up
    ElseIf oGroup.ScrollOffset > 0 Then
        ScrollButtonsVisible = Both
    End If
'   *****

End Function
Private Function GetGroupItemHeight(oGroup As GTGroup) As Long
'   *********************************************************************************
'   * Params:   oGroup: the group to get the height of the groupitems for
'   * Return:   Long: the distance between the active group and the next
'   *               group in the collection
'   * Purpose:  Determines the distance between the bottom of the group
'   *               heading of the active group and the top of the group heading
'   *                in the next group. This is the amount of space to draw the
'   *               groupitems.
'   *********************************************************************************
    Dim oGroupItem As GTGroupItem
    Dim lHeight As Long
    Dim lPicHeight As Long
    
    For Each oGroupItem In oGroup.GroupItems
        
        If oGroup.View = gtLargePicture Then
'   ***** Ver 1.0a Added checking for empty and isnumeric. Allows LargeImages to use key
            If Not IsEmpty(oGroupItem.LargePicture) Then
                If Not IsNumeric(oGroupItem.LargePicture) Then
                    lPicHeight = m_oLargeImages.Height
                    lHeight = lHeight + lPicHeight + m_lGroupItemTextHeight + GROUPITEMSPACING
                ElseIf oGroupItem.LargePicture > 0 Then
                    lPicHeight = m_oLargeImages.Height
                    lHeight = lHeight + lPicHeight + m_lGroupItemTextHeight + GROUPITEMSPACING
                End If
            End If
'   *****
        Else
'   ***** Ver 1.0a Added checking for empty and isnumeric. Allows SmallImages to use key
            If Not IsEmpty(oGroupItem.SmallPicture) Then
                
                If Not IsNumeric(oGroupItem.SmallPicture) Then
                    lPicHeight = m_oSmallImages.Height
                    
                    If lPicHeight > m_lGroupItemTextHeight Then
                        lHeight = lHeight + lPicHeight + GROUPITEMSPACING
                    Else
                        lHeight = lHeight + m_lGroupItemTextHeight + GROUPITEMSPACING
                    End If
                ElseIf oGroupItem.SmallPicture > 0 Then
                    lPicHeight = m_oSmallImages.Height
                    
                    If lPicHeight > m_lGroupItemTextHeight Then
                        lHeight = lHeight + lPicHeight + GROUPITEMSPACING
                    Else
                        lHeight = lHeight + m_lGroupItemTextHeight + GROUPITEMSPACING
                    End If
                End If
'   *****
            End If
        End If
        
    Next
    
    GetGroupItemHeight = lHeight
End Function

Private Function GroupItemsHitTest(x As Single, y As Single) As GTGroupItem
'   *********************************************************************************
'   * Params:   X: the left of the point to find, Y: the top of the point to find.
'   * Return:   GTGroupItem: the GroupItem that was found at the X,Y point; Nothing if
'   *               no GroupItem was found.
'   * Purpose:  Finds the GroupItem at the X,Y point and returns it.Loops thru the
'   *               collection checking and added the heights.
'   *********************************************************************************
    Dim lTop As Long
    Dim lGroupItemsBottom As Long
    Dim lPicHeight As Long
    Dim lPicWidth As Long
    Dim oGroupItem As GTGroupItem
    Dim oPicture As StdPicture
    Dim lScaleWidth As Long
    
    
    If y < m_lItemBkStart Or y > m_lItemBkStop Then
        Exit Function
    End If
    
    lScaleWidth = ScaleWidth - m_iOffset
    
    If x < m_iOffset Or lScaleWidth < x Then
        Exit Function
    End If
    
    lTop = m_lItemBkStart + GROUPITEMSTARTPOS - m_oSelectedGroup.ScrollOffset
    lGroupItemsBottom = m_lItemBkStop
    
'   ***** Loops thru the groupitems and adding the imageheights and text
'   ***** height and matches to the point for the mouse.
    For Each oGroupItem In m_oSelectedGroup.GroupItems
        If m_oSelectedGroup.View = gtLargePicture Then
'   ***** For large pictures the text is under the image
            lPicWidth = m_oLargeImages.Width
            lPicHeight = m_oLargeImages.Height
            
            If lTop + lPicHeight > lGroupItemsBottom Then
                Exit Function
            End If
            
            If lScaleWidth / 2 - (lPicWidth / 2) < x And _
                x < lScaleWidth / 2 - (lPicWidth / 2) + lPicWidth Then
                    If lTop < y And y < lTop + lPicHeight + m_lGroupItemTextHeight Then
                        Set GroupItemsHitTest = oGroupItem
                        Exit Function
                    End If
            End If
        
            lTop = lTop + lPicHeight + m_lGroupItemTextHeight + GROUPITEMSPACING
'   *****
        Else
'   ***** For small pictures the text is next to the image
            lPicWidth = m_oSmallImages.Width
            lPicHeight = m_oSmallImages.Height
            
            If lTop + IIf(m_lGroupItemTextHeight > lPicHeight, m_lGroupItemTextHeight, lPicHeight) > lGroupItemsBottom Then
                Exit Function
            End If
            
            If m_iOffset < x And x < (lPicWidth + GetGroupItemTextWidth(oGroupItem.Text) + 2) Then
                If lTop < y And y < lTop + IIf(m_lGroupItemTextHeight > lPicHeight, m_lGroupItemTextHeight, lPicHeight) Then
                    Set GroupItemsHitTest = oGroupItem
                    Exit Function
                End If
            End If
        
'   ***** Adds ltop to the imageheight or textheight which ever is greater
            lTop = lTop + IIf(m_lGroupItemTextHeight > lPicHeight, m_lGroupItemTextHeight, lPicHeight) + GROUPITEMSPACING
'   *****
'   *****
        End If
        
        
        If lTop > lGroupItemsBottom Then
            Exit Function
        End If
        
    Next
'   *****
End Function
Private Sub SetScrollOffset(byScrollButton As Byte)
'   *********************************************************************************
'   * Params:   byScrollButton: the button that was pushed to scroll the
'   *               groupitems.
'   * Purpose:  Sets the postion based on the height of the groupitems and
'   *               adds/subtracts this value from the ScrollOffset property of the
'   *               active group. By saving this value in the group itself, that group
'   *               will alway show the same groupitems as the last time it was
'   *               active.
'   *********************************************************************************
    Dim lPicHeight As Long
    Dim lOffset As Long
    
    If m_oSelectedGroup.ScrollOffset = 0 Then
        lOffset = GROUPITEMSTARTPOS
    End If
    
    If m_oSelectedGroup.View = gtLargePicture Then
        lPicHeight = m_oLargeImages.Height
        lOffset = lPicHeight + m_lGroupItemTextHeight + GROUPITEMSPACING
    Else
'   ***** Ver 1.0a Fixes small groupitems not scrolling correctly
        lPicHeight = m_oSmallImages.Height
        
        If lPicHeight > m_lGroupItemTextHeight Then
            lOffset = lPicHeight + GROUPITEMSPACING
        Else
            lOffset = m_lGroupItemTextHeight + GROUPITEMSPACING
        End If
'   *****
    End If
    
'   ***** Holds the scrolloffset in the group so that when reselecting the group
'   ***** the same images are visible
    If byScrollButton = Up Then
        If m_oSelectedGroup.ScrollOffset - lOffset < 0 Then
            m_oSelectedGroup.ScrollOffset = 0
        Else
            m_oSelectedGroup.ScrollOffset = m_oSelectedGroup.ScrollOffset - lOffset
        End If
    Else
        m_oSelectedGroup.ScrollOffset = m_oSelectedGroup.ScrollOffset + lOffset
    End If
'   *****
End Sub
Private Function GetGroupItemTextWidth(sText As String) As Long
'   *********************************************************************************
'   * Params:   sText: the text to get the textwidth for
'   * Return:   Long: the width of the text
'   * Purpose:  Gets the textwidth of the groupitem text. Sets the groupitem
'   *               font temporarily to get the textwidth then returns the font previously
'   *               in the dc.
'   *********************************************************************************
    Dim oTempFont As StdFont
    
    Set oTempFont = UserControl.Font
    Set UserControl.Font = m_oFont
    
    GetGroupItemTextWidth = TextWidth(sText + Space(3))
    
    Set UserControl.Font = oTempFont
    
End Function


Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_HelpID = 8
Attribute ShowAboutBox.VB_UserMemId = -552
Attribute ShowAboutBox.VB_MemberFlags = "40"
    
End Sub

Private Function GetGroupDifference() As Integer
'   *********************************************************************************
'   * Return:   Integer: number of visible groups between the current group
'   *               and the selected group
'   * Purpose:  Loops between the two groups counting the number of
'   *               visible groups between the two.
'   *********************************************************************************
    Dim i As Integer
    Dim iNumVisible As Integer
    Dim iStep As Integer
    
    If m_oSelectedGroup.Index > m_oCurrentGroup.Index Then
        iStep = 1
    Else
        iStep = -1
    End If

    For i = m_oCurrentGroup.Index To m_oSelectedGroup.Index Step iStep
        If m_oGroups(i).Visible Then
            iNumVisible = iNumVisible + 1
        End If
    Next

    GetGroupDifference = iNumVisible
End Function

Private Function GetClosestVisibleGroup(oTargetGroup As GTGroup) As GTGroup
'   *********************************************************************************
'   * Params:   oTargetGroup: the group to look for
'   * Return:   GTGroup: the Group that was found to be the closest group to
'   *               the target group that is visible.
'   * Purpose: Loops from the targetgroup to the end of the collection looking
'   *               for the first visible group. If none found (ie: the targetgroup is
'   *               the last group in the collection) then starts from the beginning
'   *               to find the first visible group. This is used when setting the
'   *               selected group, because a selected group must be visible.
'   *********************************************************************************
    Dim i As Integer
    
    For i = oTargetGroup.Index To m_oGroups.Count
        If m_oGroups(i).Visible Then
            Set GetClosestVisibleGroup = m_oGroups(i)
            Exit Function
        End If
    Next
    
    For i = 1 To oTargetGroup.Index
        If m_oGroups(i).Visible Then
            Set GetClosestVisibleGroup = m_oGroups(i)
            Exit Function
        End If
    Next
    
End Function
Private Sub PrintDisplayName(hdc As Long)
'   **************************************************************************
'   * Param:    hdc: the dc to draw on
'   * Purpose:  Draws the name of the control at design time when
'   *               there are no groups. Lets the user see it's not another
'   *               type of control.
'   **************************************************************************
    Dim r As RECT
    
    If Ambient.UserMode Then
        Exit Sub
    End If
    
    r.Left = m_iOffset
    r.Top = m_iOffset
    r.Bottom = r.Top + TextHeight("O") + 4
    r.Right = r.Left + TextWidth(Ambient.DisplayName) + 2

'    DrawText hdc, Ambient.DisplayName, r, DT_SINGLELINE Or DT_VCENTER, vbCenter
    m_CPaint.PaintText Ambient.DisplayName, m_oFont.Name, r.Left, r.Top, r.Right, r.Bottom, TextHeight("O"), _
                        DT_SINGLELINE Or DT_VCENTER, , m_oFont.Bold, m_oFont.Italic, m_oFont.Strikethrough, _
                        m_oFont.Underline, UserControl.BackColor, m_lForeColor
End Sub
Private Function CaptureMouse(x As Single, y As Single, iButton As Integer, Optional bRelease As Boolean = False) As Boolean
'   *********************************************************************************
'   * Params:   X: the left point, Y: the top point, iButton: the button on the mouse
'   *               that is down, bRelease: Optional: if the mouse is to be released
'   *               regardless of the whether the mouse is over the control or not
'   *               (used when the mouse is released off the control).
'   * Return:   Boolean: True if successful, False if not.
'   * Purpose: Captures the mouse when moved over the user control, releases
'   *               the capture when moved off the control or over a contained control.
'   *               Also turns off tooltips. Capturing is necessary because otherwise
'   *               don't know the mouse if off the control (if the mouse isn't down), and
'   *               active buttons would still be active even when they shouldn't be.
'   * Modified: Ver 1.0a    Fixed bug 503. Click no longer goes thru when control
'   *                               isn't active
'   *********************************************************************************
    Static s_bCaptured As Boolean
    Dim lRet As Long
    Dim lWidth As Long
    Dim lHeight As Long
    
    If Not s_bCaptured Then
        SetCapture UserControl.hWnd
        s_bCaptured = True
        
    ElseIf bRelease Then ' force to release
        s_bCaptured = False ' reset flag
        
        ActivateTopWindow
    
    ElseIf s_bCaptured Then  ' check to see if moved off the control
'   ***** Ver 1.0a Bug 503. Turns capture off so clicks don't go to the grouplist when it isn't active
        If Not IsGroupListActive() Then
            ReleaseCapture
            s_bCaptured = False ' reset flag
            m_CToolTips.HideToolTip
'   *****
        ElseIf x >= 0 And y >= 0 And x <= ScaleWidth And y <= ScaleHeight Or iButton Then
            ' within control
        Else
            ReleaseCapture
            s_bCaptured = False ' reset flag
            m_CToolTips.HideToolTip
        End If
        
    End If
    
    CaptureMouse = s_bCaptured
End Function

Private Function GetTopWindow() As Long
'   ***********************************************************************
'   * Return:   Long: the hwnd of the top level window
'   * Purpose:  Loops backwards thru the parents to get the top
'   *               level window.
'   ***********************************************************************
    Dim obj As Object

    On Error Resume Next

    Set obj = UserControl.Parent

    Do While Not obj Is Nothing
        Set obj = obj.Parent
        If Err Then
            Exit Do
        End If
    Loop

    On Error GoTo 0

    On Error Resume Next

    GetTopWindow = obj.hWnd
    If Err Then
        GetTopWindow = 0
    End If
End Function
Private Sub ActivateTopWindow()
'   ***********************************************************************
'   * Purpose: Gets the top hwnd and compares it to the activewindow.
'   *               If they're different, activate the top level window.
'   ***********************************************************************
    Dim lTopWindow As Long
    
    lTopWindow = GetTopWindow()
    If lTopWindow <> GetActiveWindow() Then
        SetForegroundWindow (lTopWindow)
    End If

End Sub

Private Function GroupsOverlap() As Boolean
'   ***********************************************************************
'   * Return:   Boolean: if groups overlap.
'   * Purpose: Calculates the height of all groups and if greater than
'   *               the height of the control, return true
'   ***********************************************************************
'   ***** The height is always in twips regardless of the scalemode of the control
    GroupsOverlap = ScaleX(m_oGroups.Count * m_lGroupHeight, vbPixels, vbTwips) > UserControl.Height
'   *****
End Function

Private Function IsGroupListActive() As Boolean
'   ***********************************************************************
'   * Return:   Boolean: If grouplist is the active window
'   * Purpose: Returns whether or not grouplist is the active window. Added for Ver 1.0a.
'   ***********************************************************************
    Dim pt As POINTAPI
    Dim lRet As Long
    
    lRet = GetCursorPos(pt)
    
    lRet = WindowFromPoint(pt.x, pt.y)
    
    IsGroupListActive = (lRet = UserControl.hWnd)
End Function
