Attribute VB_Name = "MGlobals"
'   ******************************************************************************
'   * Purpose:  This bas module holds all global constants and function declares
'   * File:         MGlobals.bas
'   ******************************************************************************
Option Explicit

'   ***** Application constants
Public Const SCROLL_BUTTONSIZE = 15
Public Const GROUPITEMSPACING = 2
Public Const GROUPITEMSTARTPOS = 2
'   *****

'   ***** common dialog constants
Public Const OFN_ALLOWMULTISELECT = &H200
'Public Const OFN_CREATEPROMPT = &H2000
'Public Const OFN_ENABLEHOOK = &H20
'Public Const OFN_ENABLETEMPLATE = &H40
'Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_EXPLORER = &H80000
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_LONGNAMES = &H200000
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_NOLONGNAMES = &H40000
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOVALIDATE = &H100
'   *****
'   ***** Common dialog error constants
'Public Const FNERR_BUFFERTOOSMALL = &H3003
'Public Const FNERR_FILENAMECODES = &H3000
Public Const FNERR_INVALIDFILENAME = &H3002
'Public Const FNERR_SUBCLASSFAILURE = &H3001
Public Const CDERR_DIALOGFAILURE = &HFFFF
Public Const CDERR_FINDRESFAILURE = &H6
Public Const CDERR_GENERALCODES = &H0
Public Const CDERR_INITIALIZATION = &H2
Public Const CDERR_LOADRESFAILURE = &H7
Public Const CDERR_LOADSTRFAILURE = &H5
Public Const CDERR_LOCKRESFAILURE = &H8
Public Const CDERR_MEMALLOCFAILURE = &H9
Public Const CDERR_MEMLOCKFAILURE = &HA
Public Const CDERR_NOHINSTANCE = &H4
Public Const CDERR_NOHOOK = &HB
Public Const CDERR_NOTEMPLATE = &H3
Public Const CDERR_REGISTERMSGFAIL = &HC
Public Const CDERR_STRUCTSIZE = &H1
'   *****

'   ***** drawframecontrol constants
Public Const DFC_SCROLL = 3             'Scroll bar
Public Const DFCS_SCROLLUP = &H0               'Up arrow of scroll bar
Public Const DFCS_SCROLLDOWN = &H1             'Down arrow of scroll bar
Public Const DFCS_SCROLLLEFT = &H2             'Left arrow of scroll bar
Public Const DFCS_SCROLLRIGHT = &H3            'Right arrow of scroll bar
Public Const DFCS_SCROLLCOMBOBOX = &H5         'Combo box scroll bar
Public Const DFCS_SCROLLSIZEGRIP = &H8         'Size grip
Public Const DFCS_SCROLLSIZEGRIPRIGHT = &H10   'Size grip in bottom-right corner of window
Public Const DFCS_INACTIVE = &H100      'Button is inactive (grayed)
Public Const DFCS_PUSHED = &H200        'Button is pushed
'   *****
'   ***** drawtext constants
Public Const DT_SINGLELINE = &H20
Public Const DT_BOTTOM = &H8
Public Const DT_CENTER = &H1
Public Const DT_LEFT = &H0
Public Const DT_RIGHT = &H2
Public Const DT_TOP = &H0
Public Const DT_VCENTER = &H4
Public Const DT_WORDBREAK = &H10
Public Const DT_NOCLIP = &H100
Public Const DT_END_ELIPSE = &H8000
Public Const DT_WORD_ELIPSE = &H40000
'   *****
'   ***** exttextout constants
Public Const ETO_CLIPPED = 4
Public Const ETO_GRAYED = 1
Public Const ETO_OPAQUE = 2
'   *****
'   ***** system color constants
Public Const COLOR_BTNFACE = 15
Public Const COLOR_HIGHLIGHT = 13
Public Const COLOR_BTNSHADOW = 16
'   *****
'   ***** systemmetrics constants
Public Const SM_CXHSCROLL = 21
Public Const SM_CXVSCROLL = 2
'   *****

Public Const TA_UPDATECP = 1

'   ***** subclass constants
Public Const WM_SYSCOLORCHANGE = &H15
'   *****

'   ***** API structures
Type POINTAPI
        x As Long
        y As Long
End Type

Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
'   *****

'   ***** API Declarations
Public Declare Function DrawTextAPI Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, _
        ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal _
        wFormat As Long) As Long
Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
        lpPoint As POINTAPI) As Long
Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function ExtTextOut Lib "gdi32" Alias "ExtTextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal wOptions As Long, lpRect As RECT, ByVal lpString As String, ByVal nCount As Long, lpDx As Long) As Long
Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Declare Function DrawFrameControl Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long
Declare Function ReleaseCapture Lib "user32" () As Long
Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function GetActiveWindow Lib "user32" () As Long
Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long ' ver 1.0a
Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long ' ver 1.0a
'   *****

Public Sub DrawText(hdc As Long, sText As String, rectCol As RECT, lOptions As Long, eColAlignment As GTAlignmentConstants)
'   ******************************************************************************
'   * Purpose:  This proc draws the text passed in on the hdc, which is also
'   *               passed in.
'   * Params:   hDC: the device context to be drawn on, sText: the text to be
'   *               drawn on the dc, rectCol: the rect that bounds the drawing, lOptions:
'   *               the DrawText options for how to draw the text, eColAlignment:
'   *               whether the text is left or right justified or centered.
'   ******************************************************************************
    Dim sTempText As String
    
    Select Case eColAlignment
        Case gtLeftAlign:
            lOptions = lOptions Or DT_LEFT
            sTempText = Space(3) & sText
        Case gtRightAlign:
            lOptions = lOptions Or DT_RIGHT
            sTempText = sText & Space(2)
        Case Else: ' center
            lOptions = lOptions Or DT_CENTER
            sTempText = sText
    End Select
    
    DrawTextAPI hdc, sTempText, Len(sTempText), rectCol, lOptions
    
End Sub

