VERSION 5.00
Begin VB.UserControl GTInTray 
   BorderStyle     =   1  'Fixed Single
   CanGetFocus     =   0   'False
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   780
   InvisibleAtRuntime=   -1  'True
   MaskColor       =   &H00FF0000&
   Picture         =   "GTInTray.ctx":0000
   PropertyPages   =   "GTInTray.ctx":030A
   ScaleHeight     =   480
   ScaleWidth      =   780
   ToolboxBitmap   =   "GTInTray.ctx":0322
   Begin GreenTreeInTray.GTMsgHook GTMsgHook1 
      Left            =   360
      Top             =   90
      _ExtentX        =   635
      _ExtentY        =   635
   End
End
Attribute VB_Name = "GTInTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

'Error codes
Private Const errInvalidPropertyValue = 380

'Windows Messages
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_LBUTTONDBLCLK = &H203

Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205

Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONUP = &H208

Private Const WM_TIMER = &H113

'The enumerations used in the Property window on VB
Public Enum GTAnimationStyleConstants
    gtCycle = 0
    gtPingPong = 1
End Enum

'Internal properties (due to the timer being in the MGlobals
'module, some properties are global
Private WithEvents m_colIcons As GTIcons
Attribute m_colIcons.VB_VarHelpID = -1

'Property strings
Private Const sAnimationStyle = "AnimationStyle"
Private Const sContinuous = "Continuous"
Private Const sEnabled = "Enabled"
Private Const sIconCount = "IconCount"
Private Const sIcon = "Icon#"
Private Const sInterval = "Interval"
Private Const sReverseAnimation = "ReverseAnimation"
Private Const sToolTipText = "ToolTipText"

'Events
Public Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_HelpID = 129
Public Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Attribute DblClick.VB_HelpID = 106
Public Event MouseDown(Button As Integer, Shift As _
        Integer, x As Single, y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Attribute MouseDown.VB_HelpID = 124
Public Event MouseMove(Button As Integer, Shift As _
        Integer, x As Single, y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Attribute MouseMove.VB_HelpID = 121
Public Event MouseUp(Button As Integer, Shift As _
        Integer, x As Single, y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Attribute MouseUp.VB_HelpID = 124

'Properties
Property Get Animate() As Boolean
Attribute Animate.VB_Description = "Returns/sets whether or not the icons will iterate through the collection."
Attribute Animate.VB_HelpID = 152
Attribute Animate.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Animate.VB_MemberFlags = "400"
    Animate = mGlobals.Animate
End Property

Property Let Animate(ByVal NewValue As Boolean)
    If Ambient.UserMode Then
        If NewValue Then
            StartTimer hWnd
        Else
            EndTimer
        End If
    End If
End Property

Public Property Get AnimationStyle() As GTAnimationStyleConstants
Attribute AnimationStyle.VB_Description = "Returns/sets the how the icons are animated."
Attribute AnimationStyle.VB_HelpID = 12
Attribute AnimationStyle.VB_ProcData.VB_Invoke_Property = ";Behavior"
    AnimationStyle = mGlobals.AnimationStyle
End Property

Public Property Let AnimationStyle(ByVal NewValue _
        As GTAnimationStyleConstants)
    'Be sure that NewValue is valid
    Select Case NewValue
        Case gtCycle, gtPingPong
            mGlobals.AnimationStyle = NewValue
            PropertyChanged sAnimationStyle
            
        Case Else
            MsgBox "Invalid property value"
    End Select
End Property

Public Property Get Continuous() As Boolean
Attribute Continuous.VB_Description = "Returns/sets if the icons continuously run."
Attribute Continuous.VB_HelpID = 100
Attribute Continuous.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Continuous = mGlobals.Continuous
End Property
    
Public Property Let Continuous(ByVal NewValue As Boolean)
    mGlobals.Continuous = NewValue
    PropertyChanged sContinuous
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_HelpID = 18
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
    UserControl.Enabled = NewValue
    PropertyChanged "Enabled" ' Ver 1.0a
End Property

Public Property Get Icons() As GTIcons
Attribute Icons.VB_Description = "Returns an object reference to a GTIcons collection."
Attribute Icons.VB_HelpID = 45
    Set Icons = m_colIcons
End Property

'Public Property Let Icons(ByVal NewValue As GTIcons)
'    MsgBox "Property is read-only"
'End Property

Public Property Get Interval() As Integer
Attribute Interval.VB_Description = "Returns/Sets the number of milliseconds between Animation cells."
Attribute Interval.VB_HelpID = 47
Attribute Interval.VB_ProcData.VB_Invoke_Property = ";Misc"
    Interval = mGlobals.Interval
End Property

Public Property Let Interval(ByVal NewValue As Integer)
    Dim lRet As Long
    
    If NewValue >= 0 And NewValue <= 32767 Then
        mGlobals.Interval = NewValue
                
        If NewValue = 0 And mGlobals.Interval > 0 Then
            EndTimer
        ElseIf mGlobals.Animate Then
            ' start the timer when setting the interval if animate is true
            StartTimer hWnd
        End If
    Else
        Error errInvalidPropertyValue
    End If
End Property

Public Property Get ReverseAnimation() As Boolean
Attribute ReverseAnimation.VB_Description = "Returns/sets if the icons animate from the last to the first."
Attribute ReverseAnimation.VB_HelpID = 68
Attribute ReverseAnimation.VB_ProcData.VB_Invoke_Property = ";Behavior"
    ReverseAnimation = mGlobals.ReverseAnimation
End Property

Public Property Let ReverseAnimation(ByVal NewValue As Boolean)
    mGlobals.ReverseAnimation = NewValue
End Property

Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
Attribute ToolTipText.VB_HelpID = 91
Attribute ToolTipText.VB_ProcData.VB_Invoke_Property = ";Text"
    ToolTipText = mGlobals.ToolTipText
End Property

Public Property Let ToolTipText(ByVal NewValue As String)
    mGlobals.ToolTipText = NewValue
    ChangeTrayIconToolTipText
End Property

Private Sub GTMsgHook1_Message(ByVal hWnd As Long, ByVal MsgID As Long, _
        ByVal wParam As Long, ByVal lParam As Long)
        
    Select Case MsgID
        Case msgTrayEvent
            TrayEventProc lParam
    End Select
End Sub

'Icons collection's events
Private Sub m_colIcons_IconAdded(ByVal Icon As GTIcon)
    Dim iCount As Integer
        
    PropertyChanged sIconCount
    
End Sub

Private Sub m_colIcons_IconChanged(ByVal Icon As GTIcon, Property _
        As String)
    PropertyChanged sIconCount
End Sub

Private Sub m_colIcons_IconRemoved(ByVal Icon As GTIcon)
    Select Case m_colIcons.Count
        Case 0
            EndTimer
            RemoveIconFromTray
        Case 1
            EndTimer
    End Select
    PropertyChanged sIconCount
End Sub

Private Sub UserControl_Initialize()
    Dim i As Integer
    
    GTMsgHook1.Windows.Add , , , UserControl.hWnd
    GTMsgHook1.Windows(1).Messages.Add , , msgTrayEvent
    
    mGlobals.InitIcons
    Set m_colIcons = mGlobals.m_colIcons
End Sub

Private Sub UserControl_InitProperties()
    GTMsgHook1.Subclass = Ambient.UserMode
    mGlobals.AnimationStyle = gtCycle
    mGlobals.Continuous = True
    UserControl.Enabled = True
    mGlobals.Interval = 0
    mGlobals.ReverseAnimation = False
    mGlobals.ToolTipText = ""
    
End Sub

Private Sub UserControl_Terminate()
    EndTimer
    RemoveIconFromTray
    
    mGlobals.m_colIcons.Clear
    mGlobals.Terminate
    
'   ***** Releases the icons
    m_colIcons.Clear
    Set m_colIcons = Nothing
'   *****

    GTMsgHook1.Subclass = False
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Dim iLoop As Integer
    
    GTMsgHook1.Subclass = Ambient.UserMode
    
    mGlobals.AnimationStyle = PropBag.ReadProperty(sAnimationStyle)
    mGlobals.Continuous = PropBag.ReadProperty(sContinuous)
    UserControl.Enabled = PropBag.ReadProperty(sEnabled)
    'Since the icons can not be stored in one property, we
    'must store Icons.Count and then each icon in its own property
    m_colIcons.ReadObjectProps PropBag
    
    mGlobals.Interval = PropBag.ReadProperty(sInterval)
    mGlobals.ReverseAnimation = PropBag.ReadProperty(sReverseAnimation)
    mGlobals.ToolTipText = PropBag.ReadProperty(sToolTipText)

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Dim iLoop As Integer
    
    PropBag.WriteProperty sAnimationStyle, mGlobals.AnimationStyle
    PropBag.WriteProperty sContinuous, mGlobals.Continuous
    PropBag.WriteProperty sEnabled, UserControl.Enabled
    If Not m_colIcons Is Nothing Then
        m_colIcons.WriteObjectProps PropBag
    Else
        PropBag.WriteProperty sIconCount, 0
    End If
    PropBag.WriteProperty sInterval, mGlobals.Interval
    PropBag.WriteProperty sReverseAnimation, mGlobals.ReverseAnimation
    PropBag.WriteProperty sToolTipText, mGlobals.ToolTipText
End Sub

Private Sub UserControl_Resize()
    'since the control itself is not visible, use
    'an image in a certain constant size
    Width = ScaleX(27, vbPixels, vbTwips)
    Height = ScaleY(28, vbPixels, vbTwips)
End Sub


Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_HelpID = 8
Attribute ShowAboutBox.VB_UserMemId = -552
Attribute ShowAboutBox.VB_MemberFlags = "40"
    
End Sub

Private Sub TrayEventProc(ByVal lParam As Long)
    Dim lpPoint As POINTAPI
    Dim iShft As Integer
    Dim iCtl As Integer
    Dim iAlt As Integer
    Dim iShift As Integer
    Dim x As Single, y As Single
    Dim iLButton As Integer
    Dim iRButton As Integer
    Dim iMButton As Integer
    Dim iButtonState As Integer
    
    'prepare parameters for Mouse events
    GetCursorPos lpPoint
    x = ScaleX(CSng(lpPoint.x), vbPixels, vbTwips)
    y = ScaleY(CSng(lpPoint.y), vbPixels, vbTwips)
    
    iShft = (GetKeyState(VK_SHIFT) And &H80) \ &H80
    iCtl = (GetKeyState(VK_CONTROL) And &H80) \ &H80
    iAlt = (GetKeyState(VK_MENU) And &H80) \ &H80
    iShift = (iShft * vbShiftMask) Or (iCtl * vbCtrlMask) Or _
            (iAlt * vbAltMask)
    
    iLButton = (GetKeyState(VK_LBUTTON) And &H80) \ &H80
    iRButton = (GetKeyState(VK_RBUTTON) And &H80) \ &H80
    iMButton = (GetKeyState(VK_MBUTTON) And &H80) \ &H80
    
    iButtonState = iLButton Or iRButton * 2 Or iMButton * 4
    'Coordinates in twips
    Select Case lParam
        Case WM_MOUSEMOVE
            RaiseEvent MouseMove(iButtonState, iShift, x, y)
            
        Case WM_LBUTTONDOWN
            iButtonState = iButtonState Or vbLeftButton
            RaiseEvent MouseDown(vbLeftButton, iShift, x, y)
            
        Case WM_LBUTTONUP
            iButtonState = iButtonState And Not vbLeftButton
            RaiseEvent Click
            RaiseEvent MouseUp(vbLeftButton, iShift, x, y)
            
        Case WM_LBUTTONDBLCLK
            RaiseEvent DblClick
            
        Case WM_RBUTTONDOWN
            iButtonState = iButtonState Or vbRightButton
            RaiseEvent MouseDown(vbRightButton, iShift, x, y)
            
        Case WM_RBUTTONUP
            iButtonState = iButtonState And Not vbRightButton
            RaiseEvent MouseUp(vbRightButton, iShift, x, y)
            
        Case WM_MBUTTONDOWN
            iButtonState = iButtonState Or vbMiddleButton
            RaiseEvent MouseDown(vbMiddleButton, iShift, x, y)
            
        Case WM_MBUTTONUP
            iButtonState = iButtonState And Not vbMiddleButton
            RaiseEvent MouseUp(vbMiddleButton, iShift, x, y)
    End Select
End Sub

Public Sub RemoveFromSystemTray()
'   ************************************************************************
'   * Purpose:  Stops all processing, including turning off MsgHook.
'   *               Should be called from Form_Unload.
'   * Added:    Ver 1.0a
'   ************************************************************************
    EndTimer
    RemoveIconFromTray
    GTMsgHook1.Subclass = False
End Sub
