VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "GTIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'property storage
Private m_oIcon As StdPicture
Private m_vKey As Variant
Private m_sName As String
Private m_vTag As Variant

'Interval variables
Private m_oCollection As GTIcons
Private m_iIndex As Integer

'Properties
Public Property Get Index() As Integer
    Index = m_iIndex
End Property

Friend Property Set Collection(NewValue As GTIcons)
    Set m_oCollection = NewValue
End Property

Public Property Get Icon() As StdPicture
Attribute Icon.VB_Description = "Returns/sets the image Icon."
Attribute Icon.VB_HelpID = 44
    Set Icon = m_oIcon
End Property

Public Property Set Icon(ByVal NewValue As StdPicture)
    Dim iCount As Integer
    
    If Not NewValue Is Nothing Then
        If NewValue <> 0 Then
            If NewValue.Type = vbPicTypeIcon Then
                Set m_oIcon = NewValue
            Else
                Error errInvalidPropertyValue
                Exit Property
            End If
        Else
            Set m_oIcon = Nothing
        End If
    Else
        Set m_oIcon = Nothing
    End If
    m_oCollection.ChildChanged Me, "Icon"
End Property

Friend Property Get InternalIndex() As Integer
    InternalIndex = m_iIndex
End Property

Friend Property Let InternalIndex(ByVal NewValue As Integer)
    m_iIndex = NewValue
End Property

Public Property Get Key() As Variant
Attribute Key.VB_Description = "Returns/sets the unique string of an object in a collection."
Attribute Key.VB_HelpID = 48
    Key = m_vKey
End Property

Public Property Let Key(ByVal NewValue As Variant)
    If m_oCollection.IsDuplicateKey(NewValue) Then
        Err.Raise 50001, , "Key already exists."
        Exit Property
    End If
    m_vKey = NewValue
    m_oCollection.ChildChanged Me, "Key"
End Property

Public Property Get Name() As String
Attribute Name.VB_Description = "Returns/sets an identiifier for the object."
Attribute Name.VB_HelpID = 61
    Name = m_sName
End Property

Public Property Let Name(ByVal NewValue As String)
    m_sName = NewValue
    m_oCollection.ChildChanged Me, "Name"
End Property

'   ***** Ver 1.0a Added Set
Public Property Set Tag(vTag As Variant)
Attribute Tag.VB_Description = "Stores any extra data needed for your program."
    Set m_vTag = vTag
    m_oCollection.ChildChanged Me, "Tag"
End Property
'   *****
Public Property Let Tag(ByVal NewValue As Variant)
'   ***** Ver 1.0a have to check if an object before checking the value
    If Not IsObject(m_vTag) Then
        If m_vTag = NewValue Then
            Exit Property
        End If
    End If
'   *****
    m_vTag = NewValue
    m_oCollection.ChildChanged Me, "Tag"
End Property
Public Property Get Tag() As Variant
'   ***** Ver 1.0a If an object, have to use Set
    If IsObject(m_vTag) Then
        Set Tag = m_vTag
    Else
        Tag = m_vTag
    End If
'   *****
End Property
'Public Property Get Tag() As Variant
'    Tag = m_vTag
'End Property
'
'Public Property Let Tag(ByVal NewValue As Variant)
'    m_vTag = NewValue
'    m_oCollection.ChildChanged Me, "Tag"
'End Property

Private Sub Class_Terminate()
    Set m_oIcon = Nothing
End Sub
