Attribute VB_Name = "MGlobals"
'   ******************************************************************************
'   * Purpose:  This bas module holds all global constants and function declares
'   * File:         MGlobals.bas
'   ******************************************************************************
Option Explicit

'   ***** Subclass constants
Public Const WM_ACTIVATE = &H6
Public Const WM_SYSCOLORCHANGE = &H15
'   *****
'   ***** drawframecontrol constants
Public Const DFC_SCROLL = 3             'Scroll bar
Public Const DFCS_SCROLLSIZEGRIP = &H8         'Size grip
Public Const DFCS_SCROLLSIZEGRIPRIGHT = &H10   'Size grip in
'   *****
'   ***** drawtext constants
Public Const DT_SINGLELINE = &H20
Public Const DT_BOTTOM = &H8
Public Const DT_CENTER = &H1
Public Const DT_LEFT = &H0
Public Const DT_RIGHT = &H2
Public Const DT_TOP = &H0
Public Const DT_VCENTER = &H4
Public Const DT_WORDBREAK = &H10
Public Const DT_NOCLIP = &H100
Public Const DT_END_ELIPSE = &H8000
Public Const DT_WORD_ELIPSE = &H40000
'   *****
'   ***** exttextout constants
Public Const ETO_CLIPPED = 4
Public Const ETO_GRAYED = 1
Public Const ETO_OPAQUE = 2
'   *****
'   ***** system color constants
Public Const COLOR_BTNFACE = 15
Public Const COLOR_HIGHLIGHT = 13
'   *****
'   ***** Gettextmetric constants
Public Const SM_CXHSCROLL = 21
Public Const SM_CXVSCROLL = 2
'   *****

Public Const TA_UPDATECP = 1

'   ***** API structures
Type POINTAPI
        x As Long
        y As Long
End Type

Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
'   *****

'   ***** API declarations
Public Declare Function DrawTextAPI Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, _
        ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal _
        wFormat As Long) As Long
Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
        lpPoint As POINTAPI) As Long
Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function ExtTextOut Lib "gdi32" Alias "ExtTextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal wOptions As Long, lpRect As RECT, ByVal lpString As String, ByVal nCount As Long, lpDx As Long) As Long
Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Declare Function InvalidateRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT, ByVal bErase As Long) As Long
Declare Function DrawFrameControl Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long
Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function GetActiveWindow Lib "user32" () As Long ' ver 1.0a
'   *****

Public Const IDC_SPLITTER = 110

' the variable is used to see if the control environment is at design or runtime
Public g_bAmbientUserMode As Boolean
Public g_bInternalUse As Boolean

Public Sub DrawText(hdc As Long, sText As String, rectCol As RECT, lOptions As Long, eColAlignment As GTAlignmentConstants)
'   ******************************************************************************
'   * Purpose:  This proc draws the text passed in on the hdc, which is also
'   *               passed in.
'   * Params:   hDC: the device context to be drawn on, sText: the text to be
'   *               drawn on the dc, rectCol: the rect that bounds the drawing, lOptions:
'   *               the DrawText options for how to draw the text, eColAlignment:
'   *               whether the text is left or right justified or centered.
'   ******************************************************************************
    Dim sTempText As String
    
    Select Case eColAlignment
        Case vbLeftJustify:
            lOptions = lOptions Or DT_LEFT
            sTempText = Space(2) & sText
        Case vbRightJustify:
            lOptions = lOptions Or DT_RIGHT
            sTempText = sText & Space(2)
        Case Else: ' center
            lOptions = lOptions Or DT_CENTER
            sTempText = sText
    End Select
    
    DrawTextAPI hdc, sTempText, Len(sTempText), rectCol, lOptions
    
End Sub


