Attribute VB_Name = "MCallBack"
Option Explicit
'   ***** API constants
Private Const GWL_WNDPROC = -4
'   *****
'   ***** API declarations used
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, _
                ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
                ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Public Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Public Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
'   *****
'   ***** module level variables
Private m_bSubClass As Boolean ' holds the subclass status
Private m_colWindows As Collection ' holds a collection of GTWindows collections
'   *****

Public Function CallbackProc(ByVal hWnd As Long, ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   *****************************************************************
'   * Params:   hWnd: the handle to the window being called with the message, lMsg: the windows message,
'   *               wParam: the wParam for the callback, lParam: the lParam for the callback
'   * Return:   Long: the return value after calling the default procedure.
'   * Purpose:  This procedure is the callback procedure. This proc gets called each time a message for
'   *               for one of the hWnds in the Windows collections is intercepted.
'   ******************************************************************
    Dim oWindow As GTWindow
    Dim oWindows As GTWindows
    Dim lPrevWndProc As Long 'holds the hwnd to the previous window procedure
    Dim bProcessDefaultProc As Boolean ' process the default message or not
    Dim eProcessType As GTProcessingConstants ' when to process the default message
    Dim bSendCurrentMessage As Boolean ' whether or not the message was found for a window
    Dim colSubclassedWindows As Collection
    Dim colAfterDefault As Collection
    Dim bProcessDefault As Boolean
    Dim oMessage As GTMessage ' ver 1.0a
    Dim lRet As Long ' ver 1.0a
    Dim i As Integer
    
'   ***** This block of code is to handle when the user hits the stop button or end buttons in VB
    If m_colWindows Is Nothing Then ' when the collection is nothing
        CallbackProc = UnhookAll(hWnd, lMsg, wParam, lParam) ' calls UnhookAll to end gracefully
        Exit Function
    End If
'   *****
    
    Set oMessage = New GTMessage ' ver 1.0a
    
'   ***** Ver 1.0a Fixes problem with 2 MsgHooks on same form
    Set colSubclassedWindows = New Collection
    Set colAfterDefault = New Collection

'    For Each oWindows In m_colWindows
''        If Not oWindows.Subclass Then ' checks to see if the window is not subclassed, should never happen
''            Exit Function
''        End If
'        If oWindows.Subclass Then
'
'            For Each oWindow In oWindows ' loop thru all the subclassed windows for the collection
'                If hWnd = oWindow.SubClassHwnd Then ' finds the hwnd that matches the param
'
'                    ' calls to see if the current message should be intercepted or not
'                    ' also returns whether or not to fire the default message and what order to process the default message
'                    bSendCurrentMessage = oWindows.SendCurrentMessage(oWindow, hWnd, lMsg, bProcessDefaultProc, eProcessType)
'
'                    If bSendCurrentMessage Then ' only when the messsage should be send
'                        ' only when the default message will be processed and the default proc is fired before our own
'                        If bProcessDefaultProc And eProcessType = gtAfterDefaultProc Then
'                            CallbackProc = CallWindowProc(oWindow.PrevWndProc, hWnd, lMsg, wParam, lParam)
'                        End If
'
'                        oWindows.ProcessMessage hWnd, lMsg, wParam, lParam ' fire our own event (Message)
'
'                        ' only when the default message will be processed and the default proc is fired after our own
'                        If bProcessDefaultProc And eProcessType = gtBeforeDefaultProc Then
'                            CallbackProc = CallWindowProc(oWindow.PrevWndProc, hWnd, lMsg, wParam, lParam)
'                        End If
'
'                    Else ' call the default proc
'                        CallbackProc = CallWindowProc(oWindow.PrevWndProc, hWnd, lMsg, wParam, lParam)
'                    End If
'
'                End If
'
'            Next
'        End If
'    Next
'   *****

    For Each oWindows In m_colWindows
        If oWindows.Subclass Then

            For Each oWindow In oWindows

                If oWindow.SubClassHwnd = hWnd Then
                    colSubclassedWindows.Add oWindow
                End If

            Next

        End If
    Next

    If colSubclassedWindows.Count = 0 Then
        Exit Function
    End If

    For Each oWindow In colSubclassedWindows
'   ***** Ver 1.0a Modified to use the return code and get the message object
       bSendCurrentMessage = oWindow.Windows.SendCurrentMessage(oWindow, hWnd, lMsg, bProcessDefaultProc, eProcessType, oMessage)
'        bSendCurrentMessage = oWindow.Windows.SendCurrentMessage(oWindow, hWnd, lMsg, bProcessDefaultProc, eProcessType)
'   *****

        If bSendCurrentMessage Then
            If bProcessDefaultProc Then
                bProcessDefault = True
            End If
            
            Select Case eProcessType
                Case gtBeforeDefaultProc
                    oWindow.Windows.ProcessMessage hWnd, lMsg, wParam, lParam ' fire our own event (Message)
                Case gtAfterDefaultProc
                    colAfterDefault.Add oWindow
            End Select
            
        Else
            bProcessDefault = True
        End If
        
    Next

    If bProcessDefault Then
        Set oWindow = colSubclassedWindows(1)
'   ***** Ver 1.0a
        
        lRet = CallWindowProc(oWindow.PrevWndProc, hWnd, lMsg, wParam, lParam)
        
        If eProcessType = gtAfterDefaultProc Then
            oMessage.ReturnValue = lRet
        End If
        
'        CallbackProc = CallWindowProc(oWindow.PrevWndProc, hWnd, lMsg, wParam, lParam)
'   *****
    End If
    
    For Each oWindow In colAfterDefault
        oWindow.Windows.ProcessMessage hWnd, lMsg, wParam, lParam ' fire our own event (Message)
    Next
    
'   ***** Ver 1.0a
    If oMessage.UseReturnValue Then
        lRet = oMessage.ReturnValue
    End If

    CallbackProc = lRet
'   *****
    
    Set colSubclassedWindows = Nothing
    Set colAfterDefault = Nothing
End Function

Public Sub Subclass(oWindows As GTWindows)
'   *****************************************************************
'   * Params:   GTWindows: a GTWindows collection that needs subclassing turned on or off
'   * Purpose:  Turns subclassing on or off for the GTWindows collection that was passed in.
'   *****************************************************************
    Dim oWindow As GTWindow
    
    For Each oWindow In oWindows
        If oWindows.Subclass Then ' checks the subclass property for the collection
            Hook oWindow ' subclass
        Else
            Unhook oWindow ' stop subclassing
        End If
    Next
    
End Sub

Public Sub Attach(oWindows As GTWindows)
'   *****************************************************************
'   * Params:   GTWindows: a GTWindows collection to add to the modules collection
'   * Purpose:  Adds the GTWindows collection to the modules collection
'   *****************************************************************
    ' The collection is initialized here because it's the only place when multiple uses
    If m_colWindows Is Nothing Then ' if nothing
        Set m_colWindows = New Collection ' initialize the collection
    End If
    
    m_colWindows.Add oWindows, "Collection " & m_colWindows.Count + 1 ' add to the collection
End Sub

Public Sub Detach(oWindows As GTWindows)
'   *****************************************************************
'   * Params:   GTWindows: a GTWindows collection to remove from the modules collection
'   * Purpose:  Removes the GTWindows collection from the modules collection
'   *****************************************************************
    Subclass oWindows 'calls subclass, so that subclassing can be turned off before removing
    m_colWindows.Remove GetItemIndex(oWindows) ' removes the GTWindows collection
End Sub

Private Sub Hook(oWindow As GTWindow)
'   *****************************************************************
'   * Params:   GTWindow: the window that needs to be subclassed
'   * Purpose:  Subclasses the window passed in. If the window is already subclassed
'   *               (this is found by checking the reference count (NUM_ADDEDPROPS)), and if not
'   *               subclasses the window. If not already subclassed, 2 properties are added to the window:
'   *               NUM_ADDEDPROPS and PREV_WNDPROC. PREV_WNDPROC holds the handle to the window
'   *               that was subclassed, so it can end gracefully on termination (when the user hits the stop or end
'   *               button in VB). NUM_ADDEDPROPS is incremented to show the number of references.
'   *****************************************************************
    Dim lPrevWndProc As Long
    Dim lNumProps As Long
    
    ' get the ref count
    lNumProps = GetProp(oWindow.SubClassHwnd, CTL_PREFIX & "NUM_ADDEDPROPS")
        
    ' check to see if the window has been subclassed already, if it has, it can't be again.
    If lNumProps = 0 Then ' the window hasn't been subclassed yet
        ' subclass the window
        lPrevWndProc = SetWindowLong(oWindow.SubClassHwnd, GWL_WNDPROC, AddressOf CallbackProc)
        SetProp oWindow.SubClassHwnd, CTL_PREFIX & "PREV_WNDPROC", lPrevWndProc ' write the prev window proc
    Else ' the window has been subclassed
        ' hold the prev wnd proc for calling in the Callback proc
        lPrevWndProc = GetProp(oWindow.SubClassHwnd, CTL_PREFIX & "PREV_WNDPROC")
    End If
    
    oWindow.PrevWndProc = lPrevWndProc ' stores in the window property
    
    ' increment the ref count
    SetProp oWindow.SubClassHwnd, CTL_PREFIX & "NUM_ADDEDPROPS", lNumProps + 1
    
End Sub
Private Sub Unhook(oWindow As GTWindow)
'   *****************************************************************
'   * Params:   oWindow: the window to stop subclassing
'   * Purpose:  Stops the window from being subclassed when the ref count is 0 (no other windows are subclassing it)
'   *               if the ref count is > 0, then just decrement the ref count.
'   *****************************************************************

    Dim lRet As Long
    Dim lNumProps As Long
    
    ' get the ref count
    lNumProps = GetProp(oWindow.SubClassHwnd, CTL_PREFIX & "NUM_ADDEDPROPS")
    
    ' Only when the ref count is 1 is the window unsubclassed.
    If lNumProps = 1 Then
        SetWindowLong oWindow.SubClassHwnd, GWL_WNDPROC, oWindow.PrevWndProc
        ' remove the property from the window
        lRet = RemoveProp(oWindow.SubClassHwnd, CTL_PREFIX & "PREV_WNDPROC")
    End If
    
    If lNumProps = 1 Then
        lRet = RemoveProp(oWindow.SubClassHwnd, CTL_PREFIX & "NUM_ADDEDPROPS") ' remove the ref count because no longer needed
    ElseIf lNumProps > 0 Then
        ' decrement the ref count
        SetProp oWindow.SubClassHwnd, CTL_PREFIX & "NUM_ADDEDPROPS", lNumProps - 1
    End If
    
End Sub

Private Function UnhookAll(ByVal hWnd As Long, ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   *****************************************************************
'   * Params:   hWnd: the window that was called in the callback, lMsg: the message called in the callback, wParam:
'   *               the wParam from the callback, lParam: the lParam from the call back.
'   * Return:   Long: the return value from calling the default proc.
'   * Purpose:  This function is called when the collection holding the GTWindows collections is no long valid.
'   *               The window is unsubclassed and/or the ref count is decremented here. This allows the app to
'   *               end gracefully when a user hits the stop or end button.
'   *****************************************************************
    Dim lNumProps As Long
    Dim i As Long
    Dim lPrevWndProc As Long
    Dim lRet As Long
    Dim lCurrentHwnd As Long
    
    On Error GoTo UnhookAll_err
    
    ' gets the hwnd of the prev proc from the window
    lPrevWndProc = GetProp(hWnd, CTL_PREFIX & "PREV_WNDPROC")
    
    ' as long as the hwnd of the prev proc is valid, it will be unsubclassed
    If lPrevWndProc <> 0 Then
        SetWindowLong hWnd, GWL_WNDPROC, lPrevWndProc
    End If
    
    lRet = RemoveProp(hWnd, CTL_PREFIX & "PREV_WNDPROC") ' remove the property that was added
    UnhookAll = CallWindowProc(lPrevWndProc, hWnd, lMsg, wParam, lParam) ' call the default proc

    lRet = RemoveProp(hWnd, CTL_PREFIX & "NUM_ADDEDPROPS") ' remove the ref count

    Exit Function
    
UnhookAll_err:
    
End Function

Private Function GetItemIndex(oTargetWindows As GTWindows) As Long
'   *****************************************************************
'   * Params:   oTargetWindowa: the GTWindows collection to get the index for.
'   * Return:   Long: the index of the collection in the collection
'   * Purpose:  Returns the index of the GTWindows collection. Used for removing from the main collection.
'   *****************************************************************
    Dim i As Long
    
    For i = 1 To m_colWindows.Count ' loop thru the collection
        If m_colWindows(i) Is oTargetWindows Then ' check for a match
            GetItemIndex = i ' return the position of the object in the collection
            Exit Function
        End If
    Next
    
End Function
