VERSION 5.00
Begin VB.UserControl GTMsgHook 
   CanGetFocus     =   0   'False
   ClientHeight    =   1455
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2085
   InvisibleAtRuntime=   -1  'True
   MaskColor       =   &H00FFFFFF&
   Picture         =   "MsgHook.ctx":0000
   PropertyPages   =   "MsgHook.ctx":030A
   ScaleHeight     =   97
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   139
   ToolboxBitmap   =   "MsgHook.ctx":031A
End
Attribute VB_Name = "GTMsgHook"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'   ******************************************************************************
'   * Purpose:  This is the subclass control.
'   * File:         MsgHook.ctl
'   ******************************************************************************
Option Explicit

Private WithEvents m_oWindows As GTWindows ' holds the GTWindow objects
Attribute m_oWindows.VB_VarHelpID = -1

'   ***** Fired when a message in the Messages collection is intercepted
Event Message(ByVal hWnd As Long, ByVal MsgID As Long, ByVal wParam As Long, ByVal lParam As Long)
Attribute Message.VB_Description = "Occurs when a Message is intercepted that is one of the messages the user requested."
Attribute Message.VB_HelpID = 125
Attribute Message.VB_MemberFlags = "200"
'   *****

'   ***** Returns a reference to the GTWindows collection
Public Property Get Windows() As GTWindows
Attribute Windows.VB_Description = "Returns a reference to a collection of GTWindow objects."
    Set Windows = m_oWindows
End Property
'   *****

'   ***** Returns/sets the Subclass property. Starts subclassing the windows in the Windows collection
Public Property Get Subclass() As Boolean
Attribute Subclass.VB_Description = "Toggles Subclassing on and off. "
Attribute Subclass.VB_HelpID = 84
Attribute Subclass.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Subclass.VB_UserMemId = 0
Attribute Subclass.VB_MemberFlags = "400"
    Subclass = m_oWindows.Subclass
End Property

Public Property Let Subclass(bSubclass As Boolean)
    
'   ***** Ver 1.0a No need to set again
    If m_oWindows.Subclass = bSubclass Then
        Exit Property
    End If
'   *****
    
    If Ambient.UserMode Then
        If Not m_oWindows.IsHwndPresent Then
            Err.Raise vbObjectError + 1051, , "No windows have been subclassed. MsgHook needs the hWnd of at least one window to subclass."
            Exit Property
        End If
        
        m_oWindows.Subclass = bSubclass
        
        MCallBack.Subclass m_oWindows
    
    Else
        m_oWindows.Subclass = bSubclass
    End If
End Property
'   *****

'   ****** Called when a Window is added to the Windows collection. Need this because
'   ***** there is no notification when a window is added
Private Sub m_oWindows_Added(Window As GTWindow)
    PropertyChanged "Windows"
End Sub
'   *****

'   ***** Called when the Message event needs to be fired.
Private Sub m_oWindows_CallBack(hWnd As Long, lMsg As Long, wParam As Long, lParam As Long)
    RaiseEvent Message(hWnd, lMsg, wParam, lParam)
End Sub
'   *****

'   ****** Called when a property on a GTWindow object has changed. Need this because
'   ***** there is no notification when a GTWindow object is changed
Private Sub m_oWindows_Changed(Window As GTWindow, sProperty As String)
    PropertyChanged "Windows"
End Sub
'   *****

'   ****** Called when a Message is added to the Messages collection for a GTWindow object.
'   ***** Need this because there is no notification when a message is added
Private Sub m_oWindows_MessageAdded(Message As GTMessage)
    PropertyChanged "Messages"
End Sub
'   *****

'   ****** Called when a property on a GTMessage object has changed. Need this because
'   ***** there is no notification when a GTMessage object is changed
Private Sub m_oWindows_MessageChanged(Message As GTMessage, Property As String)
    PropertyChanged "Messages"
End Sub
'   *****

'   ***** Called when a GTMessage object is removed. Need this because there is no
'   ***** notification when a GTMessage object is removed.
Private Sub m_oWindows_MessageRemoved(Message As GTMessage)
    PropertyChanged "Messages"
End Sub
'   *****

'   ***** Called when a GTWindow object is removed. Need this because there is no
'   ***** notification when a GTWindow object is removed.
Private Sub m_oWindows_Removed(Window As GTWindow)
    PropertyChanged "Windows"
End Sub
'   *****

Private Sub UserControl_Initialize()
'   *************************************************************************
'   * Purpose:  Initializes the Windows collection and adds the windows collection to the collection
'   *               in MCallback.
'   *************************************************************************
    Set m_oWindows = New GTWindows
    
    MCallBack.Attach m_oWindows
    
End Sub

#If MSGHOOK Then
Private Sub UserControl_InitProperties()

End Sub
#End If

#If MSGHOOK Then
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'   *************************************************************************
'   * Purpose:  Reads the property from the property bag. This is only for properties
'   *               set from the proppage.
'   *************************************************************************

    m_oWindows.ReadObjectProps PropBag
    
    SubclassByWindowName
    
End Sub
#End If

Private Sub UserControl_Resize()
'   *************************************************************************
'   * Purpose:  Resizes the control to 24x24 at all times.
'   *************************************************************************
    Width = ScaleX(24, vbPixels, vbTwips)
    Height = ScaleY(24, vbPixels, vbTwips)
End Sub

Private Sub UserControl_Terminate()
'   *************************************************************************
'   * Purpose:  Turns subclassing off, removes the Windows collection from
'   *               the collection in MCallback, and releases the Windows collection
'   *************************************************************************

    m_oWindows.Subclass = False
    MCallBack.Detach m_oWindows
    Set m_oWindows = Nothing
    
End Sub


Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_HelpID = 8
Attribute ShowAboutBox.VB_UserMemId = -552
Attribute ShowAboutBox.VB_MemberFlags = "40"

End Sub

#If MSGHOOK Then
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
'   *************************************************************************
'   * Purpose:  Saves the properties to the property bag. Only for properties
'   *               changed at design time thru the proppages.
'   *************************************************************************

    m_oWindows.WriteObjectProps PropBag
    
End Sub
#End If

Private Function IsOtherMsgHook() As Boolean
'   *************************************************************************
'   * Return:   Boolean: True: another GTMsgHook control is on the form, False:
'   *               No other GTMsgHook controls.
'   * Purpose:  Moves up the container to the top level and gets the
'   *               Controls collection for it. Usually a form or doc object, etc.
'   *               Then loops thru the Controls collection looking another GTMsgHook
'   *               control.
'   *************************************************************************

    Dim obj As Object
    Dim ctl As Control
    Dim iCtls As Integer
    
    On Error Resume Next
    
    Set obj = UserControl.Parent
    
    Do While Not obj Is Nothing
        Set obj = obj.Parent
        If Err Then
            Exit Do
        End If
    Loop
    
    For Each ctl In obj.Controls
        If TypeOf ctl Is GTMsgHook Then
            iCtls = iCtls + 1
            If iCtls > 1 Then
                IsOtherMsgHook = True
                Exit Function
            End If
        End If
    Next
        
    IsOtherMsgHook = False
    
End Function

Public Function GetControlNames() As Variant
Attribute GetControlNames.VB_MemberFlags = "40"
'   *************************************************************************
'   * Return:   Variant: False if no controls or top level hwnds were found, Array of
'   *               control names when at least 1 hwnd is found.
'   * Purpose:  Moves up the container to the top level and gets the
'   *               Controls collection for it. Usually a form or doc object, etc. Holds
'   *               the top level name if it has an hwnd. Then loops thru the Controls
'   *               collection looking for controls with hWnds and adds those names to the
'   *               array. This is only called from the proppage.
'   *************************************************************************
    Dim aNames As Variant
    Dim obj As Object
    Dim ctl As Control
    Dim lTemp As Long
    Dim i As Long
    
    On Error Resume Next
    
    Set obj = UserControl.Parent
    
    Do While Not obj Is Nothing
        Set obj = obj.Parent
        If Err Then
            Exit Do
        End If
    Loop
    
    On Error GoTo 0
    
    On Error Resume Next
    
    ReDim aNames(1) As Variant
    aNames(i) = obj.Name
    i = i + 1
    
    For Each ctl In obj.Controls
        lTemp = ctl.hWnd
        If Err Then
            On Error GoTo 0
            On Error Resume Next
        Else
            ReDim Preserve aNames(i + 1) As Variant
            aNames(i) = ctl.Name
            i = i + 1
        End If
        
    Next
    
    If i = 0 Then
        GetControlNames = False
    Else
        GetControlNames = aNames
    End If
    
End Function

Private Sub SubclassByWindowName()
'   *************************************************************************
'   * Purpose:  Moves up the container to the top level and gets the
'   *               Controls collection for it. Usually a form or doc object, etc.
'   *               Checks the top level and the controls in the Controls collection
'   *               to see if any hWnds match the hWnds in the Windows collection.
'   *               If so, the subclass property of the Windows collection is set to
'   *               True. This is done for the Windows added thru the proppages at
'   *               design time.
'   *************************************************************************
    Dim obj As Object
    Dim ctl As Control
    Dim oWindow As GTWindow
    
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        Exit Sub
    End If
    
    If m_oWindows.Count = 0 Then
        Exit Sub
    End If
    
    Set obj = UserControl.Parent
    
    Do While Not obj Is Nothing
        Set obj = obj.Parent
        If Err Then
            Exit Do
        End If
    Loop
    
    On Error GoTo 0
    
    On Error Resume Next
    
    For Each oWindow In m_oWindows
    
        If oWindow.Name = obj.Name Then
            oWindow.SubClassHwnd = obj.hWnd ' don't worry about checking the error after this line.
        Else
            For Each ctl In obj.Controls
                If oWindow.Name = ctl.Name Then
                
                    oWindow.SubClassHwnd = ctl.hWnd
                    If Not Err Then
                        Exit For
                    End If
                
                End If
                
            Next
        End If
        
        Err.Clear
    Next
    
End Sub

Public Function LoByte(Value As Long) As Long
Attribute LoByte.VB_Description = "Returns the low order byte from an long value."
Attribute LoByte.VB_HelpID = 157
'   *************************************************************************
'   * Param:    Value: the value to return the lobyte for.
'   * Return:   Long: the lobyte of the param
'   * Purpose:  Returns the lobyte of the param. This is generally used
'   *               with callbacks and the wParam.
'   *************************************************************************
      LoByte = Value And &HFF&
End Function
Public Function HiByte(Value As Long) As Long
Attribute HiByte.VB_Description = "Returns the high order byte from a long value."
Attribute HiByte.VB_HelpID = 155
'   *************************************************************************
'   * Param:    Value: the value to return the hibyte for.
'   * Return:   Long: the hibyte of the param
'   * Purpose:  Returns the hibyte of the param. This is generally used
'   *               with callbacks and the wParam.
'   *************************************************************************
      HiByte = Value \ &H100 And &HFF&
End Function
Public Function LoWord(Value As Long) As Long
Attribute LoWord.VB_Description = "Returns the low order word from a long value."
Attribute LoWord.VB_HelpID = 158
'   *************************************************************************
'   * Param:    Value: the value to return the loword for.
'   * Return:   Long: the loword of the param
'   * Purpose:  Returns the loword of the param. This is generally used
'   *               with callbacks and the wParam.
'   *************************************************************************
      LoWord = Value And &HFFFF&
End Function
Public Function HiWord(Value As Long) As Long
Attribute HiWord.VB_Description = "Returns the high order word from a long value."
Attribute HiWord.VB_HelpID = 156
'   *************************************************************************
'   * Param:    Value: the value to return the hiword for.
'   * Return:   Long: the hiword of the param
'   * Purpose:  Returns the hiword of the param. This is generally used
'   *               with callbacks and the wParam.
'   *************************************************************************
      HiWord = Value \ &H10000 And &HFFFF&
End Function


