VERSION 5.00
Begin VB.UserControl GTProgress 
   Alignable       =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   465
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4470
   ClipControls    =   0   'False
   PropertyPages   =   "GTProgress.ctx":0000
   ScaleHeight     =   31
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   298
   ToolboxBitmap   =   "GTProgress.ctx":0030
End
Attribute VB_Name = "GTProgress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

'Error Codes
Private Const errInvalidPropertyValue = 380

'Windows Messages
Private Const WM_SYSCOLORCHANGE = &H15

'The enumerations used in the Property window in VB
Public Enum GTAppearanceConstants
    gtFlat = 0
    gt3D = 1
End Enum

Public Enum GTBorderStyleConstants
    gtNone = 0
    gtFixedSingle = 1
End Enum

Public Enum GTOrientationConstants
    gtHorizontal = 0
    gtVertical = 1
End Enum

Public Enum GTProgressStyleConstants
    gtSegmented = 0
    gtFlood = 1
    gtVolume = 2
End Enum

'Internal Property Storage
Private m_eAlign As AlignConstants
Private m_eAppearance As GTAppearanceConstants
Private m_eBorderStyle As GTBorderStyleConstants
Private m_sCaption As String
Private m_oFloodColor As OLE_COLOR
Private m_oFont As IFontDisp
Private m_oForeColor As OLE_COLOR
Private m_lHelpContextID As Long
Private m_lMax As Single
Private m_lMin As Single
Private m_eOrientation As GTOrientationConstants
Private m_lOLEDropMode As Long
Private m_eStyle As GTProgressStyleConstants
Private m_lValue As Single
Private m_lWhatsThisHelpID As Long

'Internal Variables
Private m_bNoResize As Boolean

'Property Strings
Private Const sAlign = "Align"
Private Const sAppearance = "Appearance"
Private Const sBackColor = "BackColor"
Private Const sBorderStyle = "BorderStyle"
Private Const sCaption = "Caption"
Private Const sEnabled = "Enabled"
Private Const sFloodColor = "FloodColor"
Private Const sFont = "Font"
Private Const sForeColor = "ForeColor"
Private Const sHelpContextID = "HelpContextID"
Private Const sMax = "Max"
Private Const sMin = "Min"
Private Const sMouseIcon = "MouseIcon"
Private Const sMouseIconNone = "MouseIconNone"
Private Const sMousePointer = "MousePointer"
Private Const sOrientation = "Orientation"
Private Const sOLEDropMode = "OLEDropMode"
Private Const sShowPercent = "ShowPercent"
Private Const sStyle = "Style"
Private Const sValue = "Value"
Private Const sWhatsThisHelpID = "WhatsThisHelpID"

'Events
Public Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_HelpID = 129
Public Event DblClick()
Attribute DblClick.VB_Description = "Occurs when you press and release a mouse button and then press and release it again over an object."
Attribute DblClick.VB_HelpID = 106
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Attribute KeyDown.VB_HelpID = 32
Public Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Attribute KeyPress.VB_HelpID = 36
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Attribute KeyUp.VB_HelpID = 32
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseDown.VB_Description = "MouseDown event"
Attribute MouseDown.VB_HelpID = 124
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseMove.VB_Description = "MouseMove event"
Attribute MouseMove.VB_HelpID = 121
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseUp.VB_Description = "MouseUp event"
Attribute MouseUp.VB_HelpID = 124
Public Event ValueChanged()
Attribute ValueChanged.VB_Description = "Occurs when the Value property changes."
Attribute ValueChanged.VB_HelpID = 109

'Property Delarations
'   ***** Returns the hwnd of the user control
Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property
'   *****

Public Property Get Appearance() As GTAppearanceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not controls, Forms or an MDIForm are painted at run time with 3-D effects."
Attribute Appearance.VB_HelpID = 22
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
    Appearance = m_eAppearance
End Property

Public Property Let Appearance(ByVal NewValue As GTAppearanceConstants)
    Select Case NewValue
        Case gtFlat
            m_eAppearance = NewValue
            UserControl.BackColor = vbWindowBackground
            PropertyChanged sAppearance
            Draw True
        Case gt3D
            m_eAppearance = NewValue
            PropertyChanged sAppearance
            UserControl.BackColor = vbButtonFace
            Draw True
        Case Else
            Error errInvalidPropertyValue
    End Select
End Property

Public Property Get BorderStyle() As GTBorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style"
Attribute BorderStyle.VB_HelpID = 2
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_eBorderStyle
End Property

Public Property Let BorderStyle(ByVal NewValue As GTBorderStyleConstants)
    Select Case NewValue
        Case gtNone, gtFixedSingle
            m_eBorderStyle = NewValue
            PropertyChanged sBorderStyle
            Draw True
        Case Else
            Error errInvalidPropertyValue
    End Select
End Property

Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar."
Attribute Caption.VB_HelpID = 21
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute Caption.VB_UserMemId = -518
    Caption = m_sCaption
End Property

Property Let Caption(ByVal NewValue As String)
    m_sCaption = NewValue
    PropertyChanged sCaption
    Draw True
End Property

Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_HelpID = 18
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Enabled = UserControl.Enabled
End Property

Property Let Enabled(ByVal NewValue As Boolean)
    UserControl.Enabled = NewValue
    PropertyChanged "Enabled"
End Property

Property Get FloodColor() As OLE_COLOR
Attribute FloodColor.VB_Description = "Returns/sets the color used to display the flood."
Attribute FloodColor.VB_HelpID = 29
Attribute FloodColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute FloodColor.VB_UserMemId = -510
    FloodColor = m_oFloodColor
End Property

Property Let FloodColor(ByVal NewValue As OLE_COLOR)
    m_oFloodColor = NewValue
    PropertyChanged sFloodColor
    Draw
End Property

Property Get Font() As StdFont
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_HelpID = 31
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512
    Set Font = m_oFont
End Property

Property Set Font(ByVal NewValue As StdFont)
    Set m_oFont = NewValue
    Set UserControl.Font = m_oFont
    PropertyChanged sFont
    Draw True
End Property

Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute ForeColor.VB_HelpID = 5000
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    ForeColor = m_oForeColor
End Property

Property Let ForeColor(ByVal NewValue As OLE_COLOR)
    m_oForeColor = NewValue
    UserControl.ForeColor = m_oForeColor
    PropertyChanged sForeColor
    Draw
End Property

Property Get HelpContextID() As Long
Attribute HelpContextID.VB_Description = "Specifies the default Help file context ID for an object."
Attribute HelpContextID.VB_HelpID = 41
Attribute HelpContextID.VB_ProcData.VB_Invoke_Property = ";Misc"
    HelpContextID = m_lHelpContextID
End Property

Property Let HelpContextID(ByVal NewValue As Long)
    m_lHelpContextID = NewValue
    PropertyChanged sHelpContextID
End Property

Public Property Get Max() As Single
Attribute Max.VB_Description = "Returns/sets a control's maximum value."
Attribute Max.VB_HelpID = 55
Attribute Max.VB_ProcData.VB_Invoke_Property = ";Misc"
    Max = m_lMax
End Property

Public Property Let Max(ByVal NewValue As Single)
    If NewValue <= m_lMin Then
        Err.Raise errInvalidPropertyValue, , "Max must be greater than Min."
        Exit Property
    End If
    m_lMax = NewValue
    PropertyChanged sMax
    Draw True
End Property

Public Property Get Min() As Single
Attribute Min.VB_Description = "Returns/sets a control's minimum value."
Attribute Min.VB_HelpID = 56
Attribute Min.VB_ProcData.VB_Invoke_Property = ";Misc"
    Min = m_lMin
End Property

Public Property Let Min(ByVal NewValue As Single)
    If NewValue >= m_lMax Then
        Err.Raise errInvalidPropertyValue, , "Min must be between 0 and Max-1."
        Exit Property
    End If
    m_lMin = NewValue
    PropertyChanged sMin
    Draw True
End Property

Public Property Get MouseIcon() As StdPicture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
Attribute MouseIcon.VB_HelpID = 58
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = ";Misc"
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal NewValue As StdPicture)
    If Not NewValue Is Nothing Then
        If NewValue <> 0 Then
            If NewValue.Type = vbPicTypeIcon Then
                Set UserControl.MouseIcon = NewValue
            Else
                Err.Raise errInvalidPropertyValue
                Exit Property
            End If
        Else
            Set UserControl.MouseIcon = Nothing
        End If
    Else
        Set UserControl.MouseIcon = Nothing
    End If
    PropertyChanged sMouseIcon
End Property

Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
Attribute MousePointer.VB_HelpID = 59
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Misc"
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal NewValue As MousePointerConstants)
    UserControl.MousePointer = NewValue
    PropertyChanged sMousePointer
End Property

Public Property Get Orientation() As GTOrientationConstants
Attribute Orientation.VB_Description = "Wether the control is displayed horizontally or vertically."
Attribute Orientation.VB_HelpID = 63
Attribute Orientation.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Orientation = m_eOrientation
End Property

Public Property Let Orientation(ByVal NewValue As GTOrientationConstants)
    Dim dTemp As Double
    
    If Not UserControl.Enabled Then
        Exit Property
    End If
    If m_eOrientation <> NewValue Then
        'Unlike other controls, this one needs to be sure that the value changed,
        'since changing the orientation swaps the height and width. This way setting
        'the control to horizontal when it already is horizontal doesn't affect the
        'height and width.
        If m_eAlign = vbAlignNone Then
            Select Case NewValue
                Case gtHorizontal, gtVertical
                    m_eOrientation = NewValue
                    PropertyChanged sOrientation
                    'Due to the fact that changing the Width and Height in the next few
                    'statements causes a visible flicker, I turn off the Resize Event's
                    'draw call until I set the Height.
                    m_bNoResize = True
                    dTemp = Width
                    Width = Height
                    'Turn on the Resize Event's draw call to redraw the control when the
                    'Height changes in the following line.
                    m_bNoResize = False
                    Height = dTemp
                Case Else
                    'The user entered an undefined value so raise an
                    '"Invalid Property Value" error
                    Error errInvalidPropertyValue
            End Select
        Else
            Err.Raise errInvalidPropertyValue, , "Cannot change Orientation when aligned."
        End If
    End If
End Property

Public Property Get Style() As GTProgressStyleConstants
Attribute Style.VB_Description = "How the flood is displayed."
Attribute Style.VB_HelpID = 83
Attribute Style.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Style = m_eStyle
End Property

Public Property Let Style(ByVal NewValue As GTProgressStyleConstants)
    Select Case NewValue
        Case gtSegmented, gtFlood, gtVolume
            m_eStyle = NewValue
            PropertyChanged sStyle
            Draw True
        Case Else
            Error errInvalidPropertyValue
    End Select
End Property

Public Property Get Value() As Single
Attribute Value.VB_Description = "Returns or sets a control's current Value property."
Attribute Value.VB_HelpID = 94
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Misc"
Attribute Value.VB_MemberFlags = "400"
    Value = m_lValue
End Property

Public Property Let Value(ByVal NewValue As Single)
    Dim bClear As Boolean
    
    'Value cannot go outside the range of Min - Max.
    If NewValue < m_lMin Or NewValue > m_lMax Then
        Error errInvalidPropertyValue
        Exit Property
    End If
    'Erase old progress bar if the new value is less than the old or a caption exists.
    bClear = m_lValue > NewValue Or m_sCaption <> ""
    m_lValue = NewValue
    RaiseEvent ValueChanged
    PropertyChanged sValue
    Draw bClear
End Property

Public Property Get WhatsThisHelpID() As Long
Attribute WhatsThisHelpID.VB_Description = "Returns/sets an associated context number for an object."
Attribute WhatsThisHelpID.VB_HelpID = 97
Attribute WhatsThisHelpID.VB_ProcData.VB_Invoke_Property = ";Misc"
    WhatsThisHelpID = m_lWhatsThisHelpID
End Property

Public Property Let WhatsThisHelpID(ByVal NewValue As Long)
    m_lWhatsThisHelpID = NewValue
End Property

'   ***** Ver 1.0a No longer used
''This routine handles the Windows Messages
'Private Sub GTMsgHook1_Message(ByVal hWnd As Long, ByVal MsgID As Long, ByVal wParam As Long, ByVal lParam As Long)
'    Select Case MsgID
'        Case WM_SYSCOLORCHANGE
'            If m_eAppearance = gt3D Then
'                UserControl.BackColor = vbButtonFace
'            Else
'                UserControl.BackColor = vbWindowBackground
'            End If
'            Draw True
'    End Select
'End Sub
'   *****

Private Sub UserControl_Initialize()
'   ***** Ver 1.0a No longer used
'    Dim oWindow As GTWindow
'    Dim oMessage As GTMessage
'   *****

'    UserControl.BackColor = vbButtonFace

'   ***** Ver 1.0a No longer used
'    Set oWindow = GTMsgHook1.Windows.Add(, , , UserControl.hWnd)
'    If Not oWindow Is Nothing Then
'        Set oMessage = oWindow.Messages.Add(, , WM_SYSCOLORCHANGE, "WM_SYSCOLORCHANGE")
'    End If
'   *****

    m_bNoResize = False
End Sub

Private Sub UserControl_InitProperties()
'   ***** Ver 1.0a No longer used
'    'Initialize the subclass routine to recieve Windows messages.
'#If DEBUG_SWITCH Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
'   *****
    'Set the properties to their initial values
    m_eAppearance = gt3D
    m_eBorderStyle = gtFixedSingle
    m_sCaption = "50%"
    UserControl.Enabled = True
    m_oFloodColor = vbHighlight
    m_oForeColor = vbHighlightText
    UserControl.ForeColor = m_oForeColor
    Set m_oFont = UserControl.Font
    m_lHelpContextID = 0
    m_lMax = 100
    m_lMin = 0
    m_lOLEDropMode = 0
    m_eStyle = gtSegmented
    m_lValue = -1
    m_lWhatsThisHelpID = 0

End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'   ***** Ver 1.0a No longer used
'#If DEBUG_SWITCH Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
'    UserControl.BackColor = vbButtonFace
'   *****
    m_bNoResize = False
    
    On Error GoTo UserControl_ReadProperties_err
    
    m_eAlign = PropBag.ReadProperty(sAlign)
    m_eAppearance = PropBag.ReadProperty(sAppearance)
    UserControl.BackColor = PropBag.ReadProperty(sBackColor)
    m_eBorderStyle = PropBag.ReadProperty(sBorderStyle)
    m_sCaption = PropBag.ReadProperty(sCaption)
    UserControl.Enabled = PropBag.ReadProperty(sEnabled)
    m_oFloodColor = PropBag.ReadProperty(sFloodColor)
    m_oForeColor = PropBag.ReadProperty(sForeColor)
    UserControl.ForeColor = m_oForeColor
    Set m_oFont = PropBag.ReadProperty(sFont)
    Set UserControl.Font = m_oFont
    m_lHelpContextID = PropBag.ReadProperty(sHelpContextID)
    m_lMax = PropBag.ReadProperty(sMax)
    m_lMin = PropBag.ReadProperty(sMin)
    Set UserControl.MouseIcon = PropBag.ReadProperty(sMouseIcon, Nothing)
    UserControl.MousePointer = PropBag.ReadProperty(sMousePointer, vbDefault)
    m_lOLEDropMode = PropBag.ReadProperty(sOLEDropMode)
    m_eOrientation = PropBag.ReadProperty(sOrientation)
    m_eStyle = PropBag.ReadProperty(sStyle)
    m_lValue = m_lMin
    m_lWhatsThisHelpID = PropBag.ReadProperty(sWhatsThisHelpID)
    
    Exit Sub
    
UserControl_ReadProperties_err:
    '***
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next ' Ver 1.0a
    
    If Not m_bNoResize Then
        'Check to see if the control's Align property changed
        If m_eAlign <> UserControl.Extender.Align Then
            m_eAlign = UserControl.Extender.Align
            'Adjust Orientation to suit the new alignment
            Select Case m_eAlign
                Case vbAlignTop, vbAlignBottom
                    m_eOrientation = gtHorizontal
                Case vbAlignLeft, vbAlignRight
                    m_eOrientation = gtVertical
                Case vbAlignNone
                    'do nothing
            End Select
        End If
        Draw True
    End If
End Sub

Private Sub UserControl_Show()
    Draw
End Sub

Private Sub UserControl_Terminate()
'   ***** Ver 1.0a No longer used
'    GTMsgHook1.Subclass = False
'   *****
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty sAlign, m_eAlign
    PropBag.WriteProperty sAppearance, m_eAppearance
    PropBag.WriteProperty sBackColor, UserControl.BackColor
    PropBag.WriteProperty sBorderStyle, m_eBorderStyle
    PropBag.WriteProperty sCaption, m_sCaption
    PropBag.WriteProperty sEnabled, UserControl.Enabled
    PropBag.WriteProperty sFloodColor, m_oFloodColor
    PropBag.WriteProperty sForeColor, m_oForeColor
    PropBag.WriteProperty sFont, m_oFont
    PropBag.WriteProperty sHelpContextID, m_lHelpContextID
    PropBag.WriteProperty sMax, m_lMax
    PropBag.WriteProperty sMin, m_lMin
    PropBag.WriteProperty sMouseIcon, UserControl.MouseIcon, Nothing
    PropBag.WriteProperty sMousePointer, UserControl.MousePointer, vbDefault
    PropBag.WriteProperty sOLEDropMode, m_lOLEDropMode
    PropBag.WriteProperty sOrientation, m_eOrientation
    PropBag.WriteProperty sStyle, m_eStyle
    PropBag.WriteProperty sWhatsThisHelpID, m_lWhatsThisHelpID
End Sub

Private Sub Draw(Optional ClearScreen As Variant)
    'Draw the control
    Dim lProgressLeft As Double, lProgressTop As Double, lProgressRight As Double, lProgressBottom As Long, lProgressWidth As Double, lProgressHeight As Long
    Dim dBlockWidth As Double, dBlockHeight As Double, dBlockStep As Double
    Dim dI As Double, dTemp As Double, bRunTime As Boolean
    Dim bVolumeSmall As Boolean, dValuePosition As Double
    Dim lRect As RECT
    
    AutoRedraw = True
    
    'Draw bevel and border
    Select Case m_eBorderStyle
        Case gtNone
            lProgressLeft = 0
            lProgressTop = 0
            lProgressWidth = ScaleWidth
            lProgressHeight = ScaleHeight
            'set clearing rect
            lRect.Left = 0
            lRect.Top = 0
            lRect.Right = ScaleWidth
            lRect.Bottom = ScaleHeight
        Case gtFixedSingle
            lProgressLeft = 2
            lProgressTop = 2
            lProgressWidth = ScaleWidth - 5
            lProgressHeight = ScaleHeight - 5
            'set clearing rect
            lRect.Left = 1
            lRect.Top = 1
            lRect.Right = ScaleWidth - 1
            lRect.Bottom = ScaleHeight - 1
            Select Case m_eAppearance
                Case gt3D
                    Draw3DPanel 0, 0, ScaleWidth, ScaleHeight, 1
                Case gtFlat
                    Line (0, 0)-(ScaleWidth - 1, ScaleHeight _
                            - 1), vb3DDKShadow, B
            End Select
    End Select
    
    If Not IsMissing(ClearScreen) Then
        If ClearScreen Then
            'clear the control to avoid overwrite
            ExtTextOut UserControl.hdc, 0, 0, ETO_OPAQUE, lRect, "", 0, 0
        End If
    End If

    'Draw Progress
    If m_lMin = m_lMax Then
        Exit Sub
    End If
    lProgressBottom = lProgressTop + lProgressHeight
    lProgressRight = lProgressLeft + lProgressWidth
    
    'Is the program in Runmode?
    bRunTime = UserControl.Ambient.UserMode
    If m_eOrientation = gtHorizontal Then
        Select Case m_eStyle
            Case gtSegmented
                If bRunTime Then
                    'Be sure value is valid
                    If m_lValue > m_lMin Then
                        dValuePosition = Int(lProgressWidth * _
                                (m_lValue / (m_lMax - m_lMin))) + lProgressLeft
                    Else
                        'In order to not need to put the drawing
                        'algorythm in twice, I fool the program
                        'into not drawing it in this instance by
                        'forcing BlockWidth to be 0.
                        lProgressHeight = 0
                    End If
                Else
                    'the design-time value is 50%
                    dValuePosition = (lProgressRight + lProgressLeft) * 0.5
                End If
                'Compute width of all blocks.
                dBlockWidth = Int(0.66 * lProgressHeight + 0.5)
                If dBlockWidth > 0 Then
                    'If block is too small, don't draw it.
                    dBlockStep = dBlockWidth + 3
                    'Draw all boxes except for the last,
                    'in case it goes off the edge.
                    For dI = lProgressLeft To dValuePosition _
                            - dBlockWidth Step dBlockStep
                        Line (dI, lProgressTop)-(dI + dBlockWidth, _
                                lProgressBottom), m_oFloodColor, BF
                    Next dI
                    If dI < dValuePosition Then
                        If dI + dBlockWidth > lProgressRight Then
                            'If the last block goes off the edge, draw it to the edge
                            Line (dI, lProgressTop)-(lProgressRight, _
                                    lProgressBottom), m_oFloodColor, BF
                        Else
                            'otherwise draw it normally
                            Line (dI, lProgressTop)-(dI + dBlockWidth, _
                                    lProgressBottom), m_oFloodColor, BF
                        End If
                    End If
                End If
            Case gtFlood
                If bRunTime Then
                    'Don't draw when value = min
                    If m_lValue > m_lMin Then
                        dValuePosition = lProgressWidth * m_lValue / _
                                (m_lMax - m_lMin) + lProgressLeft
                        Line (lProgressLeft, lProgressTop)- _
                                (dValuePosition, lProgressBottom), _
                                m_oFloodColor, BF
                    End If
                Else
                    'The design-time value is 50%
                    Line (lProgressLeft, lProgressTop)-((lProgressRight _
                            + lProgressLeft) * 0.5, lProgressBottom), _
                            m_oFloodColor, BF
                End If
            Case gtVolume
                If bRunTime Then
                    dValuePosition = lProgressWidth * m_lValue / _
                            (m_lMax - m_lMin) + lProgressLeft
                Else
                    'the design-time value is 50%
                    dValuePosition = lProgressWidth * 0.5
                End If
                
                'This variable determine if the volumebar is big or small,
                'initially set to big.
                bVolumeSmall = False
                dBlockWidth = Int(0.2178 * lProgressHeight + 0.5)
                If dBlockWidth > 0 Then
                    dBlockStep = dBlockWidth * 2
                    For dI = lProgressLeft To lProgressRight - _
                            dBlockWidth Step dBlockStep
                        'make the volume bar small after passing the ValuePosition
                        If dI >= dValuePosition And Not bVolumeSmall Then
                            dTemp = 0.33 * lProgressHeight + lProgressTop
                            lProgressBottom = 0.66 * lProgressHeight + _
                                    lProgressTop
                            lProgressTop = dTemp
                            bVolumeSmall = True
                        End If
                        Line (dI, lProgressTop)-(dI + dBlockWidth, _
                                lProgressBottom), m_oFloodColor, BF
                    Next dI
                    If dI < lProgressRight Then
                        'make the volume bar small after passing the ValuePosition
                        If dI >= dValuePosition And Not bVolumeSmall Then
                            dTemp = 0.33 * lProgressHeight + lProgressTop
                            lProgressBottom = 0.66 * lProgressHeight + lProgressTop
                            lProgressTop = dTemp
                            bVolumeSmall = True
                        End If
                        Line (dI, lProgressTop)-(lProgressRight, _
                                lProgressBottom), m_oFloodColor, BF
                    End If
                End If
        End Select
    
        If Not bRunTime Then
            UserControl.CurrentX = lProgressLeft + (lProgressWidth - _
                    UserControl.TextWidth("50%")) * 0.5
            UserControl.CurrentY = lProgressTop + (lProgressBottom - _
                    lProgressTop - UserControl.TextHeight("100%")) * 0.5
            UserControl.Print m_sCaption
        ElseIf m_sCaption <> "" Then
            UserControl.CurrentX = lProgressLeft + (lProgressWidth - _
                    UserControl.TextWidth(m_sCaption)) * 0.5
            UserControl.CurrentY = lProgressTop + (lProgressBottom - _
                    lProgressTop - UserControl.TextHeight("100%")) * 0.5
            UserControl.Print m_sCaption
        End If
    Else
        Select Case m_eStyle
            Case gtSegmented
                If bRunTime Then
                    'Be sure value is valid
                    If m_lValue > m_lMin Then
                        dValuePosition = lProgressBottom - lProgressHeight * _
                                m_lValue / (m_lMax - m_lMin)
                    Else
                        'In order to not need to put the drawing
                        'algorythm in twice, I fool the program
                        'into not drawing it in this instance by
                        'forcing BlockWidth to be 0.
                        lProgressWidth = 0
                    End If
                Else
                    'the design-time value is 50%
                    dValuePosition = (lProgressTop + lProgressBottom) * 0.5
                End If
                dBlockHeight = Int(0.66 * lProgressWidth + 0.5)
                If dBlockHeight > 0 Then
                    dBlockStep = -(dBlockHeight + 3)
                    For dI = lProgressBottom To dValuePosition + _
                            dBlockHeight Step dBlockStep
                        Line (lProgressLeft, dI)-(lProgressRight, _
                                dI - dBlockHeight), m_oFloodColor, BF
                    Next dI
                    If dI > dValuePosition Then
                        If dI - dBlockHeight < lProgressTop Then
                            Line (lProgressLeft, dI)-(lProgressRight, _
                                    lProgressTop), m_oFloodColor, BF
                        Else
                            Line (lProgressLeft, dI)-(lProgressRight, _
                                    dI - dBlockHeight), m_oFloodColor, BF
                        End If
                    End If
                End If
            Case gtFlood
                If bRunTime Then
                    If m_lValue > m_lMin Then
                        dValuePosition = lProgressBottom - lProgressHeight * _
                                m_lValue / (m_lMax - m_lMin)
                        Line (lProgressLeft, dValuePosition)-(lProgressRight, _
                                lProgressBottom), m_oFloodColor, BF
                    End If
                Else
                    'the design-time value is 50%
                    Line (lProgressLeft, (lProgressTop + lProgressBottom) * _
                            0.5)-(lProgressRight, lProgressBottom), m_oFloodColor, BF
                End If
            Case gtVolume
                'This variable determine if the volumebar is big or small,
                'initially set to big.
                bVolumeSmall = False
                dBlockHeight = Int(0.2178 * lProgressWidth + 0.5)
                dBlockHeight = Int(0.2178 * lProgressWidth + 0.5)
                If dBlockHeight > 0 Then
                    dBlockStep = -dBlockHeight * 2
                    If bRunTime Then
                        dValuePosition = lProgressBottom - lProgressHeight * _
                                m_lValue / (m_lMax - m_lMin)
                    Else
                        'the design-time value is 50%
                        dValuePosition = (lProgressBottom + lProgressTop) * 0.5
                    End If
                    For dI = lProgressBottom To lProgressTop + dBlockHeight _
                            Step dBlockStep
                        'make the volume bar small after passing the ValuePosition
                        If dI <= dValuePosition And Not bVolumeSmall Then
                            dTemp = 0.33 * lProgressWidth + lProgressLeft
                            lProgressRight = 0.66 * lProgressWidth + lProgressLeft
                            lProgressLeft = dTemp
                            bVolumeSmall = True
                        End If
                        Line (lProgressLeft, dI)-(lProgressRight, dI - _
                                dBlockHeight), m_oFloodColor, BF
                    Next dI
                    If dI + dBlockWidth > lProgressRight Then
                        'make the volume bar small after passing the ValuePosition
                        If dI <= dValuePosition And Not bVolumeSmall Then
                            dTemp = 0.33 * lProgressWidth + lProgressLeft
                            lProgressRight = 0.66 * lProgressWidth + lProgressLeft
                            lProgressLeft = dTemp
                            bVolumeSmall = True
                        End If
                        Line (lProgressLeft, dI)-(lProgressRight, lProgressTop), _
                                m_oFloodColor, BF
                    End If
                End If
        End Select
        If Not bRunTime Then
            'In vertical Progresses, the caption is written vertically, therefore
            'we need the draw each caracter individually. If we tried to do this
            'automatically with something similar to a label's wordwrap we may
            'run into trouble with some fonts since "11" or "II" may be as narrow
            'as characters like "M" or "W".
            For dI = 1 To 3
                UserControl.CurrentX = lProgressLeft + (lProgressRight - _
                        lProgressLeft - UserControl.TextWidth(Mid$("50%", _
                        dI, 1))) * 0.5
                UserControl.CurrentY = lProgressTop + (lProgressHeight - _
                        UserControl.TextHeight("%") * 4) * 0.5 + _
                        UserControl.TextHeight("%") * (dI - 1)
                UserControl.Print Mid$("50%", dI, 1)
            Next dI
        ElseIf m_sCaption <> "" Then
            For dI = 1 To Len(m_sCaption)
                UserControl.CurrentX = lProgressLeft + (lProgressRight - _
                        lProgressLeft - UserControl.TextWidth(Mid$(m_sCaption, _
                        dI, 1))) * 0.5
                UserControl.CurrentY = lProgressTop + (lProgressHeight - _
                        UserControl.TextHeight("%") * Len(m_sCaption)) * _
                        0.5 + UserControl.TextHeight("%") * (dI - 1)
                UserControl.Print Mid$(m_sCaption, dI, 1)
            Next dI
        End If
    End If

    AutoRedraw = False
End Sub

Private Sub Draw3DPanel(ByVal X1 As Single, ByVal Y1 As Single, _
        ByVal X2 As Single, ByVal Y2 As Single, ByVal BevelWidth As _
        Byte, Optional Raised As Boolean = False)
    'Draws a 3D raised/lowered panel
    Dim i As Byte
    Dim TopLeftColor As OLE_COLOR, BottomRightColor As OLE_COLOR
    
    'Set line colors for raised/lowered states.
    If Raised Then
        TopLeftColor = vb3DHighlight
        BottomRightColor = vb3DShadow
    Else
        TopLeftColor = vb3DShadow
        BottomRightColor = vb3DHighlight
    End If
        
    For i = 1 To BevelWidth
        'Top Line
        Line (X1, Y1)-(X2, Y1), TopLeftColor
        
        'Left Line
        Line (X1, Y1)-(X1, Y2), TopLeftColor
        
        'Right Line
        Line (X2 - 1, Y1)-(X2 - 1, Y2), BottomRightColor
        
        'Bottom Line
        Line (X1, Y2 - 1)-(X2, Y2 - 1), BottomRightColor
        
        'position corners for next bevel width run
        X1 = X1 + 1
        Y1 = Y1 + 1
        X2 = X2 - 1
        Y2 = Y2 - 1
    Next i
End Sub


Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_HelpID = 8
Attribute ShowAboutBox.VB_UserMemId = -552
Attribute ShowAboutBox.VB_MemberFlags = "40"
    
End Sub


