VERSION 5.00
Begin VB.UserControl GTSplitter 
   CanGetFocus     =   0   'False
   ClientHeight    =   1545
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1620
   ControlContainer=   -1  'True
   PropertyPages   =   "GTSplitter.ctx":0000
   ScaleHeight     =   103
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   108
   ToolboxBitmap   =   "GTSplitter.ctx":003A
   Begin GreenTreeSplitter.GTMsgHook GTMsgHook1 
      Left            =   660
      Top             =   690
      _ExtentX        =   635
      _ExtentY        =   635
   End
End
Attribute VB_Name = "GTSplitter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit
'   ***** API constants
Private Const MK_LBUTTON = &H1
Private Const MK_MBUTTON = &H10
Private Const MK_RBUTTON = &H2
Private Const MK_CONTROL = &H8
Private Const MK_SHIFT = &H4
Private Const VK_RMENU = &HA5
Private Const VK_LMENU = &HA4
Private Const WM_SYSCOLORCHANGE = &H15
Private Const WM_ACTIVATE = &H6
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
'   *****
'   ***** Appearance constants
Public Enum GTAppearanceConstants
    gtFlat
    gt3D
End Enum
'   *****
'   ***** BorderStyle constants
Public Enum GTBorderStyleConstants
    gtNone
    gtFixedSingle
End Enum
'   *****
'   ***** splitterstyle constants
Public Enum GTSplitterStyleConstants
    gtSplitterFlat
    gtSplitterRound
End Enum
'   *****
'   ***** Orientation constants
Public Enum GTOrientationConstants
    gtHorizontal
    gtVertical
End Enum
'   *****
'   ***** OLEDrop constants
Public Enum GTOLEDropConstants
    gtOLEDropNone
    gtOLEDropManual
End Enum
'   *****

'   ***** capture constants
Private Const gtCapture = 0
Private Const gtMouseDown = 1
Private Const gtRelease = 2
'   *****

'   ***** Default Property Values:
Const m_def_SplitterSize = 3
Const m_def_WhatsThisHelpID = 0

'   ***** variables
Private WithEvents m_oPanes As GTPanes
Attribute m_oPanes.VB_VarHelpID = -1
Private m_iOffset As Integer
Private m_oActivePane As GTPane
Private m_iScalePerPixel As Integer
Private m_CDrawRect As CDrawRect
Private m_bRedraw As Boolean
Private m_bShowingSplitterIcon As Boolean
Private m_CPaint As CPaint
Private m_bDontPaint As Boolean ' used when refreshing graphical controls
'   *****

'   ***** Property Variables:
Private m_eAppearance As GTAppearanceConstants
Private m_eBorderStyle As GTBorderStyleConstants
Private m_oSplitterMouseIcon As Picture
Private m_eSplitterStyle As GTSplitterStyleConstants
Private m_lSplitterSize As Long
Private m_eOrientation As GTOrientationConstants
Private m_lWhatsThisHelpID As Long
Private m_eMousePointer As MousePointerConstants
Private m_oMouseIcon As Picture
Private m_bResizeChildControl As Boolean
'   *****

'   *****Event Declarations:
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_HelpID = 129
Attribute Click.VB_UserMemId = -600
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when you press and release a mouse button and then press and release it again over an object."
Attribute DblClick.VB_HelpID = 106
Attribute DblClick.VB_UserMemId = -601
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Attribute MouseDown.VB_HelpID = 124
Attribute MouseDown.VB_UserMemId = -605
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Attribute MouseMove.VB_HelpID = 121
Attribute MouseMove.VB_UserMemId = -606
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Attribute MouseUp.VB_HelpID = 124
Attribute MouseUp.VB_UserMemId = -607
Event OLECompleteDrag(Effect As Long)
Attribute OLECompleteDrag.VB_Description = "OLECompleteDrag event"
Attribute OLECompleteDrag.VB_HelpID = 120
Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute OLEDragDrop.VB_Description = "OLEDragDrop event"
Attribute OLEDragDrop.VB_HelpID = 119
Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
Attribute OLEDragOver.VB_Description = "OLEDragOver event"
Attribute OLEDragOver.VB_HelpID = 118
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Attribute OLEGiveFeedback.VB_Description = "OLEGiveFeedback event"
Attribute OLEGiveFeedback.VB_HelpID = 116
Event OLESetData(Data As DataObject, DataFormat As Integer)
Attribute OLESetData.VB_Description = "OLESetData event"
Attribute OLESetData.VB_HelpID = 117
Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
Attribute OLEStartDrag.VB_Description = "OLEStartDrag event"
Attribute OLEStartDrag.VB_HelpID = 115
Event SplitterResize(Pane1 As GTPane, Pane2 As GTPane)
Attribute SplitterResize.VB_Description = "Occurs when a splitter has been moved."
Attribute SplitterResize.VB_HelpID = 110
Event Resize()
Attribute Resize.VB_Description = "Occurs when an object is first displayed or the size of an object changes.\n"
Attribute Resize.VB_HelpID = 111
'   *****

'   ***** Returns the hWnd of the usercontrol.
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle to a form or control."
Attribute hWnd.VB_HelpID = 43
    hWnd = UserControl.hWnd
End Property
'   *****

'   ***** Returns a reference to the Panes collection
Public Property Get Panes() As GTPanes
Attribute Panes.VB_Description = "Returns a reference to a collection of GTPane objects."
Attribute Panes.VB_HelpID = 64
    Set Panes = m_oPanes
End Property
'   *****

'   ***** Returns/sets the BackColor property
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_HelpID = 5000
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor = New_BackColor
    Paint
    PropertyChanged "BackColor"
End Property
'   *****

Private Sub GTMsgHook1_Message(ByVal hWnd As Long, ByVal MsgID As Long, ByVal wParam As Long, ByVal lParam As Long)
'   ****************************************************************************
'   * Params:   hWnd: the window handle that is subclassed, MsgID: the message that was intercepted, wParam: the wParam of the
'   *               message, lParam: the lParam of the message
'   * Purpose:  Fires when a Message in the Messages collection for the Window is intercepted
'   ****************************************************************************
    Select Case MsgID
'   ***** Ver 1.0a No longer used
'        Case WM_SYSCOLORCHANGE
'            Paint
'   ****

'   ***** Intercepts the mouse messages. This gets around a problem in VB4 where the
'   ***** usercontrol didn't get mouse messages even when the mouse was down.
        Case WM_MOUSEMOVE, WM_LBUTTONDOWN, WM_LBUTTONUP
            ProcessMouseMessages MsgID, wParam, lParam
'   *****
    End Select
End Sub

Private Sub m_oPanes_PaneAdded(oPane As GTPane)
'   ***********************************************************************
'   * Params:   oPane: the GTPane object that was added
'   * Purpose:  Fired when a GTPane object is added to the Panes collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    If oPane.ResizeChildControl Then
        ResizeContainedControls
    End If
    
    Paint
    If Not Ambient.UserMode Then
        PropertyChanged "Panes"
    End If
End Sub

Private Sub m_oPanes_PaneChanged(oPane As GTPane, sProperty As String)
'   ***********************************************************************
'   * Params:   oPane: the GTPane object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTPane object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   * Modified: 1.0a    Added RefreshGraphicalControls after calling Paint. Fixes
'   *                       graphical controls from disappearing.
'   ***********************************************************************
    Dim lTotalArea As Long
    Dim oOtherPane As GTPane
    
    Select Case sProperty
        Case "Width", "Height":
                    
'   ***** When the pane width/height (depending on the orientation) changes
'   ***** the other pane in the pane set has to be changed also. The SplitterResize
'   ***** event is also fired
            If oPane.Index = m_oPanes.Count Then
                Set oOtherPane = m_oPanes(oPane.Index - 1)
            Else
                Set oOtherPane = m_oPanes(oPane.Index + 1)
            End If
            
            If m_eOrientation = gtHorizontal Then
                lTotalArea = oPane.SaveWidth + oOtherPane.InternalWidth + m_lSplitterSize
                oOtherPane.InternalWidth = lTotalArea - oPane.InternalWidth - m_lSplitterSize
            Else
                lTotalArea = oPane.SaveHeight + oOtherPane.InternalHeight + m_lSplitterSize
                oOtherPane.InternalHeight = lTotalArea - oPane.InternalHeight - m_lSplitterSize
            End If
            
            If oPane.Index = m_oPanes.Count Then
                RaiseEvent SplitterResize(oOtherPane, oPane)
            Else
                RaiseEvent SplitterResize(oPane, oOtherPane)
            End If
    
            If oPane.ResizeChildControl Then
                ResizeContainedControls
            End If
'   *****

            RaiseEvent Resize
            
        Case "ControlName", "ResizeChildControl":
            If oPane.ResizeChildControl Then
                ResizeContainedControls
            End If
        
        Case "Appearance":
'   ***** When appearance changes the child control needs to be resized
            If oPane.ResizeChildControl Then
                ResizeContainedControls
            End If
'   *****
            RaiseEvent Resize
    End Select
    
    Paint
    
'   ***** Ver 1.0a. Refreshes the graphical controls after painting.
    RefreshGraphicalControls
'   *****

    If Not Ambient.UserMode Then
        PropertyChanged "Panes"
    End If
End Sub

Private Sub m_oPanes_PaneRemoved(ByVal oPane As GTPane)
'   ***********************************************************************
'   * Params:   oPane: the GTPane object that was removed
'   * Purpose:  Fired when a GTPane object is removed from the Panes collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   ***********************************************************************
    Paint
    
    ResizeContainedControls
    
    If Not Ambient.UserMode Then
        PropertyChanged "Panes"
    End If
End Sub

Private Sub m_oPanes_SplitterResized(oPane As GTPane, oPaneNext As GTPane)
'   ***********************************************************************
'   * Params:   oPane: the GTPane object that was resized, oPaneNext:
'   *               the GTPane object that was resized
'   * Purpose:  Fired when a splitter has been resized and the pane widths
'   *               have changed
'   ***********************************************************************
    Dim oPane1 As GTPane
    Dim oPane2 As GTPane
    
    Set oPane1 = oPane
    Set oPane2 = oPaneNext
    
    RaiseEvent SplitterResize(oPane1, oPane2)
    
    ResizeContainedControls
    RefreshGraphicalControls
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
'   ****************************************************************************
'   * Params:   PropertyName: the name of the property that was changed.
'   * Purpose:  Fires when one of the Ambient properties was changed.
'   ****************************************************************************
    Select Case PropertyName
        Case "ScaleUnits":
            CalculateScaleUnits
    End Select
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

'   ***** Returns/sets the enabled property
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_HelpID = 18
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property
'   *****

Private Sub UserControl_Initialize()
'   ****************************************************************************
'   * Purpose:  Fires when the control is first instiated. The control has not
'   *               yet been sited on the container. Initalizes certain variables and Messages
'   *               are added to be intercepted.
'   ****************************************************************************
    Dim oWindow As GTWindow
'    Dim oMessage As GTMessage Ver 1.0a No longer used

    Set oWindow = GTMsgHook1.Windows.Add(, , , UserControl.hWnd)

    Set m_CPaint = New CPaint
    Set m_CDrawRect = New CDrawRect
    Set m_oPanes = New GTPanes
    m_oPanes.ParentHwnd = hWnd
    m_bRedraw = True

End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is down. This will determine if
'   *               a splitter is under the mouse and whether to draw the inverted
'   *               rect.
'   ****************************************************************************
    If Button = vbLeftButton Then
        
        CaptureMouse x, y, Button, gtMouseDown
        CaptureMouse x, y, Button, gtCapture
        CheckForSplitter x, y
        m_oPanes.MouseDown m_oActivePane, x, y
    End If
    RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

'   ***** Returns/sets the MouseIcon property
Public Property Get MouseIcon() As StdPicture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
Attribute MouseIcon.VB_HelpID = 58
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = ";Misc"
    Set MouseIcon = m_oMouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As StdPicture)
    If Not New_MouseIcon Is Nothing Then
        If Not (New_MouseIcon.Type = vbPicTypeIcon) Then
            Err.Raise vbObjectError + 1051, App.Title, "MouseIcon only accepts a picture of type icon or cursor.", App.HelpFile
            Exit Property
        End If
    End If
    Set m_oMouseIcon = New_MouseIcon
    
    If m_eMousePointer = vbCustom Then
        Set UserControl.MouseIcon = New_MouseIcon
    End If
    
    PropertyChanged "MouseIcon"
End Property
'   *****

'   ***** Returns/sets the MousePointer constant.
Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
Attribute MousePointer.VB_HelpID = 59
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Misc"
    MousePointer = UserControl.MousePointer
End Property
Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    m_eMousePointer = New_MousePointer
    UserControl.MousePointer = New_MousePointer
    
    If New_MousePointer = vbCustom Then
        Set UserControl.MouseIcon = m_oMouseIcon
    End If
    
    PropertyChanged "MousePointer"
End Property
'   *****

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is moved over the user control.
'   *               If the mouse is over a splitter, the cursor will be changed.
'   *               The mouse is also captured or released, and mousemove
'   *               is called in the Panes collection when the mouse is down.
'   ****************************************************************************
    
    If Button = 0 Then
        CheckForSplitter x, y ' checks if over a splitter (between 2 panes)
        If m_oActivePane Is Nothing Then
'   ***** release the capture when not over a splitter because otherwise the
'   ***** the mouse pointer doesn't change
            CaptureMouse x, y, Button, gtRelease
'   *****
        Else
            CaptureMouse x, y, Button, gtCapture ' set the capture when over a splitter
        End If
    End If
    
    If Button = vbLeftButton Then
        m_oPanes.MouseMove m_oActivePane, x, y ' calls mousemove in the panes collection
    End If
    
    RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is released. This will capture the
'   *               mouse and call MouseUp in the Panes collection (which
'   *               will resize the panes)
'   ****************************************************************************
    CaptureMouse x, y, Button, gtCapture
    
    If Button = vbLeftButton And Not m_oActivePane Is Nothing Then
        
        m_oPanes.MouseUp m_oActivePane ' calls mouseup in the panes collection
        Paint
        RefreshGraphicalControls ' Ver 1.0a Refreshes graphical controls
    End If
    
    RaiseEvent MouseUp(Button, Shift, x, y)

End Sub

'   ***** OLE Drag/Drop events
Private Sub UserControl_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub
Public Sub OLEDrag()
Attribute OLEDrag.VB_Description = "Starts an OLE drag/drop event with the given control as the source."
Attribute OLEDrag.VB_HelpID = 135
    UserControl.OLEDrag
End Sub
Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, x, y)
End Sub
Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, x, y, State)
End Sub
Private Sub UserControl_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub
Private Sub UserControl_OLESetData(Data As DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub
Private Sub UserControl_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

'   ***** Returns/sets the value of OLEDropMode
Public Property Get OLEDropMode() As GTOLEDropConstants
    OLEDropMode = UserControl.OLEDropMode
End Property
Public Property Let OLEDropMode(ByVal New_OLEDropMode As GTOLEDropConstants)
    UserControl.OLEDropMode() = New_OLEDropMode
    PropertyChanged "OLEDropMode"
End Property
'   *****

'   ***** Returns/sets whether the control will appear 3D or Flat.
Public Property Get Appearance() As GTAppearanceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not controls, Forms, or an MDIForm are painted at runtime with 3D effects."
Attribute Appearance.VB_HelpID = 22
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
    Appearance = m_eAppearance
End Property
Public Property Let Appearance(ByVal New_Appearance As GTAppearanceConstants)
    m_eAppearance = New_Appearance
    PropertyChanged "Appearance"
    
    m_oPanes.Appearance = New_Appearance ' pass on the appearance
    
    CalcOffset ' recalc the offset
    
    m_oPanes.ResizeLastPane True ' resize the last pane to fill the control
    
    Paint
    
    ResizeContainedControls
End Property
'   *****

'   ***** Returns/sets whether the control will have a border or not
Public Property Get BorderStyle() As GTBorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/Sets the border style for an object."
Attribute BorderStyle.VB_HelpID = 2
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_eBorderStyle
End Property
Public Property Let BorderStyle(ByVal New_BorderStyle As GTBorderStyleConstants)
    m_eBorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
    
    m_oPanes.BorderStyle = New_BorderStyle ' pass on the bordstyle
     
    CalcOffset ' recalc the offset
    
    m_oPanes.ResizeLastPane True ' resize the last pane to fill the control
    
    Paint
    
    ResizeContainedControls
End Property
'   *****

'   ***** Returns/sets the SplitterMouseIcon property. This cursor is used when the
'   ***** mouse is over the splitter.
Public Property Get SplitterMouseIcon() As StdPicture
Attribute SplitterMouseIcon.VB_Description = "Sets a custom mouse icon for when the  mouse moves over a splitter."
Attribute SplitterMouseIcon.VB_HelpID = 80
Attribute SplitterMouseIcon.VB_ProcData.VB_Invoke_Property = ";Misc"
    Set SplitterMouseIcon = m_oSplitterMouseIcon
End Property
Public Property Set SplitterMouseIcon(ByVal New_SplitterMouseIcon As StdPicture)
    If Not New_SplitterMouseIcon Is Nothing Then
        If Not (New_SplitterMouseIcon.Type = vbPicTypeIcon) Then
            Err.Raise vbObjectError + 1051, App.Title, "SplitterMouseIcon only accepts a picture of type iconor cursor.", App.HelpFile
            Exit Property
        End If
    End If
    
    Set m_oSplitterMouseIcon = New_SplitterMouseIcon
    PropertyChanged "SplitterMouseIcon"
End Property
'   *****

'   ***** Returns/sets the SplitterStyle constant
Public Property Get SplitterStyle() As GTSplitterStyleConstants
Attribute SplitterStyle.VB_Description = "How the splitters are displayed."
Attribute SplitterStyle.VB_HelpID = 82
Attribute SplitterStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
    SplitterStyle = m_eSplitterStyle
End Property
Public Property Let SplitterStyle(ByVal New_SplitterStyle As GTSplitterStyleConstants)
    m_eSplitterStyle = New_SplitterStyle
    PropertyChanged "SplitterStyle"
    Paint
End Property
'   *****

'   ***** Returns/sets the SplitterSize property. This is always in Pixels.
Public Property Get SplitterSize() As Long
Attribute SplitterSize.VB_Description = "The width/height of the splitter depending on the orientation."
Attribute SplitterSize.VB_HelpID = 81
Attribute SplitterSize.VB_ProcData.VB_Invoke_Property = ";Appearance"
    SplitterSize = m_lSplitterSize
End Property
Public Property Let SplitterSize(ByVal New_SplitterSize As Long)
    If New_SplitterSize > 32767 Or New_SplitterSize < 1 Then
        Err.Raise vbObjectError + 1052, App.Title, "SplitterSize must be between 1 and 32767.", App.HelpFile
        Exit Property
    End If
    
    m_lSplitterSize = New_SplitterSize
    m_oPanes.SplitterSize = New_SplitterSize ' pass on the splitter size
    
    PropertyChanged "SplitterSize"
    
    m_oPanes.ResizeLastPane True ' resize the last pane to fill the control
    
    Paint
    
    ResizeContainedControls
End Property
'   *****

'   ***** Returns/sets the Orientation constant
Public Property Get Orientation() As GTOrientationConstants
Attribute Orientation.VB_Description = "Returns/sets whether the control is displayed horizontal or vertical."
Attribute Orientation.VB_HelpID = 63
Attribute Orientation.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Orientation = m_eOrientation
End Property
Public Property Let Orientation(ByVal New_Orientation As GTOrientationConstants)
    m_eOrientation = New_Orientation
    
    m_oPanes.Orientation = New_Orientation ' pass on the orientation
    PropertyChanged "Orientation"
    
    ' Need to reset the properties in the panes class
    m_oPanes.Move Extender.Left, Extender.Top, ScaleWidth - m_iOffset * 2, ScaleHeight - m_iOffset * 2
    
    m_oPanes.ResizeLastPane True ' resize the last pane to fill the control
    
    Paint
End Property
'   *****

'   ***** Returns/sets the WhatsThisHelpID property. Used with the WhatsThisMode methode
Public Property Get WhatsThisHelpID() As Variant
Attribute WhatsThisHelpID.VB_Description = "Returns/sets an associated context number for an object."
Attribute WhatsThisHelpID.VB_HelpID = 97
Attribute WhatsThisHelpID.VB_ProcData.VB_Invoke_Property = "General;Misc"
    WhatsThisHelpID = m_lWhatsThisHelpID
End Property
Public Property Let WhatsThisHelpID(ByVal New_WhatsThisHelpID As Variant)
    m_lWhatsThisHelpID = New_WhatsThisHelpID
    PropertyChanged "WhatsThisHelpID"
End Property
'   *****

Private Sub UserControl_InitProperties()
'   *************************************************************************
'   * Purpose:  Intializes the property variables . This is fired when a
'   *               control is first instanciated.
'   *************************************************************************
    m_bRedraw = False

'   ***** Calculates the scaleunits per pixel
    CalculateScaleUnits
'   *****

    m_eAppearance = gt3D
    m_eBorderStyle = gtNone
    Set m_oSplitterMouseIcon = Nothing
    m_eSplitterStyle = gtSplitterFlat
    m_lSplitterSize = m_def_SplitterSize
    m_eOrientation = gtHorizontal
    m_lWhatsThisHelpID = m_def_WhatsThisHelpID

'   ***** Calculates the offset based on the appearance and borderstyle props
    CalcOffset
'   *****

    On Error Resume Next ' don't want an error when if extender has no left or top

'   ***** passed for the splitter class
    m_oPanes.Move Extender.Left, Extender.Top, ScaleWidth - m_iOffset * 2, ScaleHeight - m_iOffset * 2
'   *****

    On Error GoTo 0 ' reset the error

    m_oPanes.Orientation = m_eOrientation
    m_oPanes.SplitterSize = m_lSplitterSize
    m_oPanes.Appearance = m_eAppearance
    m_oPanes.BorderStyle = m_eBorderStyle

    m_oPanes.CreateFirstPane ' creates the first pane


'   ***** Ver 1.0a Only turn on subclassing in mousedown
''   ***** Turns subclassing on. Turn off when debugging.
'#If DEBUG_SWITCH = 2 Then
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = 1 Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
''   *****
'   *****

    m_bRedraw = True
    Paint

End Sub

Private Sub UserControl_Paint()
'   **************************************************************
'   * Purpose:  Fired when the control needs to be repainted.
'   *               Calls the internal Paint proc.
'   **************************************************************
    Paint
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'   *************************************************************************
'   * Purpose:  Retrieves the properties from the property bag for those
'   *               properties that can be set at designtime or thru the proppages.
'   *               The control is sited on the container that is point.
'   *************************************************************************
    m_bRedraw = False

'   ***** Calculates the scaleunits per pixel
    CalculateScaleUnits
'   *****

    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    m_eMousePointer = PropBag.ReadProperty("MousePointer", vbDefault)
    UserControl.MousePointer = m_eMousePointer

    UserControl.OLEDropMode = PropBag.ReadProperty("OLEDropMode", 0)
    m_eAppearance = PropBag.ReadProperty("Appearance", gt3D)
    m_eBorderStyle = PropBag.ReadProperty("BorderStyle", gtFixedSingle)
    Set m_oSplitterMouseIcon = PropBag.ReadProperty("SplitterMouseIcon", Nothing)
    m_eSplitterStyle = PropBag.ReadProperty("SplitterStyle", gtSplitterFlat)
    m_lSplitterSize = PropBag.ReadProperty("SplitterSize", m_def_SplitterSize)
    m_eOrientation = PropBag.ReadProperty("Orientation", gtHorizontal)
    m_lWhatsThisHelpID = PropBag.ReadProperty("WhatsThisHelpID", m_def_WhatsThisHelpID)

'   ***** Calculates the offset based on the appearance and borderstyle props
    CalcOffset
'   *****

'   ***** passed for the splitter class
    m_oPanes.Move Extender.Left, Extender.Top, ScaleWidth - m_iOffset * 2, ScaleHeight - m_iOffset * 2
'   *****

    m_oPanes.Orientation = m_eOrientation
    m_oPanes.SplitterSize = m_lSplitterSize
    m_oPanes.Appearance = m_eAppearance
    m_oPanes.BorderStyle = m_eBorderStyle

'   ***** Reads properties for the collection
    ReadObjectProps PropBag
'   *****

'   ***** Have to intercept the mouse messages. The default proc doesn't get fired.
'   ***** This gets around a problem in VB4 where mouse messages weren't returned
'   ***** over contained controls (graphical, 3rd Party ActiveX controls).
    If Ambient.UserMode Then
'   ***** Ver 1.0a Make sure that there is a Windows(1)
        If GTMsgHook1.Windows.Count > 0 Then
            GTMsgHook1.Windows(1).Messages.Add , , WM_MOUSEMOVE, , False
            GTMsgHook1.Windows(1).Messages.Add , , WM_LBUTTONDOWN, , False
            GTMsgHook1.Windows(1).Messages.Add , , WM_LBUTTONUP, , False
        End If
'   *****
    End If
'   *****

'   ***** Ver 1.0a Only turn on subclassing in mousedown
''   ***** Turns subclassing on. Turn off when debugging
'#If DEBUG_SWITCH = 2 Then
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = 1 Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
''   *****
'   *****

    m_bRedraw = True

    Paint
    
End Sub

Private Sub UserControl_Resize()
'   **************************************************************************
'   * Purpose:  Fired when the control is resized. Contained controls
'   *               are resized from here also.
'   **************************************************************************
    On Error Resume Next ' ver 1.0a Don't show error when container doesn't support extender prop
    
    m_oPanes.Move Extender.Left, Extender.Top, ScaleWidth - m_iOffset * 2, ScaleHeight - m_iOffset * 2
    
    Paint
    RaiseEvent Resize

    ResizeContainedControls
    
End Sub

Private Sub UserControl_Show()
'   **************************************************************************
'   * Purpose:  Fired when the control is shown. This is the first event
'   *               where the ContainedControls collection is available.
'   **************************************************************************
    RaiseEvent Resize
    ResizeContainedControls
End Sub

Private Sub UserControl_Terminate()
'   **************************************************************************
'   * Purpose:  Fired when the control is destroyed gracefully. Doesn't
'   *               occur when the user hits Stop or end. Releases all objects.
'   *               and cleans up.
'   **************************************************************************
'   ***** Ver 1.0a No longer needed
'    GTMsgHook1.Subclass = False
'   *****
    Set m_oPanes = Nothing
    Set m_CDrawRect = Nothing
    Set m_CPaint = Nothing
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
'   **************************************************************************
'   * Purpose:  Fired at designtime when properties have been changed.
'   *               Saves the properties in the property bag.
'   **************************************************************************
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", m_eMousePointer, vbDefault)
    Call PropBag.WriteProperty("OLEDropMode", UserControl.OLEDropMode, 0)
    Call PropBag.WriteProperty("Appearance", m_eAppearance, gt3D)
    Call PropBag.WriteProperty("BorderStyle", m_eBorderStyle, gtFixedSingle)
    Call PropBag.WriteProperty("SplitterMouseIcon", m_oSplitterMouseIcon, Nothing)
    Call PropBag.WriteProperty("SplitterStyle", m_eSplitterStyle, gtSplitterFlat)
    Call PropBag.WriteProperty("SplitterSize", m_lSplitterSize, m_def_SplitterSize)
    Call PropBag.WriteProperty("Orientation", m_eOrientation, gtHorizontal)
    Call PropBag.WriteProperty("WhatsThisHelpID", m_lWhatsThisHelpID, m_def_WhatsThisHelpID)

'   ***** Saves the properties for the collection
    WriteObjectProps PropBag
'   *****

End Sub

Private Sub Paint()
'   *********************************************************************************
'   * Purpose:  Creates the memory dc to draw the panes on. Also draws
'   *               the border.
'   *********************************************************************************
    Dim hDCMem As Long
    
'   ***** 1.0a Fixes splitter inside a splitter not redrawing correctly with graphical controls
    If Not m_bRedraw Then
'    If Not m_bRedraw Or m_bDontPaint Then
'   *****
        Exit Sub
    End If
    
    hDCMem = m_CPaint.GetMemDC(UserControl.hdc, ScaleWidth, ScaleHeight)
    m_CPaint.DrawBackground hDCMem, 0, 0, ScaleWidth, ScaleHeight, UserControl.BackColor
    
    DrawPanes hDCMem
    
    DrawBorder hDCMem
    
    m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight
End Sub

Private Sub DrawBorder(hdc As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on.
'   * Purpose:  Draws the border based on the Appearance and BorderStyle
'   *               properties.
'   *********************************************************************************
    If m_eAppearance = gt3D And m_eBorderStyle = gtFixedSingle Then
        m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, Inset
    ElseIf m_eBorderStyle = gtFixedSingle Then
        m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, FixedSingle
    Else
        Exit Sub
    End If
    
End Sub


Private Sub DrawPanes(hdc As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on.
'   * Purpose:  Draws the Panes. Draws Pane.Name at design time. Draws
'   *               the splitter rounded based on the property value.
'   *********************************************************************************
    Dim lLeft As Long
    Dim lTop As Long
    Dim i As Long
    Dim lHeight As Long
    Dim lWidth As Long
    Dim oPane As GTPane
    Dim oFont As StdFont
    
    lLeft = m_iOffset
    lTop = m_iOffset
    
'   ***** Sets the width/height based on the orientation
    If m_eOrientation = gtHorizontal Then
        lHeight = ScaleHeight - lTop * 2
    Else
        lWidth = ScaleWidth - lLeft * 2
    End If
'   *****

'   ***** Loops thru each pane and draws the rect. The splitter is only drawn when
'   ***** it is rounded, otherwise it is just the space between the panes
    For Each oPane In m_oPanes
            
        If m_eOrientation = gtHorizontal Then
            If oPane Is m_oPanes(m_oPanes.Count) Then
                lWidth = ScaleWidth - lLeft - m_iOffset
            Else
                lWidth = oPane.InternalWidth
            End If
        Else
            If oPane Is m_oPanes(m_oPanes.Count) Then
                lHeight = ScaleHeight - lTop - m_iOffset
            Else
                lHeight = oPane.InternalHeight
            End If
        End If
            
        If oPane.Appearance = gtPane3D Then
            m_CDrawRect.Draw3DRect hdc, lLeft, lTop, lWidth, lHeight, Inset
        End If
            
'   ***** At design time, the Name of the pane is drawn for clarity
        If Not Ambient.UserMode Then
            Set oFont = UserControl.Font
            m_CPaint.PaintText oPane.Name, oFont.Name, lLeft + 1, lTop + 1, lLeft + lWidth - 2, lTop + lHeight - 2, TextHeight("O"), _
                            DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, , oFont.Bold, oFont.Italic, oFont.Strikethrough, _
                            oFont.Underline, GetBkColor(UserControl.hdc), GetSysColor(COLOR_BTNTEXT)
        End If
'   *****

'   ***** Draws the illusion of a round splitter
        If m_eSplitterStyle = gtSplitterRound And Not (oPane.Index = m_oPanes.Count) Then
            m_CDrawRect.DrawRoundSplitter hdc, m_eOrientation, m_lSplitterSize, m_iOffset, lLeft, lTop, lWidth, lHeight
        End If
'   *****

        If m_eOrientation = gtHorizontal Then
            lLeft = lLeft + lWidth + m_lSplitterSize
        Else
            lTop = lTop + lHeight + m_lSplitterSize
        End If
        
    Next
'   *****

End Sub

Private Sub CalcOffset()
'   *********************************************************************************
'   * Purpose:  Calculates how far left and from the top to start the drawing
'   *               of the objects. This is calculated by the value of the Appearance
'   *               and BorderStyle properties.
'   *********************************************************************************
    If m_eAppearance = gt3D And m_eBorderStyle = gtFixedSingle Then
        m_iOffset = 2
    ElseIf m_eBorderStyle = gtFixedSingle Then
        m_iOffset = 1
    Else
        m_iOffset = 0
    End If
    
    m_oPanes.Offset = m_iOffset
    m_oPanes.ScaleWidth = ScaleWidth - m_iOffset * 2
    m_oPanes.ScaleHeight = ScaleHeight - m_iOffset * 2
    
End Sub

Private Sub CheckForSplitter(x As Single, y As Single)
'   *********************************************************************************
'   * Params:   X: the x point, Y: the y point.
'   * Purpose:  Checks to see if the mouse is over a splitter (the space between
'   *               two panes. If so the icon is changed to a splitter icon (or custom)
'   *********************************************************************************
    Dim oPane As GTPane
    
    Set oPane = m_oPanes.HitTest(x, y)
    If oPane Is Nothing Then
        Set UserControl.MouseIcon = m_oMouseIcon
        UserControl.MousePointer = m_eMousePointer
        m_bShowingSplitterIcon = False ' reset the splitter icon showing flag
    Else
'   ***** If the splitter icon isn't showing, set the mousepointer property
'   ***** of the usercontrol to custom and load the splitter icon
        If Not m_bShowingSplitterIcon Then
            
            UserControl.MousePointer = vbCustom
                
            If Not m_oSplitterMouseIcon Is Nothing Then
'   ***** Uses the user defined splitter icon
                Set UserControl.MouseIcon = m_oSplitterMouseIcon
'   *****
            Else
'   ***** Loads the cursor from the res file depending on the orientation
                If m_eOrientation = gtHorizontal Then
                    Set UserControl.MouseIcon = LoadResPicture(IDC_SPLITTERV, vbResCursor)
                Else
                    Set UserControl.MouseIcon = LoadResPicture(IDC_SPLITTERH, vbResCursor)
                End If
            End If
'   *****
            m_bShowingSplitterIcon = True
            
        End If
'   *****
    End If

    Set m_oActivePane = oPane
    
End Sub

Private Sub CalculateScaleUnits()
'   *********************************************************************************
'   * Purpose:  Calculates the number of scale units per pixel because all
'   *               drawing is based on pixels. This allows the values to be returned
'   *               in the Scale that user is expecting. This is based on the ScaleMode
'   *               of the container.
'   *********************************************************************************
    Dim iScalePerPixel As Integer
    
    Select Case Ambient.ScaleUnits
        Case "Twip":
            iScalePerPixel = ScaleX(1, vbPixels, vbTwips)
        Case "Pixel":
            iScalePerPixel = 1
        Case "Inch":
            iScalePerPixel = ScaleX(1, vbPixels, vbInches)
        Case "User":
            iScalePerPixel = 1
'            iScalePerPixel = ScaleX(1, vbPixels, vbUser)
        Case "Point":
            iScalePerPixel = ScaleX(1, vbPixels, vbPoints)
        Case "Millimeter":
            iScalePerPixel = ScaleX(1, vbPixels, vbMillimeters)
        Case "Centimeter":
            iScalePerPixel = ScaleX(1, vbPixels, vbCentimeters)
    End Select
    
    m_oPanes.ScalePerPixel = iScalePerPixel ' passes to the panes collection
    m_iScalePerPixel = iScalePerPixel
    
End Sub

Private Sub ReadObjectProps(oPropBag As PropertyBag)
'   ***********************************************************************
'   * Params:   oPropBag: the property bag to read property values from
'   * Purpose:  Reads the properties from the property bag. Reads only
'   *               the properties for objects that were changed at design time
'   *               thru the property pages.
'   ***********************************************************************
    Dim i As Long
    Dim lCount As Long
    Dim lHeight As Long
    Dim lWidth As Long
    Dim oPane As GTPane
    
    lCount = oPropBag.ReadProperty("NumPanes", 0)
    
    For i = 1 To lCount
        
        If lCount > 1 Then
            m_oPanes.DontResizeLastPane = True
        End If
        
        If m_eOrientation = gtHorizontal Then
            m_oPanes.AddWidth = oPropBag.ReadProperty("PaneWidth" & i, 0)
            Set oPane = m_oPanes.Add()
            m_oPanes.AddWidth = 0
        Else
            m_oPanes.AddHeight = oPropBag.ReadProperty("PaneHeight" & i, 0)
            Set oPane = m_oPanes.Add()
            m_oPanes.AddHeight = 0
        End If
        
        m_oPanes.DontResizeLastPane = False
    
        oPane.Appearance = oPropBag.ReadProperty("PaneAppearance" & i, 1)
        oPane.Tag = oPropBag.ReadProperty("PaneTag" & i, "")
        oPane.Name = oPropBag.ReadProperty("PaneName" & i, "Pane " & i)
        oPane.ControlName = oPropBag.ReadProperty("PaneControlName" & i, "")
        oPane.Minimum = oPropBag.ReadProperty("PaneMinimum" & i, 10)
        oPane.ResizeChildControl = oPropBag.ReadProperty("PaneResizeChildControl" & i, True)
        oPane.Key = oPropBag.ReadProperty("PaneKey" & i, "") ' 7/18/98 Key was persisting
    
    Next
    
End Sub

Private Sub WriteObjectProps(oPropBag As PropertyBag)
'   ***********************************************************************
'   * Params:   oPropBag: the property bag to write property values to
'   * Purpose:  Writes the properties to the property bag. Writes only
'   *               the properties for objects that were changed at design time
'   *               thru the property pages.
'   ***********************************************************************
    Dim i As Long
    Dim oPane As GTPane
    
    Call oPropBag.WriteProperty("NumPanes", m_oPanes.Count, 0)
    
    For Each oPane In m_oPanes
        
        If m_eOrientation = gtHorizontal Then
            Call oPropBag.WriteProperty("PaneWidth" & oPane.Index, oPane.InternalWidth, 0)
        Else
            Call oPropBag.WriteProperty("PaneHeight" & oPane.Index, oPane.InternalHeight, 0)
        End If
        
        Call oPropBag.WriteProperty("PaneControlName" & oPane.Index, oPane.ControlName, "")
        Call oPropBag.WriteProperty("PaneName" & oPane.Index, oPane.Name, "Pane " & i)
        Call oPropBag.WriteProperty("PaneTag" & oPane.Index, oPane.Tag, "")
        Call oPropBag.WriteProperty("PaneAppearance" & oPane.Index, oPane.Appearance, 1)
        Call oPropBag.WriteProperty("PaneMinimum" & oPane.Index, oPane.Minimum, 1)
        Call oPropBag.WriteProperty("PaneResizeChildControl" & oPane.Index, oPane.ResizeChildControl, True)
        Call oPropBag.WriteProperty("PaneKey" & oPane.Index, oPane.Key, "") ' 7/18/98 Key was persisting
        
    Next
    
End Sub

Private Sub ResizeContainedControls()
'   ***********************************************************************
'   * Purpose:  Resizes the controls in each pane based on the
'   *               Name and ResizeChildControl properties of the
'   *               Pane. If the control has an hwnd, the MoveWindow
'   *               API is used, otherwise the move method of the control
'   *               is used.
'   ***********************************************************************
    Dim oPane As GTPane
    Dim cCtl As Control
    Dim hWnd As Long
    
    If Not m_bRedraw Then
        Exit Sub
    End If
    
    On Error Resume Next
    
    For Each oPane In m_oPanes
            
'   ***** Only check the contained controls collection when ResizeChildControl
'   ***** is True and there is a ControlName.
        If oPane.ResizeChildControl And Not (oPane.ControlName = "") Then
        
'   ***** Loops thru the contained controls collection
'   ***** Note: don't access ContainedControls.Count. This will wreak havoc
'   ***** in VB4
            For Each cCtl In ContainedControls
                If StrComp(cCtl.Name, oPane.ControlName, vbTextCompare) = 0 Then
                                                        
                    hWnd = cCtl.hWnd
                    If Err Then ' control doesn't have an hwnd
                        On Error GoTo 0
                        
                        On Error Resume Next
                        
'   ***** Doesn't have an hwnd (graphical control?) so have to use the move method
                        cCtl.Move oPane.Left, oPane.Top, oPane.Width, oPane.Height
'   *****
                    Else
                        cCtl.Move oPane.Left, oPane.Top, oPane.Width, oPane.Height
                        MoveWindow hWnd, ScaleX(oPane.Left, vbTwips, vbPixels), ScaleY(oPane.Top, vbTwips, vbPixels), ScaleX(oPane.Width, vbTwips, vbPixels), ScaleY(oPane.Height, vbTwips, vbPixels), 1
''   ***** Because of a problem using MoveWindow with UserControls (the resize event doesn't fire)
''   ***** check to see if a user control and use the move method or use MoveWindow with non-usercontrols
'                        If IsUserControl(hWnd) Then
'                            cCtl.Move oPane.Left, oPane.Top, oPane.Width, oPane.Height
'                        Else
''   ***** Using the MoveWindow api allows the child control to be sized smaller than using the move method
'                            MoveWindow hWnd, ScaleX(oPane.Left, vbTwips, vbPixels), ScaleY(oPane.Top, vbTwips, vbPixels), ScaleX(oPane.Width, vbTwips, vbPixels), ScaleY(oPane.Height, vbTwips, vbPixels), 1
''   *****
'                        End If
''   *****
                    End If
                End If
            Next
'   *****
        End If
'   *****
    Next
    
End Sub



Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_UserMemId = -552
Attribute ShowAboutBox.VB_MemberFlags = "40"
    
End Sub

Private Function CaptureMouse(x As Single, y As Single, iButton As Integer, Optional byRelease As Byte = gtCapture) As Boolean
'   *********************************************************************************
'   * Params:   X: the left point, Y: the top point, iButton: the button on the mouse
'   *               that is down, byRelease: Optional: if the mouse is to be released
'   *               regardless of the whether the mouse is over the control or not
'   *               (used when the mouse is released off the control).
'   * Return:   Boolean: True if successful, False if not.
'   * Purpose: Captures the mouse when moved over the user control, releases
'   *               the capture when moved off the control or over a contained control.
'   *               Changes the mousepointer to pointer of the contained controls
'   *               when moved off.
'   * Modified:  Ver 1.0a   Added turning subclassing on and off from here instead of
'   *                               always being on.
'   *********************************************************************************
    Static s_bCaptured As Boolean
    Dim lRet As Long
    Dim lWidth As Long
    Dim lHeight As Long
    Dim lTopWindow As Long
    Dim lActiveWindow As Long
    
    If Not s_bCaptured Then

        GTMsgHook1.Subclass = True ' Ver 1.0a Turns on subclassing
        
        SetCapture UserControl.hWnd
        s_bCaptured = True
        
    ElseIf byRelease = gtMouseDown Then ' force to release
        s_bCaptured = False ' reset flag
        
        ActivateTopWindow
        
    ElseIf byRelease = gtRelease Then ' force to release
        GTMsgHook1.Subclass = False ' Ver 1.0a Turns off subclassing
        
        lRet = ReleaseCapture()
        s_bCaptured = False ' reset flag
    
    ElseIf s_bCaptured Then  ' check to see if moved off the control
        
        If x >= 0 And y >= 0 And x <= ScaleWidth And y <= ScaleHeight Or iButton Then
            ' within control
            
            GTMsgHook1.Subclass = True ' Ver 1.0a Turns on subclassing
            
        Else
            GTMsgHook1.Subclass = False ' Ver 1.0a Turns off subclassing
            ReleaseCapture
            s_bCaptured = False ' reset flag
        End If
        
    End If
    
    CaptureMouse = s_bCaptured
End Function

Public Function GetContainedControls() As Variant
Attribute GetContainedControls.VB_MemberFlags = "40"
'   *********************************************************************************
'   * Return:   Variant: False if no contained controls, an array of control names
'   *               if there are controls.
'   * Purpose: For use with the proppages to load the contained controls
'   *               into the ControlName property. Only used for this purpose.
'   *               Loops thru the containedControls collection and loads the
'   *               the control names into an array, which is passed back.
'   *********************************************************************************
    Dim aControls As Variant
    Dim i As Long
    Dim cCtl As Control
    
    On Error GoTo GetContainedControls_err
    
    ReDim aControls(0) As Variant
    
'   ***** Loops thru the contained controls collection
'   ***** Note: don't access ContainedControls.Count. This will wreak havoc
'   ***** in VB4
    For Each cCtl In ContainedControls
        ReDim Preserve aControls(i + 1) As Variant
        aControls(i) = cCtl.Name
        i = i + 1
    Next
'   *****

    GetContainedControls = aControls
    
    Exit Function
    
GetContainedControls_err:
    GetContainedControls = False
End Function

Private Function IsUserControl(hWnd As Long) As Boolean
'   *********************************************************************************
'   * Params:   hWnd: the window to check if it's a user control.
'   * Return:   Boolean: whether or not the window under the point is a usercontrol.
'   * Purpose:  Gets the classname of that window. The return value is based on
'   *               the classname being of a user control ("ThunderUserControl" or
'   *               "ThunderRT5UserControl")
'   *********************************************************************************
    Dim lRet As Long
    Dim sClassName As String
    
    sClassName = Space(256)
    
    lRet = GetClassName(hWnd, sClassName, Len(sClassName))
    
    IsUserControl = (StrComp(Left$(sClassName, lRet), "ThunderUserControl", vbTextCompare) = 0 Or StrComp(Left$(sClassName, lRet), "ThunderRT5UserControl", vbTextCompare) = 0)
    
End Function

Private Sub RefreshGraphicalControls()
'   ***********************************************************************
'   * Purpose:  Loops thru the contained controls collection and
'   *               finds the controls without hwnd properties. These
'   *               controls are then refreshed. This is done because
'   *               graphical controls get painted over when blitting.
'   ***********************************************************************
    Dim cCtl As Control
    Dim hWnd As Long
    If Not m_bRedraw Then
        Exit Sub
    End If
    
    On Error Resume Next
    
    m_bDontPaint = True ' this stops the recursion caused by the refresh
    
'   ***** Looks for controls without hwnd properties. Assumes these
'   ***** are graphical
    For Each cCtl In ContainedControls
        hWnd = cCtl.hWnd
        If Err Then ' control doesn't have an hwnd
            On Error GoTo 0
            
            On Error Resume Next
            
            cCtl.Refresh
        End If
    Next
'   *****

    m_bDontPaint = False ' reset the flag

End Sub

Private Function MouseShiftValue(wParam As Long) As Integer
'   ***********************************************************************
'   * Param:    wParam: the wParam from a callback function.
'   * Return:   Integer: the value for the keys that are pressed.
'   * Purpose:  Determines the keys that were pressed from the
'   *               wParam. Returns the value for all keys.
'   ***********************************************************************
    Dim iShift As Integer
    
'   ***** Check for shift key
    If wParam And MK_SHIFT Then
        iShift = 1
    End If
'   *****
'   ***** Check for ctrl key
    If wParam And MK_CONTROL Then
        iShift = iShift Or 2
    End If
'   *****

'   ***** Check for left or right alt keys
    If (GetAsyncKeyState(VK_RMENU) And &H8000) Or (GetAsyncKeyState(VK_LMENU)) Then
        iShift = iShift Or 4
    End If
'   *****

    MouseShiftValue = iShift
End Function

Private Function MouseButtonValue(wParam As Long) As Integer
'   ***********************************************************************
'   * Param:    wParam: the wParam from a callback function.
'   * Return:   Integer: the value for the buttons that are pressed.
'   * Purpose:  Determines the buttonsthat were pressed from the
'   *               wParam. Returns the value for all buttons.
'   ***********************************************************************
    Dim iShift As Integer
    
'   ***** Check for left mouse button
    If wParam And MK_LBUTTON Then
        iShift = MK_LBUTTON
    End If
'   *****
'   ***** Check for right mouse button
    If wParam And MK_RBUTTON Then
        iShift = iShift Or MK_RBUTTON
    End If
'   *****
'   ***** Check for middle mouse button
    If wParam And MK_MBUTTON Then
        iShift = iShift Or MK_MBUTTON
    End If
'   *****
    MouseButtonValue = iShift
End Function

Private Sub ProcessMouseMessages(lMsgID As Long, wParam As Long, lParam As Long)
'   ***********************************************************************
'   * Param:    lMsgID: the message that was intercepted, wParam:
'   *               the wParam, lParam: the lParam
'   * Purpose:  Strips the x and y coordinates from the lParam and the
'   *               button and shift values from the wParam and fires the
'   *               correct event.
'   ***********************************************************************
    Dim x As Long
    Dim y As Long
    Dim iButtonValue As Integer
    Dim iShiftValue As Integer
    
'   ***** Get the x coordinate
    x = GTMsgHook1.LoWord(lParam)
'   ***** Value is an unsigned integer, so if greater than an int
'   ***** have to subtract to get the negative value
    If x > 32767 Then
        x = x - 65536
    End If
'   *****
'   *****

'   ***** Get the y coordinate
    y = GTMsgHook1.HiWord(lParam)
'   ***** Value is an unsigned integer, so if greater than an int
'   ***** have to subtract to get the negative value
    If y > 32767 Then
        y = y - 65536
    End If
'   *****
'   *****

'   ***** Get the shift and button values
    iButtonValue = MouseButtonValue(wParam)
    iShiftValue = MouseShiftValue(wParam)
'   *****

'   ***** Fires the event
    Select Case lMsgID
        Case WM_MOUSEMOVE
            UserControl_MouseMove iButtonValue, iShiftValue, CSng(x), CSng(y)
        Case WM_LBUTTONDOWN
            UserControl_MouseDown vbLeftButton, iShiftValue, CSng(x), CSng(y)
        Case WM_LBUTTONUP
            UserControl_MouseUp vbLeftButton, iShiftValue, CSng(x), CSng(y)
    End Select
'   *****
End Sub
Private Function GetTopWindow() As Long
'   ***********************************************************************
'   * Return:   Long: the hwnd of the top level window
'   * Purpose:  Loops backwards thru the parents to get the top
'   *               level window.
'   ***********************************************************************
    Dim obj As Object

    On Error Resume Next

    Set obj = UserControl.Parent

    Do While Not obj Is Nothing
        Set obj = obj.Parent
        If Err Then
            Exit Do
        End If
    Loop

    On Error GoTo 0

    On Error Resume Next

    GetTopWindow = obj.hWnd
    If Err Then
        GetTopWindow = 0
    End If
End Function
Private Sub ActivateTopWindow()
'   ***********************************************************************
'   * Purpose: Gets the top hwnd and compares it to the activewindow.
'   *               If they're different, activate the top level window.
'   ***********************************************************************
    Dim lTopWindow As Long
    
    lTopWindow = GetTopWindow()
    If lTopWindow <> GetActiveWindow() Then
        SetForegroundWindow (lTopWindow)
    End If

End Sub

