VERSION 5.00
Begin VB.UserControl GTToolbar 
   Alignable       =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3975
   ControlContainer=   -1  'True
   PropertyPages   =   "GTToolbar.ctx":0000
   ScaleHeight     =   32
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   265
   ToolboxBitmap   =   "GTToolbar.ctx":0048
   Begin VB.Timer tmrTimer 
      Enabled         =   0   'False
      Left            =   540
      Top             =   60
   End
End
Attribute VB_Name = "GTToolbar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'   ******************************************************************************
'   * Purpose:  This is the toolbar control.
'   * File:         GTToolbar.ctl
'   ******************************************************************************
Option Explicit

'   ***** Button type constants
Public Enum GTButtonTypeConstants
    gtTextandImages
    gtImagesOnly
    gtTextOnly
End Enum
'   *****
'   ***** View constants
Public Enum GTViewConstants
    gtLargePicture
    gtSmallPicture
End Enum
'   *****
'   ***** Appearance constants
Public Enum GTAppearanceConstants
    gtFlat
    gt3D
End Enum
'   *****
'   ***** Borderstyle constants
Public Enum GTBorderStyleConstants
    gtNone
    gtFixedSingle
End Enum
'   *****
'   ***** OLEdrop constants
Public Enum GTOLEDropConstants
    gtOLEDropNone
    gtOLEDropManual
End Enum
'   *****

'   ***** Default Property Values:
Const m_def_Appearance = gt3D
Const m_def_BorderStyle = gtFixedSingle
Const m_def_MaskColor = &HC0C0C0
Const m_def_ButtonHeight = 22
Const m_def_ButtonWidth = 24
Const m_def_ToolTips = True
Const m_def_ToolTipsDelay = 2000
Const m_def_WhatsThisHelpID = 0
Const m_def_OLEDropMode = gtOLEDropNone
Const m_def_MousePointer = vbDefault
Const m_def_ForeColor = vbButtonText
Const m_def_BackColor = vb3DFace
'   *****
'   ***** Property Variables:
Private m_eAppearance As GTAppearanceConstants
Private m_eBorderStyle As GTBorderStyleConstants
Private m_lMaskColor As OLE_COLOR
Private m_iButtonHeight As Integer
Private m_iButtonWidth As Integer
Private m_iButtonSpacing As Integer
Private m_iToolTipsDelay As Integer
Private m_lWhatsThisHelpID As Long
Private m_eButtonType As GTButtonTypeConstants
Private m_eView As GTViewConstants
'   *****
'   ***** Variables:
Private WithEvents m_oLargeImages As GTListImages
Attribute m_oLargeImages.VB_VarHelpID = -1
Private WithEvents m_oSmallImages As GTListImages
Attribute m_oSmallImages.VB_VarHelpID = -1
Private WithEvents m_oButtons As GTButtons
Attribute m_oButtons.VB_VarHelpID = -1
Private WithEvents m_CToolTips As CToolTips
Attribute m_CToolTips.VB_VarHelpID = -1
Private m_CDrawRect As CDrawRect
Private m_iLeftOffset As Integer
Private m_iTopOffset As Integer
Private m_iScalePerPixel As Integer
Private m_iTextHeight As Integer
Private m_bRedraw As Boolean
Private m_lMaxTextLength As Long
Private m_ePrevAlign As AlignConstants
Private m_oActiveButton As GTButton
Private m_CPaint As CPaint
Private m_bDontPaint As Boolean
'   *****
'   ***** Event Declarations:
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_HelpID = 129
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when you press and release a mouse button and then press and release it again over an object."
Attribute DblClick.VB_HelpID = 106
Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Attribute KeyDown.VB_HelpID = 32
Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Attribute KeyPress.VB_HelpID = 36
Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Attribute KeyUp.VB_HelpID = 32
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Attribute MouseDown.VB_HelpID = 124
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Attribute MouseMove.VB_HelpID = 121
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Attribute MouseUp.VB_HelpID = 124
Event OLECompleteDrag(Effect As Long)
Attribute OLECompleteDrag.VB_Description = "OLECompleteDrag event"
Attribute OLECompleteDrag.VB_HelpID = 120
Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute OLEDragDrop.VB_Description = "OLEDragDrop event"
Attribute OLEDragDrop.VB_HelpID = 119
Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
Attribute OLEDragOver.VB_Description = "OLEDragOver event."
Attribute OLEDragOver.VB_HelpID = 118
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Attribute OLEGiveFeedback.VB_Description = "OLEGiveFeedback event."
Attribute OLEGiveFeedback.VB_HelpID = 116
Event OLESetData(Data As DataObject, DataFormat As Integer)
Attribute OLESetData.VB_Description = "OLESetData event"
Attribute OLESetData.VB_HelpID = 117
Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
Attribute OLEStartDrag.VB_Description = "OLEStartDrag event"
Attribute OLEStartDrag.VB_HelpID = 115
Event Resize()
Attribute Resize.VB_Description = "Occurs when a form is first displayed or the size of an object changes."
Attribute Resize.VB_HelpID = 111
Event ButtonClick(Button As GTButton)
Attribute ButtonClick.VB_Description = "Occurs when the user clicks on a Button object in a Toolbar control."
Attribute ButtonClick.VB_HelpID = 127
Attribute ButtonClick.VB_MemberFlags = "200"
Event MouseEnter(Button As GTButton)
Attribute MouseEnter.VB_Description = "Occurs when the user moves the mouse over a GTButton object."
Attribute MouseEnter.VB_HelpID = 123
Event MouseExit(Button As GTButton)
Attribute MouseExit.VB_Description = "Occurs when the user moves the mouse off a GTButton object."
Attribute MouseExit.VB_HelpID = 123
Event PlaceHolderResize(Button As GTButton)
Attribute PlaceHolderResize.VB_Description = "Occurs when the Width property of a GTButton object of Style PlaceHolder is changed."
Attribute PlaceHolderResize.VB_HelpID = 112
'   *****

'   ***** Returns/sets the ButtonType constant. This will be Images and Text, Images Only,
'   ***** or Text Only. This also resets the buttonheight and buttonwidth
Public Property Let ButtonType(eButtonType As GTButtonTypeConstants)
Attribute ButtonType.VB_Description = "Sets/Returns the whether the each Button object shows a picture and text, a picture only, or text only."
Attribute ButtonType.VB_HelpID = 15
Attribute ButtonType.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
    If m_eButtonType = eButtonType Then
        Exit Property
    End If
    m_iButtonHeight = m_def_ButtonHeight
    m_iButtonWidth = m_def_ButtonWidth
    m_eButtonType = eButtonType
    m_oButtons.ButtonType = eButtonType
    SetMaxTextLength
    Paint
    PropertyChanged "ButtonType"
End Property
Public Property Get ButtonType() As GTButtonTypeConstants
    ButtonType = m_eButtonType
End Property
'   *****

'   *****Returns/sets the View constant. This will be Large or Small images.This will reset the button dimenstions.
Public Property Let View(eView As GTViewConstants)
Attribute View.VB_Description = "Returns/sets whether the images from the LargePicture or SmallPicture collection will be used."
Attribute View.VB_HelpID = 95
Attribute View.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
    If m_eView = eView Then
        Exit Property
    End If
    m_eView = eView
    m_oButtons.View = eView
    SetButtonDimensions ' m_iButtonWidth, m_iButtonHeight
    Paint
    PropertyChanged "View"
End Property
Public Property Get View() As GTViewConstants
    View = m_eView
End Property
'   *****

'   ***** Returns a reference to the Buttons collection
Public Property Get Buttons() As GTButtons
Attribute Buttons.VB_Description = " Returns a reference to a Toolbar control's collection of Button objects."
Attribute Buttons.VB_HelpID = 23
    Set Buttons = m_oButtons
End Property
'   *****

'   ***** Returns a reference to the LargeImages collection
Public Property Get LargeImages() As GTListImages
Attribute LargeImages.VB_Description = "Returns a reference to a collection of GtListImage objects."
Attribute LargeImages.VB_HelpID = 50
    Set LargeImages = m_oLargeImages
End Property
'   *****

'   ***** Returns a reference to the SmallImages collection
Public Property Get SmallImages() As GTListImages
Attribute SmallImages.VB_Description = "Returns a reference to a collection of GtListImage objects."
Attribute SmallImages.VB_HelpID = 75
    Set SmallImages = m_oSmallImages
End Property
'   *****


Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_Description = "Shows the Aboutbox."
Attribute ShowAboutBox.VB_HelpID = 8
Attribute ShowAboutBox.VB_UserMemId = -552
Attribute ShowAboutBox.VB_MemberFlags = "40"
    
End Sub

'   ***** Returns/sets whether the control will appear 3D or Flat.
Public Property Get Appearance() As GTAppearanceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
Attribute Appearance.VB_HelpID = 22
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
Attribute Appearance.VB_MemberFlags = "200"
    Appearance = m_eAppearance
End Property

Public Property Let Appearance(ByVal New_Appearance As GTAppearanceConstants)
    If m_eAppearance = New_Appearance Then
        Exit Property
    End If
    m_eAppearance = New_Appearance
    PropertyChanged "Appearance"
    CalcOffset
    Paint
End Property
'   *****

'   ***** Returns/sets whether the control will have a border or not
Public Property Get BorderStyle() As GTBorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_HelpID = 2
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_eBorderStyle
End Property
Public Property Let BorderStyle(ByVal New_BorderStyle As GTBorderStyleConstants)
    If m_eBorderStyle = New_BorderStyle Then
        Exit Property
    End If
    m_eBorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
    CalcOffset
    Paint
End Property
'   *****

'   ***** Ver 1.0a No longer used
'Private Sub GTMsgHook1_Message(ByVal hWnd As Long, ByVal MsgID As Long, ByVal wParam As Long, ByVal lParam As Long)
''   ****************************************************************************
''   * Params:   hWnd: the window handle that is subclassed, MsgID: the message that was intercepted, wParam: the wParam of the
''   *               message, lParam: the lParam of the message
''   * Purpose:  Fires when a Message in the Messages collection for the Window is intercepted
''   ****************************************************************************
'
'    Select Case MsgID
'        Case WM_SYSCOLORCHANGE:
'            Paint
'    End Select
'
'End Sub
'   *****

Private Sub m_CToolTips_TimerIntervalChanged(lInterval As Long)
'   ****************************************************************************
'   * Params:   lInterval: the new time to set the Interval property of the timer
'   * Purpose:  Fires when the Interval property of the Timer needs to be changed.
'   ****************************************************************************
    tmrTimer.Interval = lInterval
End Sub

Private Sub m_CToolTips_TimerStatusChanged(bEnabled As Boolean)
'   ****************************************************************************
'   * Params:   bEnabled: Whether the Timer should be enabled or not.
'   * Purpose:  Fires when the Enabled property of the Timer needs to be changed.
'   ****************************************************************************
    tmrTimer.Enabled = bEnabled
End Sub

Private Sub m_oButtons_ButtonAdded(Button As GTButton)
'   ***********************************************************************
'   * Params:   Button: the GTButton object that was added
'   * Purpose:  Fired when a GTButton object is added to the Buttons collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************

    If m_oButtons.Count = 1 Then
        SetButtonDimensions
    End If
    
    If Not Button.Caption = "" Then
        SetMaxTextLength
    End If
    
    Paint
    PropertyChanged "Buttons"
End Sub

Private Sub m_oButtons_ButtonChanged(Button As GTButton, sProperty As String)
'   ***********************************************************************
'   * Params:   Button: the GTButton object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTButton object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    Select Case sProperty
        Case "Width"
            RaiseEvent PlaceHolderResize(Button)
            Paint
        
        Case "Caption"
            SetMaxTextLength
        
        Case "LargePicture", "SmallPicture", "Value", "Enabled"
            Paint Button
        
        Case "Style", "Visible"
            Paint
            
        Case Else
        
    End Select
    
    PropertyChanged "Buttons"
End Sub

Private Sub m_oButtons_ButtonRemoved(Button As GTButton)
'   ***********************************************************************
'   * Params:   Button: the GTButton object that was removed
'   * Purpose:  Fired when a GTButton object is removed from the Buttons collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   ***********************************************************************
    If Button Is Nothing Then
    
    Else
    
    End If
    
    Paint
    PropertyChanged "Buttons"
End Sub

Private Sub m_oLargeImages_ImageAdded(oListImage As GTListImage)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was added
'   * Purpose:  Fired when a GTListImage object is added to the LargeImages collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub m_oLargeImages_ImageChanged(oListImage As GTListImage, sProperty As String)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTListImage object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub m_oLargeImages_ImageRemoved(oListImage As GTListImage)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was removed
'   * Purpose:  Fired when a GTListImage object is removed from the LargeImages collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub m_oSmallImages_ImageAdded(oListImage As GTListImage)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was added
'   * Purpose:  Fired when a GTListImage object is added to the SmallImages collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub m_oSmallImages_ImageChanged(oListImage As GTListImage, sProperty As String)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTListImage object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub m_oSmallImages_ImageRemoved(oListImage As GTListImage)
'   ***********************************************************************
'   * Params:   oListImage: the GTListImage object that was removed
'   * Purpose:  Fired when a GTListImage object is removed from the SmallImages collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   ***********************************************************************
    PropertyChanged "Images"
End Sub

Private Sub tmrTimer_Timer()
'   ****************************************************************************
'   * Purpose:  Fires interval has expired. This will call the TimerExpired method
'   *               of the CToolTips. This had to be done this way because adding a reference to
'   *               the timer doesn't let the Terminate event fire and there for holds the instance
'   *               of the control in memory and causes major problems
'   ****************************************************************************
    m_CToolTips.TimerExpired
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
'   ****************************************************************************
'   * Params:   PropertyName: the name of the property that was changed.
'   * Purpose:  Fires when one of the Ambient properties was changed.
'   ****************************************************************************
    Select Case PropertyName
        Case "ScaleUnits":
            CalculateScaleUnits
            Paint
    End Select
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

'   ***** Returns/sets the enabled property
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_HelpID = 18
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled = New_Enabled
    PropertyChanged "Enabled"
End Property
'   *****

'   ***** Returns/sets the Font object. The whole font object needs to change otherwise there
'   ***** is no notification (ie. changing bold.); this is limitation of VB
Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_HelpID = 31
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property
Public Property Set Font(ByVal New_Font As StdFont)
    If UserControl.Font Is New_Font Then
        Exit Property
    End If
    Set UserControl.Font = New_Font
    PropertyChanged "Font"
    SetTextHeight
    SetMaxTextLength
    Paint
End Property
'   *****

'   ***** Returns/sets the forecolor property
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_HelpID = 5000
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = UserControl.ForeColor
End Property
Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor = New_ForeColor
    PropertyChanged "ForeColor"
    Paint
End Property
'   *****

'   ***** Returns/sets the BackColor property
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_HelpID = 5000
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor = New_BackColor
    PropertyChanged "BackColor"
    Paint
End Property
'   *****

'   ***** Returns the hWnd of the usercontrol.
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
Attribute hWnd.VB_HelpID = 43
Attribute hWnd.VB_UserMemId = -515
    hWnd = UserControl.hWnd
End Property
'   *****

Private Sub UserControl_Initialize()
'   ****************************************************************************
'   * Purpose:  Fires when the control is first instiated. The control has not
'   *               yet been sited on the container. Initalizes certain variables and Messages
'   *               are added to be intercepted.
'   ****************************************************************************
'   ***** Ver 1.0a No longer used
'    Dim oWindow As GTWindow
'    Dim oMessage As GTMessage
'   *****

    Set m_CPaint = New CPaint
    Set m_CDrawRect = New CDrawRect

    Set m_oButtons = New GTButtons

    Set m_oLargeImages = New GTListImages
    Set m_oSmallImages = New GTListImages
'   ***** Needs an hdc to create the mask when the image is first
'   ***** added
    m_oLargeImages.DestinationDC = UserControl.hdc
    m_oSmallImages.DestinationDC = UserControl.hdc
'   *****

'   ***** Ver 1.0a No longer used
''   ***** Add the hwnd of the user control to be subclassed  and add the
''   ***** WM_SYSCOLORCHANGE constant. This is so the background
''   ***** changes when system color changes.
'    Set oWindow = GTMsgHook1.Windows.Add(, , , UserControl.hWnd)
'    If Not oWindow Is Nothing Then
'        Set oMessage = oWindow.Messages.Add(, , WM_SYSCOLORCHANGE, "WM_SYSCOLORCHANGE")
'    End If
''   *****
'   *****

    Set m_CToolTips = New CToolTips

    m_bRedraw = True
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

'   ***** Returns/sets the MaskColor property. This property defines the part of an image
'   ***** to be transparent
Public Property Get MaskColor() As OLE_COLOR
Attribute MaskColor.VB_Description = "Returns/sets the color that specifies transparent areas in the MaskPicture."
Attribute MaskColor.VB_HelpID = 54
Attribute MaskColor.VB_ProcData.VB_Invoke_Property = ";Behavior"
    MaskColor = m_oLargeImages.MaskColor
End Property

Public Property Let MaskColor(ByVal New_MaskColor As OLE_COLOR)
    If m_oLargeImages.MaskColor = New_MaskColor Then
        Exit Property
    End If
'   ***** Set the MaskColor property of both the large and small images
'   ***** collection
    m_oLargeImages.MaskColor = New_MaskColor
    m_oSmallImages.MaskColor = New_MaskColor
'   *****
    PropertyChanged "MaskColor"
    Paint
End Property
'   *****

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is down. This will determine that the
'   *               button (if there is one) under the mouse needs to be drawn in
'   *               the down state. ToolTips are turned off.
'   ****************************************************************************
    Dim oButton As GTButton
    
    On Error Resume Next ' ver 1.0a Skips extender error when extender object isn't available
    
    If Button = vbLeftButton Then
        CaptureMouse x, y, Button, True ' Turn capture off
        
        Set oButton = ButtonHitTest(x, y)
        If Not oButton Is Nothing Then
                        
            m_CToolTips.MouseDown ' calls mousedown for the tooltips
            
'   ***** Raise the event and exit the event when the button style is separator.
'   ***** If the button style is placeholder, only exit when the control is horizontal
'   ***** (When vertical placeholders show as buttons
            Select Case oButton.Style
                Case gtPlaceHolder
                    If Extender.Align = vbAlignTop Or Extender.Align = vbAlignBottom Then
                        RaiseEvent MouseDown(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                        Exit Sub
                    End If
                    
                Case gtSeparator
                    RaiseEvent MouseDown(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                    Exit Sub
            
            End Select
'   *****

            If Not oButton.Enabled Then
                RaiseEvent MouseDown(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                Exit Sub
            End If
            
'   ***** if the button is the active button (the mouse is over it, set the down
'   ***** down property and repaint the button
            If oButton Is m_oActiveButton Then
                m_oButtons(oButton.Index).Down = True
                Paint oButton
            End If
'   *****
        End If
    End If
    
    RaiseEvent MouseDown(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
End Sub

'   ***** Returns/sets the MouseIcon property
Public Property Get MouseIcon() As StdPicture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
Attribute MouseIcon.VB_HelpID = 58
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = ";Misc"
    Set MouseIcon = UserControl.MouseIcon
End Property
Public Property Set MouseIcon(ByVal New_MouseIcon As StdPicture)
    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property
'   *****

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is moved over the user control. If
'   *                the mouse is over a button it will be shown as active (raised)
'   *               when in the up state or (inset) when in the down state. ToolTips
'   *               are turned on or updated from here.
'   * Modified: Ver 1.0a    Added resetting the down flag when over a placeholder
'   ****************************************************************************
    Dim oButton As GTButton
    Dim bCaptured As Boolean
    
    On Error Resume Next ' ver 1.0a Skips extender error when extender object isn't available

'   ***** If the left button is not down capture the mouse
    If Not (Button = vbLeftButton) Then
        CaptureMouse x, y, Button
    End If
'   *****

    Set oButton = ButtonHitTest(x, y)
    If Not oButton Is Nothing Then ' the mouse is over a button
        
        m_CToolTips.MouseMove UserControl.hWnd, oButton ' call the mousemove routine in tooltips
        
'   ***** Raise the event and exit the event when the button style is separator.
'   ***** If the button style is placeholder, only exit when the control is horizontal
'   ***** (When vertical placeholders show as buttons
        Select Case oButton.Style
            Case gtPlaceHolder
                If Extender.Align = vbAlignTop Or Extender.Align = vbAlignBottom Then
                    If Not m_oActiveButton Is Nothing Then
                        m_oButtons(m_oActiveButton.Index).Active = False ' reset the active flag
                        m_oButtons(m_oActiveButton.Index).Down = False ' reset the down flag ' Ver 1.0a Bug 707
                        Paint m_oActiveButton 'repaint the button
                        Set m_oActiveButton = Nothing
                    End If
                    
                    RaiseEvent MouseMove(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                    Exit Sub
                End If
                
            Case gtSeparator
                RaiseEvent MouseMove(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                Exit Sub
        
        End Select
'   *****

'   ***** If the button is disabled, reset the active property and set the
'   ***** active button to nothing and the raise the event
        If Not oButton.Enabled Then
            If Not m_oActiveButton Is Nothing Then
                m_oButtons(m_oActiveButton.Index).Active = False
                
                Paint m_oActiveButton
                    
                Set m_oActiveButton = Nothing
            End If
            
            RaiseEvent MouseMove(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
            Exit Sub
        End If
'   *****

'   ***** If the button under the mouse is the active button
'   ***** set the active property and if the left mouse button
'   ***** is down, set the down flag and repaint the button
        If oButton Is m_oActiveButton Then
            m_oButtons(m_oActiveButton.Index).Active = True
            
            If Button = vbLeftButton Then
                m_oButtons(m_oActiveButton.Index).Down = True
            End If
            
            Paint oButton
            Exit Sub
        End If
'   *****

'   ***** If the active button is not nothing and the button under the mouse
'   ***** is a different button
        If Not m_oActiveButton Is Nothing Then
            Select Case Button
                Case vbMiddleButton, vbRightButton ' the middle or right mousebutton is down
                    ' do nothing
                    
                Case vbLeftButton ' the left mousebutton is down
                    ' reset the down flag to false and repaint the button
                    m_oButtons(m_oActiveButton.Index).Down = False
                    Paint m_oActiveButton
                
                Case Else ' no mouse buttons are down
                    ' reset the active flag and repaint the active button
                    m_oButtons(m_oActiveButton.Index).Active = False
                    Paint m_oActiveButton
            
            End Select
        
            RaiseEvent MouseExit(m_oButtons(m_oActiveButton.Index))
        End If
'   *****

'   ***** When no mousebuttons are down, set the button under the
'   ***** mouse to be the active button
        If Button = 0 Then
            Set m_oActiveButton = oButton
            m_oButtons(oButton.Index).Active = True
            
            RaiseEvent MouseEnter(m_oButtons(oButton.Index))
        End If
    '*****
    
        Paint oButton
        
    ElseIf Not (m_oActiveButton Is Nothing) Then
'   ***** The mouse is not over a button and there is an active button. Reset
'   ***** the down property of the active button (when the value is unpressed),
'   ***** set the active flag to false when the mouse buttons are up and paint
'   ***** the active button. Also set the active button to nothing
        If m_oButtons(m_oActiveButton.Index).Value = gtUnpressed Then
            If m_oButtons(m_oActiveButton.Index).Down Then
                m_oButtons(m_oActiveButton.Index).Down = False
            End If
        End If
        
        If Button = 0 Then
            m_oButtons(m_oActiveButton.Index).Active = False
        End If
        
        Paint m_oActiveButton
            
        If Button = 0 Then
            Set m_oActiveButton = Nothing
        End If
'   *****
    Else
'   ***** no button is under the mouse and there was no active button
'   ***** so hide the tooltips
        m_CToolTips.HideToolTip
'   *****
    End If
    
    RaiseEvent MouseMove(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
End Sub

'   ***** Returns/sets the MousePointer constant.
Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
Attribute MousePointer.VB_HelpID = 59
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Misc"
    MousePointer = UserControl.MousePointer
End Property
Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    UserControl.MousePointer = New_MousePointer
    PropertyChanged "MousePointer"
End Property
'   *****

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is released. This will turn tooltips back on.
'   *               It will also be determined if the button is show raised or inset
'   *               depending on the Style and Value properties of the button.
'   * Modified: Ver 1.0A    Added IsCursorOverToolbar to reset the active property
'   *                               of the button.
'   *                               Moved calling the MouseUp method of CToolTips to just
'   *                               before raising MouseUp
'   *               Ver 1.0a    Added on error resume next to stop extender errors when
'   *                               no extender object exists.
'   ****************************************************************************
    Dim oButton As GTButton
        
    On Error Resume Next ' ver 1.0a Skips extender error when extender object isn't available

'    m_CToolTips.MouseUp ' call mouseup in tooltips ' Ver 1.0A Moved to before raising MouseUp
    
    CaptureMouse x, y, Button ' capture the mouse
    
    If Button = vbLeftButton Then ' the left mouse button is down
        
'   ***** get the button under the mouse and set the value to pressed if a toggle,
'   ***** group or group toggle button and the value is unpressed
'   ***** otherwise set the value to unpressed and redraw the button . Also
'   ***** reset the down property
        Set oButton = ButtonHitTest(x, y)
        If Not oButton Is Nothing Then
            
            Select Case oButton.Style
                Case gtPlaceHolder
                    If Extender.Align = vbAlignTop Or Extender.Align = vbAlignBottom Then
                        m_CToolTips.MouseUp ' call mouseup in tooltips
                        
                        RaiseEvent MouseUp(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                        Exit Sub
                    End If
                    
                Case gtSeparator
                    m_CToolTips.MouseUp ' call mouseup in tooltips
                    
                    RaiseEvent MouseUp(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                    Exit Sub
            
            End Select
            
            If Not oButton.Enabled Then
                m_CToolTips.MouseUp ' call mouseup in tooltips
                
                RaiseEvent MouseUp(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                Exit Sub
            End If
                
            If oButton Is m_oActiveButton Then
                
                m_oButtons(m_oActiveButton.Index).Down = False
                
                Select Case m_oButtons(m_oActiveButton.Index).Style
                    Case gtToggle
                        If m_oButtons(m_oActiveButton.Index).Value = gtPressed Then
                            m_oButtons(m_oActiveButton.Index).Value = gtUnpressed
                        Else
                            m_oButtons(m_oActiveButton.Index).Value = gtPressed
                        End If
                    
                    Case gtDefault
                        If m_oButtons(m_oActiveButton.Index).Value = gtPressed Then
                            m_oButtons(m_oActiveButton.Index).Value = gtUnpressed
                        End If
                        
                    Case gtGroup, gtGroupToggle
                        SetGroupValues m_oButtons(m_oActiveButton.Index)
                
                End Select
                
                RaiseEvent ButtonClick(m_oButtons(oButton.Index))
                
                oButton.Active = IsCursorOverToolbar ' Ver 1.0a
                
                Paint oButton
            
                m_CToolTips.MouseUp ' call mouseup in tooltips
                
                RaiseEvent MouseUp(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
                Exit Sub
            End If
            
        End If
        
'   ***** If there is an active button, reset the down and active flags, repaint
'   ***** and set the active button to nothing
        If Not m_oActiveButton Is Nothing Then
            m_oButtons(m_oActiveButton.Index).Down = False
            m_oButtons(m_oActiveButton.Index).Active = False
            
            Paint m_oActiveButton
            
            Set m_oActiveButton = Nothing
            
        End If
'   *****
    End If
    
    m_CToolTips.MouseUp ' call mouseup in tooltips
    
    RaiseEvent MouseUp(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)

End Sub

'   ***** OLE Drag/Drop events
Private Sub UserControl_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub
Public Sub OLEDrag()
Attribute OLEDrag.VB_Description = "Starts an OLE drag/drop event with the given control as the source."
Attribute OLEDrag.VB_HelpID = 135
    UserControl.OLEDrag
End Sub
Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, x, y)
End Sub
Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, x, y, State)
End Sub
Private Sub UserControl_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub
Private Sub UserControl_OLESetData(Data As DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub
Private Sub UserControl_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub
'   *****

'   ***** Returns/sets the value of OLEDropMode
Public Property Get OLEDropMode() As GTOLEDropConstants
    OLEDropMode = UserControl.OLEDropMode
End Property
Public Property Let OLEDropMode(ByVal New_OLEDropMode As GTOLEDropConstants)
    UserControl.OLEDropMode() = New_OLEDropMode
    PropertyChanged "OLEDropMode"
End Property
'   *****

'   ***** Returns/sets the ButtonHeight property. This will be overridden if smaller than the
'   ***** default: 22 pixels
Public Property Get ButtonHeight() As Integer
Attribute ButtonHeight.VB_Description = "Returns/sets the height of the buttons"
Attribute ButtonHeight.VB_HelpID = 11
Attribute ButtonHeight.VB_ProcData.VB_Invoke_Property = ";Misc"
    ButtonHeight = m_iButtonHeight * m_iScalePerPixel
End Property
Public Property Let ButtonHeight(ByVal New_ButtonHeight As Integer)
    If m_iButtonHeight = New_ButtonHeight \ m_iScalePerPixel Then
        Exit Property
    End If

    m_iButtonHeight = New_ButtonHeight \ m_iScalePerPixel
    SetButtonDimensions
    
    PropertyChanged "ButtonHeight"
End Property
'   *****

'   ***** Returns/sets the ButtonWidth property. This will be overridden if smaller than the
'   ***** default: 24 pixels
Public Property Get ButtonWidth() As Integer
Attribute ButtonWidth.VB_Description = "Returns/sets the width of the buttons"
Attribute ButtonWidth.VB_HelpID = 19
Attribute ButtonWidth.VB_ProcData.VB_Invoke_Property = ";Misc"
    ButtonWidth = m_iButtonWidth * m_iScalePerPixel
End Property
Public Property Let ButtonWidth(ByVal New_ButtonWidth As Integer)
    If m_iButtonWidth = New_ButtonWidth \ m_iScalePerPixel Then
        Exit Property
    End If

    m_iButtonWidth = New_ButtonWidth \ m_iScalePerPixel
    SetButtonDimensions
    PropertyChanged "ButtonWidth"
End Property
'   *****

'   ***** Returns/sets whether tooltips will be shown
Public Property Get ToolTips() As Boolean
Attribute ToolTips.VB_Description = "Enables/disables ToolTips for tool buttons"
Attribute ToolTips.VB_HelpID = 89
Attribute ToolTips.VB_ProcData.VB_Invoke_Property = ";Misc"
    ToolTips = m_CToolTips.ToolTips
End Property
Public Property Let ToolTips(ByVal New_ToolTips As Boolean)
    If m_CToolTips.ToolTips = New_ToolTips Then
        Exit Property
    End If
    m_CToolTips.ToolTips = New_ToolTips
    PropertyChanged "ToolTips"
End Property
'   *****

'   ***** Returns/sets the ToolTipDelay property. This sets how long the mouse
'   ***** must be paused over a button before the tooltip is displayed.
Public Property Get ToolTipsDelay() As Long
Attribute ToolTipsDelay.VB_Description = "Sets/Returns the amount of time the mouse must pause over a GTButton object before the TooTips appears."
Attribute ToolTipsDelay.VB_HelpID = 90
Attribute ToolTipsDelay.VB_ProcData.VB_Invoke_Property = ";Misc"
    ToolTipsDelay = tmrTimer.Interval
End Property
Public Property Let ToolTipsDelay(ByVal New_ToolTipsDelay As Long)
    If tmrTimer.Interval = New_ToolTipsDelay Then
        Exit Property
    End If
    tmrTimer.Interval = New_ToolTipsDelay
    m_CToolTips.ToolTipsDelay = New_ToolTipsDelay
    
    PropertyChanged "ToolTipsDelay"
End Property
'   *****

Public Function HitTest(x As Single, y As Single) As GTButton
Attribute HitTest.VB_Description = "Returns an object reference to the object at the specified X and Y position."
Attribute HitTest.VB_HelpID = 3
'   *****************************************************************************
'   * Params:   X: the left point, Y: the top point
'   * Return:   GTButton: a GTButton object if X,Y intersects a button, Nothing if not
'   * Purpose:  Returns a button if the X,Y point if over a button.
'   *****************************************************************************
    Set HitTest = ButtonHitTest(x, y)
End Function

'   ***** Returns/sets the UseMaskColor property. This is used for drawing
'   ***** pictures transparent and is used in conjunction with the MaskColor property.
Public Property Get UseMaskColor() As Boolean
Attribute UseMaskColor.VB_Description = "Returns/sets a value which determines if the ImageList control will use the MaskColor property."
Attribute UseMaskColor.VB_HelpID = 93
Attribute UseMaskColor.VB_ProcData.VB_Invoke_Property = ";Behavior"
    UseMaskColor = m_oLargeImages.UseMaskColor
End Property
Public Property Let UseMaskColor(ByVal bUseMaskColor As Boolean)
    If m_oLargeImages.UseMaskColor = bUseMaskColor Then
        Exit Property
    End If
    
'   ***** sets the UseMaskColor property of the large and small
'   ***** images collections
    m_oLargeImages.UseMaskColor = bUseMaskColor
    m_oSmallImages.UseMaskColor = bUseMaskColor
'   *****

    Paint
    
    PropertyChanged "UseMaskColor"
End Property
'   *****

'   ***** Returns/sets the WhatsThisHelpID property. Used with the WhatsThisMode methode
Public Property Get WhatsThisHelpID() As Long
Attribute WhatsThisHelpID.VB_Description = "Returns/sets an associated context number for an object."
Attribute WhatsThisHelpID.VB_HelpID = 97
Attribute WhatsThisHelpID.VB_ProcData.VB_Invoke_Property = ";Misc"
    WhatsThisHelpID = m_lWhatsThisHelpID
End Property
Public Property Let WhatsThisHelpID(ByVal New_WhatsThisHelpID As Long)
    m_lWhatsThisHelpID = New_WhatsThisHelpID
    PropertyChanged "WhatsThisHelpID"
End Property
'   *****

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
'   *************************************************************************
'   * Purpose:  Intializes the property variables . This is fired when a
'   *               control is first instanciated.
'   *************************************************************************

    On Error Resume Next ' want skip an error if the align property isn't supported

    Extender.Align = vbAlignTop
    m_ePrevAlign = Extender.Align

    On Error GoTo 0 ' Reset the error handler

'   ***** gets the number of scaleunits per pixel based on the container's scalemode
    CalculateScaleUnits
'   *****

    m_eAppearance = m_def_Appearance
    m_eBorderStyle = m_def_BorderStyle

'   ***** calculates the offset from the left and top based on the appearance and
'   ***** borderstyle properties
    CalcOffset
'   *****
'   ***** Ver 1.0a
    Set UserControl.Font = Ambient.Font
'    Set Font = Ambient.Font
'   *****
    m_oLargeImages.MaskColor = m_def_MaskColor
    m_oSmallImages.MaskColor = m_def_MaskColor
    m_iButtonHeight = m_def_ButtonHeight
    m_iButtonWidth = m_def_ButtonWidth
    m_CToolTips.ToolTips = m_def_ToolTips
    tmrTimer.Interval = m_def_ToolTipsDelay
    m_CToolTips.ToolTipsDelay = m_def_ToolTipsDelay
    m_lWhatsThisHelpID = m_def_WhatsThisHelpID
    UserControl.OLEDropMode = m_def_OLEDropMode
    UserControl.MousePointer = m_def_MousePointer
    UserControl.BackColor = m_def_BackColor
    UserControl.ForeColor = m_def_ForeColor
    m_eView = gtSmallPicture
    m_eButtonType = gtImagesOnly

'   ***** sets the buttontype and view property of the buttons collection
    m_oButtons.ButtonType = m_eButtonType
    m_oButtons.View = m_eView
'   *****

'   ***** Ver 1.0a Doesn't need to be set
'    SetButtonDimensions
'   *****
    SetTextHeight

'   ***** Ver 1.0a No longer used
''   ***** turns on subclassing. Turn off for debugging
'#If DEBUG_SWITCH = DEBUG_DEBUG Then ' Ver 1.0a Added
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = DEBUG_RUN Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
''   *****
'   *****

    Paint

End Sub

Private Sub UserControl_Paint()
'   **************************************************************
'   * Purpose:  Fired when the control needs to be repainted.
'   *               Calls the internal Paint proc.
'   **************************************************************
    Paint
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'   *************************************************************************
'   * Purpose:  Retrieves the properties from the property bag for those
'   *               properties that can be set at designtime or thru the proppages.
'   *               The control is sited on the container that is point.
'   *************************************************************************
    m_bRedraw = False
    
    On Error Resume Next ' want skip an error if the align property isn't supported
    Extender.Align = PropBag.ReadProperty("Align", vbAlignTop)
    m_ePrevAlign = Extender.Align
    
    On Error GoTo 0
    
'   ***** gets the number of scaleunits per pixel based on the container's scalemode
    CalculateScaleUnits
'   *****
    
    m_eAppearance = PropBag.ReadProperty("Appearance", m_def_Appearance)
    m_eBorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    
'   ***** calculates the offset from the left and top based on the appearance and
'   ***** borderstyle properties
    CalcOffset
'   *****
    
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    m_oLargeImages.MaskColor = PropBag.ReadProperty("MaskColor", m_def_MaskColor)
    m_oSmallImages.MaskColor = m_oLargeImages.MaskColor
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", m_def_MousePointer)
    UserControl.OLEDropMode = PropBag.ReadProperty("OLEDropMode", m_def_OLEDropMode)
    m_iButtonHeight = PropBag.ReadProperty("ButtonHeight", m_def_ButtonHeight)
    m_iButtonWidth = PropBag.ReadProperty("ButtonWidth", m_def_ButtonWidth)
    m_CToolTips.ToolTips = PropBag.ReadProperty("ToolTips", m_def_ToolTips)
    tmrTimer.Interval = PropBag.ReadProperty("ToolTipsDelay", m_def_ToolTipsDelay)
    m_CToolTips.ToolTipsDelay = tmrTimer.Interval
    
    m_oLargeImages.UseMaskColor = PropBag.ReadProperty("UseMaskColor", True)
    m_oSmallImages.UseMaskColor = m_oLargeImages.UseMaskColor
    
    m_lWhatsThisHelpID = PropBag.ReadProperty("WhatsThisHelpID", m_def_WhatsThisHelpID)
    m_eView = PropBag.ReadProperty("View", gtSmallPicture)
    m_eButtonType = PropBag.ReadProperty("ButtonType", gtImagesOnly)
    
'   ***** sets the buttontype and view property of the buttons collection
    m_oButtons.ButtonType = m_eButtonType
    m_oButtons.View = m_eView
'   *****

    m_oLargeImages.Width = PropBag.ReadProperty("LargeImagesWidth", 32)
    m_oLargeImages.Height = PropBag.ReadProperty("LargeImagesHeight", 32)
    m_oSmallImages.Width = PropBag.ReadProperty("SmallImagesWidth", 16)
    m_oSmallImages.Height = PropBag.ReadProperty("SmallImagesHeight", 16)
    
'   ***** reads the properties for the collections. These are the properties set in
'   ***** the prop pages
    m_oLargeImages.ReadObjectProps PropBag, "LargeImages"
    m_oSmallImages.ReadObjectProps PropBag, "SmallImages"
    m_oButtons.ReadObjectProps PropBag
'   *****

    SetMaxTextLength
    SetTextHeight
    
'   ***** Ver 1.0a No longer used
''   ***** turns on subclassing based on the user mode
'#If DEBUG_SWITCH = DEBUG_DEBUG Then ' Ver 1.0a Added
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = DEBUG_RUN Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
''   *****
'   *****

    m_bRedraw = True
    
    Paint

End Sub

Private Sub UserControl_Resize()
'   **************************************************************************
'   * Purpose:  Fired when the control is resized. The control is a fixed
'   *               height (horizontal) or width (vertical) depending on the
'   *               width/height of the buttons. The width/height will also be
'   *               reset here. A static variable is used so an endless loop
'   *               doesn't occur.
'   **************************************************************************
    Static s_bSkip As Boolean
    
'   ***** Ver 1.0a
    On Error Resume Next ' want skip an error if the align property isn't supported
'   *****

    If s_bSkip Then ' want to exit when true, stops the endless loop
        Exit Sub
    End If
    
    s_bSkip = True ' before setting anything, set the flag to true
    
'   ***** If the align property has changed
    If Not (m_ePrevAlign = Extender.Align) Then
        SetButtonDimensions
        m_oButtons.Align = Extender.Align
        m_ePrevAlign = Extender.Align
    End If
'   *****
    
'   ***** Set the width and height depending on the orientation of the toolbar
    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
        If Not m_iButtonWidth = 0 Then
            UserControl.Width = ScaleX(m_iButtonWidth + m_iLeftOffset * 2, vbPixels, vbTwips)
        End If
    Else
        If Not m_iButtonHeight = 0 Then
            UserControl.Height = ScaleY(m_iButtonHeight + m_iTopOffset * 2, vbPixels, vbTwips)
        End If
    End If
'   *****

    s_bSkip = False ' reset the flag
        
    Paint
End Sub

Private Sub UserControl_Terminate()
'   **************************************************************************
'   * Purpose:  Fired when the control is destroyed gracefully. Doesn't
'   *               occur when the user hits Stop or end. Releases all objects.
'   *               and cleans up.
'   **************************************************************************

    On Error Resume Next
    Set m_CToolTips = Nothing
    Set m_oActiveButton = Nothing
    m_oLargeImages.Clear
    Set m_oLargeImages = Nothing
    m_oSmallImages.Clear
    Set m_oSmallImages = Nothing
'   ***** Ver 1.0a. Changed to use removeall to stop exceptions in VC++
    m_oButtons.RemoveAll
'    m_oButtons.Clear
'   *****
    Set m_oButtons = Nothing
    Set m_CDrawRect = Nothing
    Set m_CPaint = Nothing
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
'   **************************************************************************
'   * Purpose:  Fired at designtime when properties have been changed.
'   *               Saves the properties in the property bag.
'   **************************************************************************

    On Error Resume Next
    
    Call PropBag.WriteProperty("Align", Extender.Align, vbAlignTop)
    Call PropBag.WriteProperty("Appearance", m_eAppearance, m_def_Appearance)
    Call PropBag.WriteProperty("BorderStyle", m_eBorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", UserControl.Font)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, m_def_BackColor)
    Call PropBag.WriteProperty("MaskColor", m_oLargeImages.MaskColor, m_def_MaskColor)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, m_def_MousePointer)
    Call PropBag.WriteProperty("OLEDropMode", UserControl.OLEDropMode, m_def_OLEDropMode)
    Call PropBag.WriteProperty("ButtonHeight", m_iButtonHeight, m_def_ButtonHeight)
    Call PropBag.WriteProperty("ButtonWidth", m_iButtonWidth, m_def_ButtonWidth)
    Call PropBag.WriteProperty("ToolTips", m_CToolTips.ToolTips, m_def_ToolTips)
    Call PropBag.WriteProperty("ToolTipsDelay", tmrTimer.Interval, m_def_ToolTipsDelay)
    Call PropBag.WriteProperty("UseMaskColor", m_oLargeImages.UseMaskColor, True)
    Call PropBag.WriteProperty("WhatsThisHelpID", m_lWhatsThisHelpID, m_def_WhatsThisHelpID)
    Call PropBag.WriteProperty("View", m_eView, gtSmallPicture)
    Call PropBag.WriteProperty("ButtonType", m_eButtonType, gtImagesOnly)
    
    Call PropBag.WriteProperty("LargeImagesWidth", m_oLargeImages.Width, 32)
    Call PropBag.WriteProperty("LargeImagesHeight", m_oLargeImages.Height, 32)
    Call PropBag.WriteProperty("SmallImagesWidth", m_oSmallImages.Width, 16)
    Call PropBag.WriteProperty("SmallImagesHeight", m_oSmallImages.Height, 16)
    
'   ***** Write the value for the collections when changed thru the prop pages
    m_oLargeImages.WriteObjectProps PropBag, "LargeImages"
    m_oSmallImages.WriteObjectProps PropBag, "SmallImages"
    m_oButtons.WriteObjectProps PropBag
'   *****
End Sub

Private Sub CalcOffset()
'   *********************************************************************************
'   * Purpose:  Calculates how far left and from the top to start the drawing
'   *               of the objects. This is calculated by the value of the Appearance
'   *               and BorderStyle properties.
'   *********************************************************************************
    Dim iOffset As Integer
    
    If m_eBorderStyle = gtFixedSingle And m_eAppearance = gt3D Then
        m_iLeftOffset = 2
        m_iTopOffset = 2
    ElseIf m_eBorderStyle = gtFixedSingle Then
        m_iLeftOffset = 2
        m_iTopOffset = 2
    Else
        m_iLeftOffset = 1
        m_iTopOffset = 1
    End If
    
'   ***** Pass the value to the collections
    m_oButtons.LeftOffset = m_iLeftOffset
    m_oButtons.TopOffset = m_iTopOffset
    m_oLargeImages.TopOffset = m_iTopOffset
    m_oSmallImages.TopOffset = m_iTopOffset
'   *****
End Sub
Private Sub CalculateScaleUnits()
'   *********************************************************************************
'   * Purpose:  Calculates the number of scale units per pixel because all
'   *               drawing is based on pixels. This allows the values to be returned
'   *               in the Scale that user is expecting. This is based on the ScaleMode
'   *               of the container.
'   *********************************************************************************
    Dim iScalePerPixel As Integer
    
    Select Case Ambient.ScaleUnits
        Case "Twip":
            iScalePerPixel = ScaleX(1, vbPixels, vbTwips)
        Case "Pixel":
            iScalePerPixel = 1
        Case "Inch":
            iScalePerPixel = ScaleX(1, vbPixels, vbInches)
        Case "User":
            iScalePerPixel = 1 ' not supported at this time
'            iScalePerPixel = ScaleX(1, vbPixels, vbUser)
        Case "Point":
            iScalePerPixel = ScaleX(1, vbPixels, vbPoints)
        Case "Millimeter":
            iScalePerPixel = ScaleX(1, vbPixels, vbMillimeters)
        Case "Centimeter":
            iScalePerPixel = ScaleX(1, vbPixels, vbCentimeters)
    End Select
    
    m_iScalePerPixel = iScalePerPixel
    
'   ***** the images collections need the number of himetrics units per pixel
    m_oLargeImages.HiMetricPerPixel = ScaleX(1, vbPixels, vbHimetric)
    m_oSmallImages.HiMetricPerPixel = ScaleX(1, vbPixels, vbHimetric)
'   *****
End Sub

Private Sub Paint(Optional oButton As GTButton = Nothing)
'   *********************************************************************************
'   * Params:   oButton: Optional: the button to redraw so the whole toolbar
'   *               isn't redrawn.
'   * Purpose:  Creates the memory dc to draw the toolbar on or retrieves the
'   *               handle to it. If the param is nothing, the whole toolbar is redrawn.
'   *               If the param is passed, only the button is redrawn.The bitmap is
'   *               blitted to the user control when the drawing is complete.
'   *********************************************************************************
    
    Dim hDCMem As Long
    
    If Not m_bRedraw Or m_bDontPaint Then
        Exit Sub
    End If
    
'   ***** If obutton is nothing, redraw all buttons, otherwise just redraw the button
    If oButton Is Nothing Then
        hDCMem = m_CPaint.GetMemDC(UserControl.hdc, ScaleWidth, ScaleHeight)
        m_CPaint.DrawBackground hDCMem, 0, 0, ScaleWidth, ScaleHeight, UserControl.BackColor
        DrawAllButtons hDCMem
        DrawBorder hDCMem
    Else
        hDCMem = m_CPaint.hDCMem
        DrawButton hDCMem, oButton
    End If
'   *****

    m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight ' blit the image to the usercontrol
    
    RefreshGraphicalControls
End Sub

Private Sub DrawBorder(hdc As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on.
'   * Purpose:  Draws the border based on the Appearance and BorderStyle
'   *               properties.
'   *********************************************************************************
    If m_eAppearance = gt3D And m_eBorderStyle = gtFixedSingle Then
        m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, ToolbarActive
    ElseIf m_eBorderStyle = gtFixedSingle Then
        m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, FixedSingle
    End If
End Sub

Private Sub SetButtonDimensions(Optional ByVal iWidth As Integer, Optional ByVal iHeight As Integer)
'   *********************************************************************************
'   * Params:   iWidth: Optional: The width of the buttons, iHeight: Optional:
'   *               the height of the buttons
'   * Purpose:  Creates the buttonheight and buttonwidth depending on the
'   *               View and ButtonType properties and the size of the images. If
'   *               the height or width if less than the default, the height or width
'   *               is set to the default.
'   *********************************************************************************
    Dim iTempHeight As Integer
    Dim iTempWidth As Integer
    Dim iButtonHeight As Integer
    Dim iButtonWidth As Integer
    
'   ***** Holds the height of the images collection based on the view
    Select Case m_eView
        Case gtLargePicture
            iTempHeight = m_oLargeImages.Height
            iTempWidth = m_oLargeImages.Width
        Case gtSmallPicture
            iTempHeight = m_oSmallImages.Height
            iTempWidth = m_oSmallImages.Width
    End Select
'   *****

'   ***** If the images height or width is 0 , use the buttonwidth
'   ***** and height.
    If iTempWidth = 0 Then
        iTempWidth = iButtonWidth
    End If
    
    If iTempHeight = 0 Then
        iTempHeight = iButtonHeight
    End If
'   *****

'   ***** Set the buttonheight and buttonwidth depending on what
'   ***** is showing in the buttons
    Select Case m_eButtonType
        Case gtTextandImages
            iButtonHeight = iTempHeight + m_iTextHeight + BUTTON_ADDON
            If iTempWidth > m_lMaxTextLength Then
                iButtonWidth = iTempWidth + BUTTON_ADDON
            Else
                iButtonWidth = m_lMaxTextLength + BUTTON_ADDON
            End If
        
        Case gtImagesOnly
            Select Case m_eView
                Case gtLargePicture
                    iButtonHeight = iTempHeight + BUTTON_ADDON
                    iButtonWidth = iTempWidth + BUTTON_ADDON
                Case gtSmallPicture
                    iButtonHeight = iTempHeight + BUTTON_ADDON
                    iButtonWidth = iTempWidth + BUTTON_ADDON
            End Select
            
        Case gtTextOnly
            iButtonHeight = m_iTextHeight + BUTTON_ADDON
            iButtonWidth = m_lMaxTextLength + BUTTON_ADDON
            
    End Select
'   *****

'   ***** Determine the height of the buttons when the new height
'   ***** is less than the default
    If m_oButtons.Count = 0 Then
        If iButtonHeight > m_def_ButtonHeight Then
            m_iButtonHeight = iButtonHeight
        ElseIf m_iButtonHeight < m_def_ButtonHeight Then
            m_iButtonHeight = m_def_ButtonHeight
        End If
    ElseIf m_iButtonHeight < m_def_ButtonHeight Then
        m_iButtonHeight = m_def_ButtonHeight
    ElseIf iButtonHeight > m_iButtonHeight Then
        m_iButtonHeight = iButtonHeight
    End If
'   *****

'   ***** Determine the width of the buttons when the new width
'   ***** is less than the default
    If m_oButtons.Count = 0 Then
        If iButtonWidth > m_def_ButtonWidth Then
            m_iButtonWidth = iButtonWidth
        ElseIf m_iButtonWidth < m_def_ButtonWidth Then
            m_iButtonWidth = m_def_ButtonWidth
        End If
    ElseIf m_iButtonWidth < m_def_ButtonWidth Then
        m_iButtonWidth = m_def_ButtonWidth
    ElseIf iButtonWidth > m_iButtonWidth Then
        m_iButtonWidth = iButtonWidth
    End If
'   *****

'   ***** pass the new button width and height the buttons collection
    m_oButtons.ButtonHeight = m_iButtonHeight
    m_oButtons.ButtonWidth = m_iButtonWidth
'   *****

    UserControl_Resize
End Sub
Private Sub SetTextHeight()
'   *********************************************************************************
'   * Purpose:  Sets the text height based on the font in the user control.
'   *********************************************************************************
    m_iTextHeight = TextHeight("O")
End Sub

Private Sub DrawAllButtons(hdc As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on
'   * Purpose:  Loops thru the Buttons collection and draws the visible
'   *               buttons.
'   *********************************************************************************
    Dim oButton As GTButton
    Dim lStart As Long
    Dim lTop As Long
    
    On Error Resume Next
    
    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
        lStart = m_iTopOffset
    Else
        lStart = m_iLeftOffset
    End If
    If Err Then
        lStart = m_iLeftOffset
    End If
    
    For Each oButton In m_oButtons
    
        If oButton.Visible Then
            DrawButton hdc, oButton, lStart, True
        End If
        
    Next
    
End Sub

Private Sub DrawDefaultButton(hdc As Long, ByVal oButton As GTButton, ByVal lStart As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on, oButton: the button to be drawm, lStart:
'   *               the left of the button rect.
'   * Purpose: Draws the button based on the View, and the Active, Down, and
'   *               Value properties of the Button. Also determines the orientation.
'   *********************************************************************************
    Dim fTempLeft As Single
    Dim fTempTop As Single
    Dim lImageWidth As Long
    Dim lImageHeight As Long
    Dim fTempButtonLeft As Single
    Dim fTempButtonTop As Single
    Dim CTransBlt As CTransBlt
    
    On Error Resume Next
    
'   ***** determines where to start the drawing when
    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
        fTempLeft = CSng(m_iLeftOffset)
        fTempTop = CSng(lStart)
    Else
        fTempLeft = CSng(lStart)
        fTempTop = CSng(m_iTopOffset)
    End If
'   *****

'   ***** Holds the image width and height based on the view
    If m_eView = gtLargePicture Then
        lImageWidth = m_oLargeImages.Width
        lImageHeight = m_oLargeImages.Height
    Else
        lImageWidth = m_oSmallImages.Width
        lImageHeight = m_oSmallImages.Height
    End If
    
    If m_eButtonType = gtTextandImages Then
        lImageHeight = lImageHeight + m_iTextHeight + 1
    End If
'   *****
    
'   ***** When the button is active and value is pressed hold
'   ***** the starting positions
    If Not oButton.Active And oButton.Value = gtPressed Then
        fTempButtonLeft = fTempLeft
        fTempButtonTop = fTempTop
    End If
'   *****

'   ***** Want to center the picture in the button
    fTempLeft = fTempLeft + (m_iButtonWidth \ 2 - lImageWidth \ 2)
    fTempTop = fTempTop + (m_iButtonHeight \ 2 - lImageHeight \ 2)
'   *****

'   ***** want the images down and over 1 when the button is down
    If oButton.Down Or oButton.Value = gtPressed Then
        fTempLeft = fTempLeft + 1
        fTempTop = fTempTop + 1
    End If
'   *****

'   ***** Draws the buttons based on the view. If the value is pressed, the
'   ***** dithered background is drawn first and then the picture is drawn
'   ***** enabled or disabled
    Select Case m_eView
        Case gtLargePicture:
            If IsNumeric(oButton.LargePicture) Then
                If oButton.LargePicture = 0 And Not oButton.Active And oButton.Value = gtPressed Then
                    Set CTransBlt = New CTransBlt
                    CTransBlt.DrawDitheredBackground hdc, 0, 0, CLng(fTempButtonLeft), CLng(fTempButtonTop), CLng(m_iButtonWidth), CLng(m_iButtonHeight), GetBkColor(UserControl.hdc)
                    Set CTransBlt = Nothing
                    
                ElseIf Not oButton.LargePicture = 0 Then
                    If Not oButton.Active And oButton.Value = gtPressed Then
                        m_oLargeImages(oButton.LargePicture).DrawPicture hdc, fTempButtonLeft, fTempButtonTop, CLng(m_iButtonWidth), CLng(m_iButtonHeight), gtDitheredBackground
                    End If
                    
                    If Not oButton.Enabled Or (Not UserControl.Enabled And Ambient.UserMode) Then
                        m_oLargeImages(oButton.LargePicture).DrawPicture hdc, fTempLeft, fTempTop, , , gtDisabled
                    Else
                        m_oLargeImages(oButton.LargePicture).DrawPicture hdc, fTempLeft, fTempTop, , , gtTransparent
                    End If
                    
                End If
            ElseIf Not (oButton.LargePicture = "") Then
                If Not oButton.Active And oButton.Value = gtPressed Then
                        m_oLargeImages(oButton.LargePicture).DrawPicture hdc, fTempButtonLeft, fTempButtonTop, CLng(m_iButtonWidth), CLng(m_iButtonHeight), gtDitheredBackground
                End If
                
'   *****   if the button is diabled, or the control is disabled, draw the buttons disabled
                If Not oButton.Enabled Or (Not UserControl.Enabled And Ambient.UserMode) Then
                    m_oLargeImages(oButton.LargePicture).DrawPicture hdc, fTempLeft, fTempTop, , , gtDisabled
                Else
                    m_oLargeImages(oButton.LargePicture).DrawPicture hdc, fTempLeft, fTempTop, , , gtTransparent
                End If
'   ****
            End If
            
        Case gtSmallPicture:
            If IsNumeric(oButton.SmallPicture) Then
                If oButton.SmallPicture = 0 And Not oButton.Active And oButton.Value = gtPressed Then
                    Set CTransBlt = New CTransBlt
                    CTransBlt.DrawDitheredBackground hdc, 0, 0, CLng(fTempButtonLeft), CLng(fTempButtonTop), CLng(m_iButtonWidth), CLng(m_iButtonHeight), GetBkColor(UserControl.hdc)
                    Set CTransBlt = Nothing
                
                ElseIf Not oButton.SmallPicture = 0 Then
                    If Not oButton.Active And oButton.Value = gtPressed Then
                            m_oSmallImages(oButton.SmallPicture).DrawPicture hdc, fTempButtonLeft, fTempButtonTop, CLng(m_iButtonWidth), CLng(m_iButtonHeight), gtDitheredBackground
                    End If
                    
                    If Not oButton.Enabled Or (Not UserControl.Enabled And Ambient.UserMode) Then
                        m_oSmallImages(oButton.SmallPicture).DrawPicture hdc, fTempLeft, fTempTop, , , gtDisabled
                    Else
                        m_oSmallImages(oButton.SmallPicture).DrawPicture hdc, fTempLeft, fTempTop, , , gtTransparent
                    End If
                    
                End If
            ElseIf Not (oButton.SmallPicture = "") Then
                If Not oButton.Active And oButton.Value = gtPressed Then
                        m_oSmallImages(oButton.SmallPicture).DrawPicture hdc, fTempButtonLeft, fTempButtonTop, CLng(m_iButtonWidth), CLng(m_iButtonHeight), gtDitheredBackground
                End If
                
'   *****   if the button is diabled, or the control is disabled, draw the buttons disabled
                If Not oButton.Enabled Or (Not UserControl.Enabled And Ambient.UserMode) Then
                    m_oSmallImages(oButton.SmallPicture).DrawPicture hdc, fTempLeft, fTempTop, , , gtDisabled
                Else
                    m_oSmallImages(oButton.SmallPicture).DrawPicture hdc, fTempLeft, fTempTop, , , gtTransparent
                End If
'   *****
            End If
    End Select
'   *****

End Sub
Private Sub DrawSeparator(hdc As Long, ByVal oButton As GTButton, ByVal lStart As Long)
'   *********************************************************************************
'   * Params:   oButton: the button to draw, lStart the left or top postion to
'   *               start the drawing
'   * Purpose:  Draws a separator (2 lines looking inset). Used to separate
'   *               buttons
'   *********************************************************************************
    
    Dim lTempLeft As Long
    Dim lTempTop As Long
    
    On Error Resume Next ' ver 1.0a Skips extender error when extender object isn't available

'   ***** based on the orientation draw the separator lines
    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
        lTempLeft = m_iLeftOffset - 2
        lTempTop = lStart + BUTTON_SEPARATORWIDTH / 3
        
        m_CDrawRect.Draw3DRect hdc, lTempLeft, lTempTop, CLng(ScaleWidth - m_iLeftOffset), 0&, ToolbarSeparatorH
        
    Else
        lTempLeft = lStart + BUTTON_SEPARATORWIDTH / 3
        lTempTop = m_iTopOffset - 2
        
        m_CDrawRect.Draw3DRect hdc, lTempLeft, lTempTop, 0&, CLng(ScaleHeight - m_iTopOffset), ToolbarSeparatorV
        
    End If
'   *****

End Sub

Private Sub SetMaxTextLength()
'   *********************************************************************************
'   * Purpose:  Finds the button with the longest caption. This is used to
'   *               set the button width when the ButtonType property is pictures and
'   *               text or Text Only.
'   *********************************************************************************
    Dim oButton As GTButton
    Dim lMaxLength As Long
    Dim lTempLength As Long
    
    For Each oButton In m_oButtons
        lTempLength = TextWidth(oButton.Caption)
        
        If lTempLength > lMaxLength Then
            lMaxLength = lTempLength
        End If
        
    Next
    
    m_lMaxTextLength = lMaxLength
    
    SetButtonDimensions ' m_iButtonWidth, m_iButtonHeight
End Sub

Private Sub DrawButtonText(hdc As Long, oButton As GTButton, lStart As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on, oButton: the button to draw the text for,
'   *               lStart: the left of the button rect.
'   * Purpose:  Draws the text on the button, enabled or disabled. Will also draw the dithered background
'   *               for buttons in the down position.
'   *********************************************************************************
    Dim lImageHeight As Long
    Dim rectButton As RECT
    Dim oFont As StdFont
    Dim CTransBlt As CTransBlt
    
    On Error Resume Next ' ver 1.0a Skips extender error when extender object isn't available

'   ***** Get the image height if there will be an image
'   ***** in addition to the text
    If m_eButtonType = gtTextandImages Then
        If m_eView = gtLargePicture Then
            lImageHeight = m_oLargeImages.Height
        Else
            lImageHeight = m_oSmallImages.Height
        End If
    End If
'   *****

'   ***** Draws the image if there is an associated image or a ditherbackground if the value is
'   ***** pressed and no image
    If Not oButton.Active And oButton.Value = gtPressed And m_eButtonType = gtTextOnly Then
        If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
            rectButton.Left = m_iLeftOffset
            rectButton.Top = lStart
        Else
            rectButton.Left = lStart
            rectButton.Top = m_iTopOffset
        End If
        If m_eView = gtLargePicture Then
            If oButton.LargePicture = 0 And Not oButton.Active And oButton.Value = gtPressed Then
                Set CTransBlt = New CTransBlt
                CTransBlt.DrawDitheredBackground hdc, 0, 0, rectButton.Left, rectButton.Top, CLng(m_iButtonWidth), CLng(m_iButtonHeight), GetBkColor(UserControl.hdc)
                Set CTransBlt = Nothing
            ElseIf Not oButton.LargePicture = 0 Then
                m_oLargeImages(oButton.LargePicture).DrawPicture hdc, CSng(rectButton.Left), CSng(rectButton.Top), CLng(m_iButtonWidth), CLng(m_iButtonHeight), gtDitheredBackground
            End If
        Else
            If oButton.SmallPicture = 0 And Not oButton.Active And oButton.Value = gtPressed Then
                Set CTransBlt = New CTransBlt
                CTransBlt.DrawDitheredBackground hdc, 0, 0, rectButton.Left, rectButton.Top, CLng(m_iButtonWidth), CLng(m_iButtonHeight), GetBkColor(UserControl.hdc)
                Set CTransBlt = Nothing
            ElseIf Not oButton.SmallPicture = 0 Then
                m_oSmallImages(oButton.SmallPicture).DrawPicture hdc, CSng(rectButton.Left), CSng(rectButton.Top), CLng(m_iButtonWidth), CLng(m_iButtonHeight), gtDitheredBackground
            End If
        End If
    End If
'   *****

    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
        rectButton.Left = m_iLeftOffset
        rectButton.Top = lStart + (m_iButtonHeight - m_iTextHeight - BUTTON_ADDON / 2)
    Else
        rectButton.Left = lStart
        rectButton.Top = m_iTopOffset + lImageHeight + BUTTON_ADDON / 2 + 1
    End If
    
    rectButton.Bottom = rectButton.Top + m_iTextHeight
    rectButton.Right = rectButton.Left + m_iButtonWidth
    
    If oButton.Down Or oButton.Value = gtPressed Then
        rectButton.Right = rectButton.Right + 2
        rectButton.Top = rectButton.Top + 1
    End If
    
    Set oFont = UserControl.Font
    
'   ***** Draws the text in the forecolor when enabled or draws the text twice (shadow and highlight)
'   ***** when disabled
    If oButton.Enabled And UserControl.Enabled Then
        m_CPaint.PaintText oButton.Caption, oFont.Name, rectButton.Left, rectButton.Top, rectButton.Right, rectButton.Bottom, _
                                    TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, , oFont.Bold, oFont.Italic, _
                                    oFont.Strikethrough, oFont.Underline, GetBkColor(UserControl.hdc), GetTextColor(UserControl.hdc)
    Else
        rectButton.Right = rectButton.Right + 1
        rectButton.Top = rectButton.Top + 1
        m_CPaint.PaintText oButton.Caption, oFont.Name, rectButton.Left, rectButton.Top, rectButton.Right, rectButton.Bottom, _
                                    TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, , oFont.Bold, oFont.Italic, _
                                    oFont.Strikethrough, oFont.Underline, GetBkColor(UserControl.hdc), GetSysColor(COLOR_BTNHIGHLIGHT)
        
        rectButton.Right = rectButton.Right - 2
        rectButton.Top = rectButton.Top - 1
        m_CPaint.PaintText oButton.Caption, oFont.Name, rectButton.Left, rectButton.Top, rectButton.Right, rectButton.Bottom, _
                                    TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, , oFont.Bold, oFont.Italic, _
                                    oFont.Strikethrough, oFont.Underline, GetBkColor(UserControl.hdc), GetSysColor(COLOR_BTNSHADOW)
    End If
'   *****
End Sub
Private Sub DrawButton(hdc As Long, oButton As GTButton, Optional lStart As Long = 0, Optional bDrawAll As Boolean = False)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on, oButton: the button to draw, lStart:
'   *               the left of the button rect, bDrawAll: Optional: whether one button
'   *               is being drawn or all.
'   * Purpose:  Draws the button w/ text depending on the ButtonStyle property.
'   *               Will initialize the button area if bDrawAll is False. Also draws the
'   *               active rect if the button is active.
'   *********************************************************************************
    Dim lStartDraw As Long
    Dim lLeft As Long
    Dim lTop As Long
    
    If Not bDrawAll Then
'   ***** gets where to start drawing the button when only one button is to be drawn
        If Not oButton.Visible Then
            Exit Sub
        End If

        lStartDraw = GetButtonStart(oButton)

        On Error Resume Next

        If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
            lTop = lStartDraw
            lLeft = m_iLeftOffset
        Else
            lLeft = lStartDraw
            lTop = m_iTopOffset
        End If

        If Err Then
            lLeft = lStartDraw
            lTop = m_iTopOffset
        End If

        m_CPaint.DrawBackground hdc, lLeft, lTop, CLng(m_iButtonWidth), CLng(m_iButtonHeight), UserControl.BackColor
'   *****
    Else
        lStartDraw = lStart
    End If
    
'   ***** Draws the button based on the button's style and the buttontype property
    Select Case oButton.Style
        Case gtDefault, gtToggle, gtGroup, gtGroupToggle
            
            Select Case m_eButtonType
                Case gtTextandImages
                    DrawDefaultButton hdc, oButton, lStartDraw
                    DrawButtonText hdc, oButton, lStartDraw
                    
                Case gtImagesOnly
                    DrawDefaultButton hdc, oButton, lStartDraw
                
                Case gtTextOnly
                    DrawButtonText hdc, oButton, lStartDraw
                
            End Select
        
            If oButton.Active Or oButton.Value = gtPressed Then
                DrawActiveRect hdc, oButton, lStartDraw
            End If
                    
            If bDrawAll Then
                If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                    lStartDraw = lStartDraw + m_iButtonHeight
                Else
                    lStartDraw = lStartDraw + m_iButtonWidth
                End If
            End If
            
        Case gtSeparator
            DrawSeparator hdc, oButton, lStartDraw
            
            If bDrawAll Then
                    lStartDraw = lStartDraw + BUTTON_SEPARATORWIDTH
            End If
            
        Case gtPlaceHolder
            
            If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                DrawDefaultButton hdc, oButton, lStartDraw
                
                If oButton.Active Then
                    DrawActiveRect hdc, oButton, lStartDraw
                End If
                
                If bDrawAll Then
                    lStartDraw = lStartDraw + m_iButtonHeight
                End If
            Else
                If bDrawAll Then
                    lStartDraw = lStartDraw + oButton.InternalWidth
                End If
            End If
    
    End Select
'   ****

    If bDrawAll Then
        lStart = lStartDraw
    End If
    
End Sub

Private Function GetButtonStart(ByVal oTargetButton As GTButton) As Long
'   *********************************************************************************
'   * Params:   oTargetButton: the button to get the left or top for, depending on
'   *               the orientation.
'   * Purpose:  Loops thru the button collection adding the button widths to
'   *               get the starting point for the target button.
'   *********************************************************************************
    Dim lStart As Long
    Dim oButton As GTButton
    
    On Error Resume Next
    
    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
        lStart = m_iTopOffset
    Else
        lStart = m_iLeftOffset
    End If
    
    If Err Then
        lStart = m_iLeftOffset
    End If
    
    For Each oButton In m_oButtons
        
        If oButton.Visible Then
            
            If oButton Is oTargetButton Then
                GetButtonStart = lStart
                Exit Function
            End If
            
            Select Case oButton.Style
                Case gtDefault, gtToggle, gtGroup, gtGroupToggle
                    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                        lStart = lStart + m_iButtonHeight
                    Else
                        lStart = lStart + m_iButtonWidth
                    End If
                    
                Case gtSeparator
                    lStart = lStart + BUTTON_SEPARATORWIDTH
                    
                Case gtPlaceHolder
                    
                    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                        lStart = lStart + m_iButtonHeight
                    Else
                        lStart = lStart + oButton.InternalWidth
                    End If
            
            End Select

        End If
        
    Next
    
    GetButtonStart = lStart

End Function
Private Function ButtonHitTest(x As Single, y As Single) As GTButton
'   *********************************************************************************
'   * Params:   X: the left of the point to find, Y: the top of the point to find.
'   * Return:   GTButton: the button that was found at the X,Y point; Nothing if
'   *               no button was found.
'   * Purpose:  Finds the button at the X,Y point and returns it.Loops thru the
'   *               collection checking and added the button widths, heights, etc
'   *               depending on the orientation.
'   *********************************************************************************
    Dim lStart As Long
    Dim oButton As GTButton
    Dim lLeft As Long
    Dim lTop As Long
    Dim lWidth As Long
    Dim lHeight As Long
    
    On Error Resume Next ' ver 1.0a Skips extender error when extender object isn't available
    
    lLeft = m_iLeftOffset
    lTop = m_iTopOffset
    
    For Each oButton In m_oButtons
        
        If oButton.Visible Then
        
'   ***** Gets the width and height of the button depending on the button's style
            Select Case oButton.Style
                Case gtDefault, gtToggle, gtGroup, gtGroupToggle
                    lHeight = m_iButtonHeight
                    lWidth = m_iButtonWidth
                    
                Case gtSeparator
                    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                        lHeight = BUTTON_SEPARATORWIDTH
                        lWidth = m_iButtonWidth
                    Else
                        lWidth = BUTTON_SEPARATORWIDTH
                        lHeight = m_iButtonHeight
                    End If
                    
                Case gtPlaceHolder
                    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                        lHeight = m_iButtonHeight
                        lWidth = m_iButtonWidth
                    Else
                        lWidth = oButton.InternalWidth
                        lHeight = m_iButtonHeight
                    End If
            
            End Select
'   *****
            If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                If lTop <= y And y <= lTop + lHeight Then
                    If lLeft < x And x < lLeft + lWidth Then
                        Set ButtonHitTest = oButton
                        Exit Function
                    End If
                End If
            Else
                If lLeft <= x And x <= lLeft + lWidth Then
                    If lTop < y And y < lTop + lHeight Then
                        Set ButtonHitTest = oButton
                        Exit Function
                    End If
                End If
            End If
            
'   ***** Adds the top or left and width or height depending on the orientation
            Select Case oButton.Style
                Case gtDefault, gtToggle, gtGroup, gtGroupToggle
                    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                        lTop = lTop + m_iButtonHeight
                    Else
                        lLeft = lLeft + m_iButtonWidth
                    End If
                    
                Case gtSeparator
                    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                        lTop = lTop + BUTTON_SEPARATORWIDTH
                    Else
                        lLeft = lLeft + BUTTON_SEPARATORWIDTH
                    End If
                    
                Case gtPlaceHolder
                    
                    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
                        lTop = lTop + m_iButtonHeight
                    Else
                        lLeft = lLeft + oButton.InternalWidth
                    End If
            
            End Select
'   *****

        End If
        
    Next

End Function
Private Sub DrawActiveRect(hdc As Long, oButton As GTButton, lStart As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on, oButton: the button to draw the rect
'   *               around, the left of the button rect.
'   * Purpose:  Draws a raised rect when the Value of the button is Unpressed
'   *               and the mouse is up, draws an inset rect when the Value of the
'   *               button is Pressed and/or the mouse is down.
'   *********************************************************************************
    Dim lLeft As Long
    Dim lTop As Long
    
    On Error Resume Next ' ver 1.0a Skips extender error when extender object isn't available
    
    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
        lLeft = m_iLeftOffset
        lTop = lStart
    Else
        lLeft = lStart
        lTop = m_iTopOffset
    End If
    
    If oButton.Value = gtPressed Then
        m_CDrawRect.Draw3DRect hdc, lLeft, lTop, CLng(m_iButtonWidth), CLng(m_iButtonHeight), ToolbarActiveDown
    ElseIf oButton.Active Then
        If oButton.Down Then
            m_CDrawRect.Draw3DRect hdc, lLeft, lTop, CLng(m_iButtonWidth), CLng(m_iButtonHeight), ToolbarActiveDown
        Else
            m_CDrawRect.Draw3DRect hdc, lLeft, lTop, CLng(m_iButtonWidth), CLng(m_iButtonHeight), ToolbarActive
        End If
    End If
    
End Sub

Private Function CaptureMouse(x As Single, y As Single, iButton As Integer, Optional bRelease As Boolean = False) As Boolean
'   *********************************************************************************
'   * Params:   X: the left point, Y: the top point, iButton: the button on the mouse
'   *               that is down, bRelease: Optional: if the mouse is to be released
'   *               regardless of the whether the mouse is over the control or not
'   *               (used when the mouse is released off the control).
'   * Return:   Boolean: True if successful, False if not.
'   * Purpose: Captures the mouse when moved over the user control, releases
'   *               the capture when moved off the control or over a contained control.
'   *               Also turns off tooltips. Capturing is necessary because otherwise
'   *               don't know the mouse if off the control (if the mouse isn't down), and
'   *               active buttons would still be active even when they shouldn't be.
'   *********************************************************************************
    Static s_bCaptured As Boolean
    Dim lRet As Long
    Dim lWidth As Long
    Dim lHeight As Long
    Dim oButton As GTButton
    
    On Error Resume Next ' ver 1.0a Skips extender error when extender object isn't available
    
    If Not s_bCaptured Then
        SetCapture UserControl.hWnd
        s_bCaptured = True
        
    ElseIf bRelease Then ' force to release
        s_bCaptured = False ' reset flag
        
        ActivateTopWindow
        
    ElseIf s_bCaptured Then  ' check to see if moved off the control
        
        If x >= 0 And y >= 0 And x <= ScaleWidth And y <= ScaleHeight Or iButton Then
            ' within control
            If Not IsUserControl(x, y) Then
                ReleaseCapture
                s_bCaptured = False ' reset flag
                m_CToolTips.HideToolTip
                Exit Function
            End If
            
            Set oButton = ButtonHitTest(x, y)
            If Not oButton Is Nothing Then
                If oButton.Style = gtPlaceHolder And Not (Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight) Then
                    ReleaseCapture
                    s_bCaptured = False ' reset flag
                End If
            End If
        Else
            ReleaseCapture
            s_bCaptured = False ' reset flag
            m_CToolTips.HideToolTip
        End If
        
    End If
    
    CaptureMouse = s_bCaptured
End Function
Private Sub SetGroupValues(oButton As GTButton)
'   *********************************************************************************
'   * Params:   oButton: the button that the value was changed on.
'   * Purpose:  Sets the values of a the buttons within a button group. Button
'   *               groups are when a group of buttons have the Style of gtGroup or
'   *               gtGroupToggle. A group is started or broken by buttons of other
'   *               styles. Here, the buttons are iterated backward from the param
'   *               button to find the first non-group button. When found, the buttons
'   *               are iterated forward from the param button to find the first non-
'   *               group button. When found, the group is gone thru to reset the
'   *               value of the button that currently has a value of pressed and
'   *               set the value of the param button to pressed. Grouptoggle buttons
'   *               can also have all buttons in the unpressed state, while group buttons
'   *               must have 1 button with the pressed state.
'   *********************************************************************************
    Dim i As Long
    Dim lFirstButton As Long
    Dim lLastButton As Long
    
'   ***** Finds the first button ot the left that isn't the same style
    For i = oButton.Index To 1 Step -1
        Select Case m_oButtons(i).Style
            Case gtGroup, gtGroupToggle
            
            Case Else
                lFirstButton = m_oButtons(i).Index + 1
                Exit For
        
        End Select
    Next
'   *****
'   ***** Finds the first button ot the right that isn't the same style
    For i = oButton.Index To m_oButtons.Count
        Select Case m_oButtons(i).Style
            Case gtGroup, gtGroupToggle
            
            Case Else
                lLastButton = m_oButtons(i).Index - 1
                Exit For
        
        End Select
    Next
'   *****

'   ***** If the param is the first or last button set the
'   ***** appriate to property to the correct index
    If lFirstButton = 0 Then
        lFirstButton = m_oButtons(1).Index
    End If
    
    If lLastButton = 0 Then
        lLastButton = m_oButtons(m_oButtons.Count).Index
    End If
'   *****

'   ***** Resets the value to pressed for all buttons
    For i = lFirstButton To lLastButton
        If m_oButtons(i).Value = gtPressed Then
            m_oButtons(i).Value = gtUnpressed
'   ***** If a grouptoggle button and the param button is found, exit because
'   ***** there is group toggle buttons can have all buttons in the up position
            If m_oButtons(i) Is oButton And oButton.Style = gtGroupToggle Then
                Exit Sub
            End If
'   *****
            Exit For
        End If
    Next
'   *****

'   ***** Sets the param to pressed
    oButton.Value = gtPressed
'   *****

End Sub

Private Function IsUserControl(x As Single, y As Single) As Boolean
'   *********************************************************************************
'   * Params:   X: the left point, Y: the top point
'   * Return:   Boolean: whether or not the window under the point is a usercontrol.
'   * Purpose:  Gets the window from point and gets the classname of that
'   *               window. The return value is based on the classname being of
'   *               a user control ("ThunderUserControl" or "ThunderRT5UserControl")
'   *********************************************************************************
    Dim pt As POINTAPI
    Dim hWnd As Long
    Dim lRet As Long
    Dim sClassName As String
    
    sClassName = Space(256)
    
    pt.x = CLng(x)
    pt.y = CLng(y)
    
    ClientToScreen UserControl.hWnd, pt
    
    hWnd = WindowFromPoint(pt.x, pt.y)
    
    lRet = GetClassName(hWnd, sClassName, Len(sClassName))
    
    IsUserControl = (StrComp(Left$(sClassName, lRet), "ThunderUserControl", vbTextCompare) = 0 Or StrComp(Left$(sClassName, lRet), "ThunderRT5UserControl", vbTextCompare) = 0)
    
End Function

Private Sub RefreshGraphicalControls()
'   ***********************************************************************
'   * Purpose:  Loops thru the contained controls collection and
'   *               finds the controls without hwnd properties. These
'   *               controls are then refreshed. This is done because
'   *               graphical controls get painted over when blitting.
'   ***********************************************************************
    Dim cCtl As Control
    Dim hWnd As Long
    If Not m_bRedraw Then
        Exit Sub
    End If
    
    On Error Resume Next
    
    m_bDontPaint = True ' this stops the recursion caused by the refresh
    
'   ***** Looks for controls without hwnd properties. Assumes these
'   ***** are graphical
    For Each cCtl In ContainedControls
        hWnd = cCtl.hWnd
        If Err Then ' control doesn't have an hwnd
            cCtl.Refresh
        End If
    Next
'   *****

    m_bDontPaint = False ' reset the flag

End Sub

Private Function GetTopWindow() As Long
'   ***********************************************************************
'   * Return:   Long: the hwnd of the top level window
'   * Purpose:  Loops backwards thru the parents to get the top
'   *               level window.
'   ***********************************************************************
    Dim obj As Object

    On Error Resume Next

    Set obj = UserControl.Parent

    Do While Not obj Is Nothing
        Set obj = obj.Parent
        If Err Then
            Exit Do
        End If
    Loop

    On Error GoTo 0

    On Error Resume Next

    GetTopWindow = obj.hWnd
    If Err Then
        GetTopWindow = 0
    End If
End Function
Private Sub ActivateTopWindow()
'   ***********************************************************************
'   * Purpose: Gets the top hwnd and compares it to the activewindow.
'   *               If they're different, activate the top level window.
'   ***********************************************************************
    Dim lTopWindow As Long
    
    lTopWindow = GetTopWindow()
    If lTopWindow <> GetActiveWindow() Then
        SetForegroundWindow (lTopWindow)
    End If

End Sub


Private Function IsCursorOverToolbar() As Boolean
'   ***********************************************************************
'   * Return:   Boolean: True if over the toolbar, False if not over
'   *               the toolbar
'   * Purpose: Checks to see if the cursor is over the toolbar
'   ***********************************************************************
    Dim lRet As Long
    Dim pt As POINTAPI
    
    lRet = GetCursorPos(pt)
    
    lRet = ScreenToClient(UserControl.hWnd, pt)
    
    IsCursorOverToolbar = pt.x > 0 And pt.x < ScaleX(UserControl.Width, vbTwips, vbPixels) And pt.y > 0 And pt.y < ScaleY(UserControl.Height, vbTwips, vbPixels)
End Function
